/* HomeTimeline.c generated by valac 0.56.14, the Vala compiler
 * generated from HomeTimeline.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "cawbird.h"
#include <glib.h>
#include "CbUserStream.h"
#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include "CbTweet.h"
#include <gio/gio.h>
#include "CbTypes.h"
#include "CbTweetModel.h"
#include <glib/gi18n-lib.h>
#include "CbMessageReceiver.h"

#define TOP 1

enum  {
	HOME_TIMELINE_0_PROPERTY,
	HOME_TIMELINE_FUNCTION_PROPERTY,
	HOME_TIMELINE_ACCESSIBILITY_NAME_PROPERTY,
	HOME_TIMELINE_NUM_PROPERTIES
};
static GParamSpec* home_timeline_properties[HOME_TIMELINE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _HomeTimelineLoadTweetsFromFollowData HomeTimelineLoadTweetsFromFollowData;

struct _HomeTimelinePrivate {
	gint64 last_tweet_id;
};

struct _HomeTimelineLoadTweetsFromFollowData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	HomeTimeline* self;
	JsonNode* follow_root;
	gint64 follow_id;
	JsonArray* root_array;
	Account* _tmp0_;
	TweetListBox* _tmp1_;
	CbTweetModel* _tmp2_;
	JsonArray* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

static gint HomeTimeline_private_offset;
static gpointer home_timeline_parent_class = NULL;
static CbMessageReceiverInterface * home_timeline_cb_message_receiver_parent_iface = NULL;

static void home_timeline_real_stream_message_received (CbMessageReceiver* base,
                                                 CbStreamMessageType type,
                                                 JsonNode* root);
static void home_timeline_load_tweets_from_follow (HomeTimeline* self,
                                            JsonNode* follow_root,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static void home_timeline_load_tweets_from_follow_finish (HomeTimeline* self,
                                                   GAsyncResult* _res_);
VALA_EXTERN void tweet_utils_set_tweet_hidden_flags (CbTweet* t,
                                         Account* account);
static void _vala_JsonNode_free (JsonNode* self);
static void home_timeline_load_tweets_from_follow_data_free (gpointer _data);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static gboolean home_timeline_load_tweets_from_follow_co (HomeTimelineLoadTweetsFromFollowData* _data_);
VALA_EXTERN void user_utils_load_user_timeline_by_id (Account* account,
                                          gint64 user_id,
                                          gint tweet_count,
                                          gint64 since_id,
                                          gint64 max_id,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
VALA_EXTERN JsonArray* user_utils_load_user_timeline_by_id_finish (GAsyncResult* _res_,
                                                       GError** error);
static void home_timeline_load_tweets_from_follow_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void ___lambda219_ (HomeTimeline* self,
                    JsonArray* array,
                    guint idx,
                    JsonNode* node);
static void ____lambda219__json_array_foreach (JsonArray* array,
                                        guint index_,
                                        JsonNode* element_node,
                                        gpointer self);
static gchar* home_timeline_real_get_title (DefaultTimeline* base);
static void home_timeline_real_create_radio_button (DefaultTimeline* base,
                                             GtkRadioButton* group);
static void home_timeline_finalize (GObject * obj);
static GType home_timeline_get_type_once (void);
static void _vala_home_timeline_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
home_timeline_get_instance_private (HomeTimeline* self)
{
	return G_STRUCT_MEMBER_P (self, HomeTimeline_private_offset);
}

HomeTimeline*
home_timeline_construct (GType object_type,
                         gint id,
                         Account* account)
{
	HomeTimeline * self = NULL;
	TweetListBox* _tmp0_;
#line 33 "../src/HomeTimeline.vala"
	g_return_val_if_fail (account != NULL, NULL);
#line 34 "../src/HomeTimeline.vala"
	self = (HomeTimeline*) default_timeline_construct (object_type, id);
#line 35 "../src/HomeTimeline.vala"
	((DefaultTimeline*) self)->account = account;
#line 36 "../src/HomeTimeline.vala"
	_tmp0_ = ((DefaultTimeline*) self)->tweet_list;
#line 36 "../src/HomeTimeline.vala"
	_tmp0_->account = account;
#line 33 "../src/HomeTimeline.vala"
	return self;
#line 159 "HomeTimeline.c"
}

HomeTimeline*
home_timeline_new (gint id,
                   Account* account)
{
#line 33 "../src/HomeTimeline.vala"
	return home_timeline_construct (TYPE_HOME_TIMELINE, id, account);
#line 168 "HomeTimeline.c"
}

static void
home_timeline_real_stream_message_received (CbMessageReceiver* base,
                                            CbStreamMessageType type,
                                            JsonNode* root)
{
	HomeTimeline * self;
#line 39 "../src/HomeTimeline.vala"
	self = (HomeTimeline*) base;
#line 39 "../src/HomeTimeline.vala"
	g_return_if_fail (root != NULL);
#line 40 "../src/HomeTimeline.vala"
	if (type == CB_STREAM_MESSAGE_TWEET) {
#line 41 "../src/HomeTimeline.vala"
		home_timeline_add_tweet (self, root);
#line 185 "HomeTimeline.c"
	} else {
#line 43 "../src/HomeTimeline.vala"
		if (type == CB_STREAM_MESSAGE_TIMELINE_LOADED) {
#line 44 "../src/HomeTimeline.vala"
			((DefaultTimeline*) self)->preload_is_complete = TRUE;
#line 191 "HomeTimeline.c"
		} else {
#line 46 "../src/HomeTimeline.vala"
			if (type == CB_STREAM_MESSAGE_EVENT_UNFOLLOW) {
#line 47 "../src/HomeTimeline.vala"
				default_timeline_hide_tweets_from ((DefaultTimeline*) self, root, CB_TWEET_STATE_HIDDEN_UNFOLLOWED, 0);
#line 197 "HomeTimeline.c"
			} else {
#line 49 "../src/HomeTimeline.vala"
				if (type == CB_STREAM_MESSAGE_EVENT_FOLLOW) {
#line 50 "../src/HomeTimeline.vala"
					default_timeline_show_tweets_from ((DefaultTimeline*) self, root, CB_TWEET_STATE_HIDDEN_UNFOLLOWED, 0);
#line 51 "../src/HomeTimeline.vala"
					home_timeline_load_tweets_from_follow (self, root, NULL, NULL);
#line 205 "HomeTimeline.c"
				} else {
#line 54 "../src/HomeTimeline.vala"
					DEFAULT_TIMELINE_CLASS (home_timeline_parent_class)->stream_message_received (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DEFAULT_TIMELINE, DefaultTimeline), type, root);
#line 209 "HomeTimeline.c"
				}
			}
		}
	}
}

void
home_timeline_add_tweet (HomeTimeline* self,
                         JsonNode* obj)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	CbTweet* t = NULL;
	CbTweet* _tmp1_;
	CbTweet* _tmp2_;
	Account* _tmp3_;
	GDateTime* _tmp4_;
	CbTweet* _tmp5_;
	CbMiniTweet* _tmp6_;
	CbTweet* _tmp16_;
	Account* _tmp17_;
	gboolean auto_scroll = FALSE;
	gboolean is_new_unread = FALSE;
	gboolean _tmp18_ = FALSE;
	CbTweet* _tmp19_;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	CbTweet* _tmp35_;
	CbMiniTweet _tmp36_;
	CbUserIdentity _tmp37_;
	Account* _tmp38_;
	CbTweet* _tmp55_;
	gboolean _tmp56_ = FALSE;
	TweetListBox* _tmp57_;
	GtkWidget* _tmp58_;
	GtkWidget* _tmp59_;
	gboolean _tmp60_;
	gboolean focused = FALSE;
	gboolean _tmp66_ = FALSE;
	gboolean should_focus = FALSE;
	TweetListBox* _tmp69_;
	CbTweetModel* _tmp70_;
	CbTweet* _tmp71_;
	CbTweet* _tmp72_;
	CbTweet* _tmp83_;
	gboolean _tmp84_ = FALSE;
	gboolean _tmp85_ = FALSE;
	gboolean _tmp86_ = FALSE;
	CbTweet* _tmp87_;
	Account* _tmp88_;
	gint stack_size = 0;
	gboolean _tmp89_ = FALSE;
#line 58 "../src/HomeTimeline.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/HomeTimeline.vala"
	g_return_if_fail (obj != NULL);
#line 59 "../src/HomeTimeline.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 59 "../src/HomeTimeline.vala"
	now = _tmp0_;
#line 60 "../src/HomeTimeline.vala"
	_tmp1_ = cb_tweet_new ();
#line 60 "../src/HomeTimeline.vala"
	t = _tmp1_;
#line 61 "../src/HomeTimeline.vala"
	_tmp2_ = t;
#line 61 "../src/HomeTimeline.vala"
	_tmp3_ = ((DefaultTimeline*) self)->account;
#line 61 "../src/HomeTimeline.vala"
	_tmp4_ = now;
#line 61 "../src/HomeTimeline.vala"
	cb_tweet_load_from_json (_tmp2_, obj, _tmp3_->id, _tmp4_);
#line 65 "../src/HomeTimeline.vala"
	_tmp5_ = t;
#line 65 "../src/HomeTimeline.vala"
	_tmp6_ = _tmp5_->retweeted_tweet;
#line 65 "../src/HomeTimeline.vala"
	if (_tmp6_ != NULL) {
#line 289 "HomeTimeline.c"
		CbTweet* _tmp7_;
		CbMiniTweet _tmp8_;
		CbUserIdentity _tmp9_;
		Account* _tmp10_;
		CbTweet* _tmp14_;
		CbTweet* _tmp15_;
#line 66 "../src/HomeTimeline.vala"
		_tmp7_ = t;
#line 66 "../src/HomeTimeline.vala"
		_tmp8_ = _tmp7_->source_tweet;
#line 66 "../src/HomeTimeline.vala"
		_tmp9_ = _tmp8_.author;
#line 66 "../src/HomeTimeline.vala"
		_tmp10_ = ((DefaultTimeline*) self)->account;
#line 66 "../src/HomeTimeline.vala"
		if (_tmp9_.id == _tmp10_->id) {
#line 306 "HomeTimeline.c"
			TweetListBox* _tmp11_;
			CbTweetModel* _tmp12_;
			Account* _tmp13_;
#line 70 "../src/HomeTimeline.vala"
			_tmp11_ = ((DefaultTimeline*) self)->tweet_list;
#line 70 "../src/HomeTimeline.vala"
			_tmp12_ = _tmp11_->model;
#line 70 "../src/HomeTimeline.vala"
			_tmp13_ = ((DefaultTimeline*) self)->account;
#line 70 "../src/HomeTimeline.vala"
			utils_set_rt_from_tweet (obj, _tmp12_, _tmp13_);
#line 71 "../src/HomeTimeline.vala"
			_g_object_unref0 (t);
#line 71 "../src/HomeTimeline.vala"
			_g_date_time_unref0 (now);
#line 71 "../src/HomeTimeline.vala"
			return;
#line 324 "HomeTimeline.c"
		}
#line 74 "../src/HomeTimeline.vala"
		_tmp14_ = t;
#line 74 "../src/HomeTimeline.vala"
		_tmp15_ = t;
#line 74 "../src/HomeTimeline.vala"
		cb_tweet_set_flag (_tmp14_, (guint) default_timeline_get_rt_flags ((DefaultTimeline*) self, _tmp15_));
#line 332 "HomeTimeline.c"
	}
#line 77 "../src/HomeTimeline.vala"
	_tmp16_ = t;
#line 77 "../src/HomeTimeline.vala"
	_tmp17_ = ((DefaultTimeline*) self)->account;
#line 77 "../src/HomeTimeline.vala"
	tweet_utils_set_tweet_hidden_flags (_tmp16_, _tmp17_);
#line 79 "../src/HomeTimeline.vala"
	auto_scroll = settings_auto_scroll_on_new_tweets ();
#line 80 "../src/HomeTimeline.vala"
	is_new_unread = FALSE;
#line 82 "../src/HomeTimeline.vala"
	_tmp19_ = t;
#line 82 "../src/HomeTimeline.vala"
	if (_tmp19_->id < self->priv->last_tweet_id) {
#line 348 "HomeTimeline.c"
		TweetListBox* _tmp20_;
		CbTweetModel* _tmp21_;
		CbTweet* _tmp22_;
#line 82 "../src/HomeTimeline.vala"
		_tmp20_ = ((DefaultTimeline*) self)->tweet_list;
#line 82 "../src/HomeTimeline.vala"
		_tmp21_ = _tmp20_->model;
#line 82 "../src/HomeTimeline.vala"
		_tmp22_ = t;
#line 82 "../src/HomeTimeline.vala"
		_tmp18_ = !cb_tweet_model_contains_id (_tmp21_, _tmp22_->id);
#line 360 "HomeTimeline.c"
	} else {
#line 82 "../src/HomeTimeline.vala"
		_tmp18_ = FALSE;
#line 364 "HomeTimeline.c"
	}
#line 82 "../src/HomeTimeline.vala"
	if (_tmp18_) {
#line 368 "HomeTimeline.c"
		gint64 age_diff = 0LL;
		CbTweet* _tmp23_;
		CbTweet* _tmp24_;
#line 83 "../src/HomeTimeline.vala"
		_tmp23_ = t;
#line 83 "../src/HomeTimeline.vala"
		age_diff = (gint64) (((self->priv->last_tweet_id >> 22) / 1000) - ((_tmp23_->id >> 22) / 1000));
#line 84 "../src/HomeTimeline.vala"
		_tmp24_ = t;
#line 84 "../src/HomeTimeline.vala"
		g_debug ("HomeTimeline.vala:84: Loaded missing tweet %lld (%lld seconds older th" \
"an %lld)", _tmp24_->id, age_diff, self->priv->last_tweet_id);
#line 85 "../src/HomeTimeline.vala"
		is_new_unread = TRUE;
#line 382 "HomeTimeline.c"
	} else {
		gboolean _tmp25_ = FALSE;
		CbTweet* _tmp26_;
#line 87 "../src/HomeTimeline.vala"
		_tmp26_ = t;
#line 87 "../src/HomeTimeline.vala"
		if (_tmp26_->id > self->priv->last_tweet_id) {
#line 390 "HomeTimeline.c"
			CbTweet* _tmp27_;
			CbMiniTweet _tmp28_;
			CbUserIdentity _tmp29_;
			Account* _tmp30_;
#line 87 "../src/HomeTimeline.vala"
			_tmp27_ = t;
#line 87 "../src/HomeTimeline.vala"
			_tmp28_ = _tmp27_->source_tweet;
#line 87 "../src/HomeTimeline.vala"
			_tmp29_ = _tmp28_.author;
#line 87 "../src/HomeTimeline.vala"
			_tmp30_ = ((DefaultTimeline*) self)->account;
#line 87 "../src/HomeTimeline.vala"
			_tmp25_ = _tmp29_.id != _tmp30_->id;
#line 405 "HomeTimeline.c"
		} else {
#line 87 "../src/HomeTimeline.vala"
			_tmp25_ = FALSE;
#line 409 "HomeTimeline.c"
		}
#line 87 "../src/HomeTimeline.vala"
		if (_tmp25_) {
#line 413 "HomeTimeline.c"
			CbTweet* _tmp31_;
#line 91 "../src/HomeTimeline.vala"
			_tmp31_ = t;
#line 91 "../src/HomeTimeline.vala"
			self->priv->last_tweet_id = _tmp31_->id;
#line 92 "../src/HomeTimeline.vala"
			is_new_unread = TRUE;
#line 421 "HomeTimeline.c"
		}
	}
#line 96 "../src/HomeTimeline.vala"
	_tmp35_ = t;
#line 96 "../src/HomeTimeline.vala"
	_tmp36_ = _tmp35_->source_tweet;
#line 96 "../src/HomeTimeline.vala"
	_tmp37_ = _tmp36_.author;
#line 96 "../src/HomeTimeline.vala"
	_tmp38_ = ((DefaultTimeline*) self)->account;
#line 96 "../src/HomeTimeline.vala"
	if (_tmp37_.id == _tmp38_->id) {
#line 96 "../src/HomeTimeline.vala"
		_tmp34_ = TRUE;
#line 436 "HomeTimeline.c"
	} else {
		gboolean _tmp39_ = FALSE;
		CbTweet* _tmp40_;
		CbMiniTweet* _tmp41_;
#line 97 "../src/HomeTimeline.vala"
		_tmp40_ = t;
#line 97 "../src/HomeTimeline.vala"
		_tmp41_ = _tmp40_->retweeted_tweet;
#line 97 "../src/HomeTimeline.vala"
		if (_tmp41_ != NULL) {
#line 447 "HomeTimeline.c"
			CbTweet* _tmp42_;
			CbMiniTweet* _tmp43_;
			CbUserIdentity _tmp44_;
			Account* _tmp45_;
#line 97 "../src/HomeTimeline.vala"
			_tmp42_ = t;
#line 97 "../src/HomeTimeline.vala"
			_tmp43_ = _tmp42_->retweeted_tweet;
#line 97 "../src/HomeTimeline.vala"
			_tmp44_ = (*_tmp43_).author;
#line 97 "../src/HomeTimeline.vala"
			_tmp45_ = ((DefaultTimeline*) self)->account;
#line 97 "../src/HomeTimeline.vala"
			_tmp39_ = _tmp44_.id == _tmp45_->id;
#line 462 "HomeTimeline.c"
		} else {
#line 97 "../src/HomeTimeline.vala"
			_tmp39_ = FALSE;
#line 466 "HomeTimeline.c"
		}
#line 97 "../src/HomeTimeline.vala"
		_tmp34_ = _tmp39_;
#line 470 "HomeTimeline.c"
	}
#line 96 "../src/HomeTimeline.vala"
	if (_tmp34_) {
#line 96 "../src/HomeTimeline.vala"
		_tmp33_ = TRUE;
#line 476 "HomeTimeline.c"
	} else {
		gboolean _tmp46_ = FALSE;
		gboolean _tmp47_ = FALSE;
		gboolean _tmp48_;
		gboolean _tmp49_;
#line 98 "../src/HomeTimeline.vala"
		_tmp48_ = scroll_widget_get_scrolled_up ((ScrollWidget*) self);
#line 98 "../src/HomeTimeline.vala"
		_tmp49_ = _tmp48_;
#line 98 "../src/HomeTimeline.vala"
		if (_tmp49_) {
#line 488 "HomeTimeline.c"
			MainWindow* _tmp50_;
			gint _tmp51_;
			gint _tmp52_;
			gint _tmp53_;
			gint _tmp54_;
#line 99 "../src/HomeTimeline.vala"
			_tmp50_ = ((DefaultTimeline*) self)->main_window;
#line 99 "../src/HomeTimeline.vala"
			_tmp51_ = main_window_get_cur_page_id (_tmp50_);
#line 99 "../src/HomeTimeline.vala"
			_tmp52_ = _tmp51_;
#line 99 "../src/HomeTimeline.vala"
			_tmp53_ = ipage_get_id ((IPage*) self);
#line 99 "../src/HomeTimeline.vala"
			_tmp54_ = _tmp53_;
#line 99 "../src/HomeTimeline.vala"
			_tmp47_ = _tmp52_ == _tmp54_;
#line 506 "HomeTimeline.c"
		} else {
#line 98 "../src/HomeTimeline.vala"
			_tmp47_ = FALSE;
#line 510 "HomeTimeline.c"
		}
#line 98 "../src/HomeTimeline.vala"
		if (_tmp47_) {
#line 100 "../src/HomeTimeline.vala"
			_tmp46_ = auto_scroll;
#line 516 "HomeTimeline.c"
		} else {
#line 98 "../src/HomeTimeline.vala"
			_tmp46_ = FALSE;
#line 520 "HomeTimeline.c"
		}
#line 98 "../src/HomeTimeline.vala"
		_tmp33_ = _tmp46_;
#line 524 "HomeTimeline.c"
	}
#line 96 "../src/HomeTimeline.vala"
	if (_tmp33_) {
#line 96 "../src/HomeTimeline.vala"
		_tmp32_ = TRUE;
#line 530 "HomeTimeline.c"
	} else {
#line 101 "../src/HomeTimeline.vala"
		_tmp32_ = !((DefaultTimeline*) self)->preload_is_complete;
#line 534 "HomeTimeline.c"
	}
#line 96 "../src/HomeTimeline.vala"
	_tmp55_ = t;
#line 96 "../src/HomeTimeline.vala"
	cb_tweet_set_seen (_tmp55_, _tmp32_);
#line 103 "../src/HomeTimeline.vala"
	_tmp57_ = ((DefaultTimeline*) self)->tweet_list;
#line 103 "../src/HomeTimeline.vala"
	_tmp58_ = list_box_get_first_visible_row ((ListBox*) _tmp57_);
#line 103 "../src/HomeTimeline.vala"
	_tmp59_ = _tmp58_;
#line 103 "../src/HomeTimeline.vala"
	_tmp60_ = _tmp59_ != NULL;
#line 103 "../src/HomeTimeline.vala"
	_g_object_unref0 (_tmp59_);
#line 103 "../src/HomeTimeline.vala"
	if (_tmp60_) {
#line 552 "HomeTimeline.c"
		TweetListBox* _tmp61_;
		GtkWidget* _tmp62_;
		GtkWidget* _tmp63_;
		gboolean _tmp64_;
		gboolean _tmp65_;
#line 104 "../src/HomeTimeline.vala"
		_tmp61_ = ((DefaultTimeline*) self)->tweet_list;
#line 104 "../src/HomeTimeline.vala"
		_tmp62_ = list_box_get_first_visible_row ((ListBox*) _tmp61_);
#line 104 "../src/HomeTimeline.vala"
		_tmp63_ = _tmp62_;
#line 104 "../src/HomeTimeline.vala"
		g_object_get (_tmp63_, "is-focus", &_tmp64_, NULL);
#line 104 "../src/HomeTimeline.vala"
		_tmp65_ = _tmp64_;
#line 104 "../src/HomeTimeline.vala"
		_tmp56_ = _tmp65_;
#line 104 "../src/HomeTimeline.vala"
		_g_object_unref0 (_tmp63_);
#line 572 "HomeTimeline.c"
	} else {
#line 103 "../src/HomeTimeline.vala"
		_tmp56_ = FALSE;
#line 576 "HomeTimeline.c"
	}
#line 103 "../src/HomeTimeline.vala"
	focused = _tmp56_;
#line 106 "../src/HomeTimeline.vala"
	if (focused) {
#line 582 "HomeTimeline.c"
		gboolean _tmp67_;
		gboolean _tmp68_;
#line 106 "../src/HomeTimeline.vala"
		_tmp67_ = scroll_widget_get_scrolled_up ((ScrollWidget*) self);
#line 106 "../src/HomeTimeline.vala"
		_tmp68_ = _tmp67_;
#line 106 "../src/HomeTimeline.vala"
		_tmp66_ = _tmp68_;
#line 591 "HomeTimeline.c"
	} else {
#line 106 "../src/HomeTimeline.vala"
		_tmp66_ = FALSE;
#line 595 "HomeTimeline.c"
	}
#line 106 "../src/HomeTimeline.vala"
	should_focus = _tmp66_;
#line 108 "../src/HomeTimeline.vala"
	_tmp69_ = ((DefaultTimeline*) self)->tweet_list;
#line 108 "../src/HomeTimeline.vala"
	_tmp70_ = _tmp69_->model;
#line 108 "../src/HomeTimeline.vala"
	_tmp71_ = t;
#line 108 "../src/HomeTimeline.vala"
	cb_tweet_model_add (_tmp70_, _tmp71_);
#line 110 "../src/HomeTimeline.vala"
	_tmp72_ = t;
#line 110 "../src/HomeTimeline.vala"
	if (!cb_tweet_is_hidden (_tmp72_)) {
#line 611 "HomeTimeline.c"
		gboolean _tmp74_ = FALSE;
		gboolean _tmp75_ = FALSE;
		CbTweet* _tmp76_;
#line 111 "../src/HomeTimeline.vala"
		if (auto_scroll) {
#line 617 "HomeTimeline.c"
			CbTweet* _tmp73_;
#line 112 "../src/HomeTimeline.vala"
			_tmp73_ = t;
#line 112 "../src/HomeTimeline.vala"
			default_timeline_scroll_up (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DEFAULT_TIMELINE, DefaultTimeline), _tmp73_);
#line 623 "HomeTimeline.c"
		} else {
#line 113 "../src/HomeTimeline.vala"
			if (((DefaultTimeline*) self)->preload_is_complete) {
#line 116 "../src/HomeTimeline.vala"
				scroll_widget_balance_next_upper_change ((ScrollWidget*) self, TOP);
#line 629 "HomeTimeline.c"
			}
		}
#line 119 "../src/HomeTimeline.vala"
		_tmp76_ = t;
#line 119 "../src/HomeTimeline.vala"
		if (!cb_tweet_get_seen (_tmp76_)) {
#line 119 "../src/HomeTimeline.vala"
			_tmp75_ = ((DefaultTimeline*) self)->preload_is_complete;
#line 638 "HomeTimeline.c"
		} else {
#line 119 "../src/HomeTimeline.vala"
			_tmp75_ = FALSE;
#line 642 "HomeTimeline.c"
		}
#line 119 "../src/HomeTimeline.vala"
		if (_tmp75_) {
#line 119 "../src/HomeTimeline.vala"
			_tmp74_ = is_new_unread;
#line 648 "HomeTimeline.c"
		} else {
#line 119 "../src/HomeTimeline.vala"
			_tmp74_ = FALSE;
#line 652 "HomeTimeline.c"
		}
#line 119 "../src/HomeTimeline.vala"
		if (_tmp74_) {
#line 656 "HomeTimeline.c"
			gint _tmp77_;
			gint _tmp78_;
#line 120 "../src/HomeTimeline.vala"
			_tmp77_ = default_timeline_get_unread_count ((DefaultTimeline*) self);
#line 120 "../src/HomeTimeline.vala"
			_tmp78_ = _tmp77_;
#line 120 "../src/HomeTimeline.vala"
			default_timeline_set_unread_count ((DefaultTimeline*) self, _tmp78_ + 1);
#line 665 "HomeTimeline.c"
		}
	} else {
		CbTweet* _tmp79_;
#line 123 "../src/HomeTimeline.vala"
		_tmp79_ = t;
#line 123 "../src/HomeTimeline.vala"
		cb_tweet_set_seen (_tmp79_, TRUE);
#line 673 "HomeTimeline.c"
	}
#line 126 "../src/HomeTimeline.vala"
	if (should_focus) {
#line 677 "HomeTimeline.c"
		TweetListBox* _tmp80_;
		GtkWidget* _tmp81_;
		GtkWidget* _tmp82_;
#line 127 "../src/HomeTimeline.vala"
		_tmp80_ = ((DefaultTimeline*) self)->tweet_list;
#line 127 "../src/HomeTimeline.vala"
		_tmp81_ = list_box_get_first_visible_row ((ListBox*) _tmp80_);
#line 127 "../src/HomeTimeline.vala"
		_tmp82_ = _tmp81_;
#line 127 "../src/HomeTimeline.vala"
		gtk_widget_grab_focus (_tmp82_);
#line 127 "../src/HomeTimeline.vala"
		_g_object_unref0 (_tmp82_);
#line 691 "HomeTimeline.c"
	}
#line 132 "../src/HomeTimeline.vala"
	_tmp83_ = t;
#line 132 "../src/HomeTimeline.vala"
	if (cb_tweet_is_hidden (_tmp83_)) {
#line 133 "../src/HomeTimeline.vala"
		_g_object_unref0 (t);
#line 133 "../src/HomeTimeline.vala"
		_g_date_time_unref0 (now);
#line 133 "../src/HomeTimeline.vala"
		return;
#line 703 "HomeTimeline.c"
	}
#line 137 "../src/HomeTimeline.vala"
	_tmp87_ = t;
#line 137 "../src/HomeTimeline.vala"
	_tmp88_ = ((DefaultTimeline*) self)->account;
#line 137 "../src/HomeTimeline.vala"
	if (cb_tweet_get_user_id (_tmp87_) == _tmp88_->id) {
#line 137 "../src/HomeTimeline.vala"
		_tmp86_ = TRUE;
#line 713 "HomeTimeline.c"
	} else {
#line 137 "../src/HomeTimeline.vala"
		_tmp86_ = auto_scroll;
#line 717 "HomeTimeline.c"
	}
#line 137 "../src/HomeTimeline.vala"
	if (_tmp86_) {
#line 137 "../src/HomeTimeline.vala"
		_tmp85_ = TRUE;
#line 723 "HomeTimeline.c"
	} else {
#line 137 "../src/HomeTimeline.vala"
		_tmp85_ = !((DefaultTimeline*) self)->preload_is_complete;
#line 727 "HomeTimeline.c"
	}
#line 137 "../src/HomeTimeline.vala"
	if (_tmp85_) {
#line 137 "../src/HomeTimeline.vala"
		_tmp84_ = TRUE;
#line 733 "HomeTimeline.c"
	} else {
#line 137 "../src/HomeTimeline.vala"
		_tmp84_ = !is_new_unread;
#line 737 "HomeTimeline.c"
	}
#line 137 "../src/HomeTimeline.vala"
	if (_tmp84_) {
#line 138 "../src/HomeTimeline.vala"
		_g_object_unref0 (t);
#line 138 "../src/HomeTimeline.vala"
		_g_date_time_unref0 (now);
#line 138 "../src/HomeTimeline.vala"
		return;
#line 747 "HomeTimeline.c"
	}
#line 140 "../src/HomeTimeline.vala"
	stack_size = settings_get_tweet_stack_count ();
#line 142 "../src/HomeTimeline.vala"
	if (stack_size == 1) {
#line 142 "../src/HomeTimeline.vala"
		_tmp89_ = !auto_scroll;
#line 755 "HomeTimeline.c"
	} else {
#line 142 "../src/HomeTimeline.vala"
		_tmp89_ = FALSE;
#line 759 "HomeTimeline.c"
	}
#line 142 "../src/HomeTimeline.vala"
	if (_tmp89_) {
#line 763 "HomeTimeline.c"
		gchar* summary = NULL;
		gchar* _tmp90_;
		CbTweet* _tmp91_;
		CbMiniTweet* _tmp92_;
		gchar* id_suffix = NULL;
		CbTweet* _tmp107_;
		gchar* _tmp108_;
		gchar* _tmp109_;
		gchar* _tmp110_;
		gchar* _tmp111_;
		CbTweet* _tmp112_;
		Account* _tmp113_;
		NotificationManager* _tmp114_;
		const gchar* _tmp115_;
		CbTweet* _tmp116_;
		gchar* _tmp117_;
		gchar* _tmp118_;
		const gchar* _tmp119_;
		gchar* _tmp120_;
#line 143 "../src/HomeTimeline.vala"
		_tmp90_ = g_strdup ("");
#line 143 "../src/HomeTimeline.vala"
		summary = _tmp90_;
#line 144 "../src/HomeTimeline.vala"
		_tmp91_ = t;
#line 144 "../src/HomeTimeline.vala"
		_tmp92_ = _tmp91_->retweeted_tweet;
#line 144 "../src/HomeTimeline.vala"
		if (_tmp92_ != NULL) {
#line 793 "HomeTimeline.c"
			CbTweet* _tmp93_;
			CbMiniTweet _tmp94_;
			CbUserIdentity _tmp95_;
			const gchar* _tmp96_;
			CbTweet* _tmp97_;
			CbMiniTweet* _tmp98_;
			CbUserIdentity _tmp99_;
			const gchar* _tmp100_;
			gchar* _tmp101_;
#line 145 "../src/HomeTimeline.vala"
			_tmp93_ = t;
#line 145 "../src/HomeTimeline.vala"
			_tmp94_ = _tmp93_->source_tweet;
#line 145 "../src/HomeTimeline.vala"
			_tmp95_ = _tmp94_.author;
#line 145 "../src/HomeTimeline.vala"
			_tmp96_ = _tmp95_.user_name;
#line 145 "../src/HomeTimeline.vala"
			_tmp97_ = t;
#line 145 "../src/HomeTimeline.vala"
			_tmp98_ = _tmp97_->retweeted_tweet;
#line 145 "../src/HomeTimeline.vala"
			_tmp99_ = (*_tmp98_).author;
#line 145 "../src/HomeTimeline.vala"
			_tmp100_ = _tmp99_.user_name;
#line 145 "../src/HomeTimeline.vala"
			_tmp101_ = g_strdup_printf (_ ("%s retweeted %s"), _tmp96_, _tmp100_);
#line 145 "../src/HomeTimeline.vala"
			_g_free0 (summary);
#line 145 "../src/HomeTimeline.vala"
			summary = _tmp101_;
#line 825 "HomeTimeline.c"
		} else {
			CbTweet* _tmp102_;
			CbMiniTweet _tmp103_;
			CbUserIdentity _tmp104_;
			const gchar* _tmp105_;
			gchar* _tmp106_;
#line 148 "../src/HomeTimeline.vala"
			_tmp102_ = t;
#line 148 "../src/HomeTimeline.vala"
			_tmp103_ = _tmp102_->source_tweet;
#line 148 "../src/HomeTimeline.vala"
			_tmp104_ = _tmp103_.author;
#line 148 "../src/HomeTimeline.vala"
			_tmp105_ = _tmp104_.user_name;
#line 148 "../src/HomeTimeline.vala"
			_tmp106_ = g_strdup_printf (_ ("%s tweeted"), _tmp105_);
#line 148 "../src/HomeTimeline.vala"
			_g_free0 (summary);
#line 148 "../src/HomeTimeline.vala"
			summary = _tmp106_;
#line 846 "HomeTimeline.c"
		}
#line 150 "../src/HomeTimeline.vala"
		_tmp107_ = t;
#line 150 "../src/HomeTimeline.vala"
		_tmp108_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp107_->id);
#line 150 "../src/HomeTimeline.vala"
		_tmp109_ = _tmp108_;
#line 150 "../src/HomeTimeline.vala"
		_tmp110_ = g_strdup_printf ("tweet-%s", _tmp109_);
#line 150 "../src/HomeTimeline.vala"
		_tmp111_ = _tmp110_;
#line 150 "../src/HomeTimeline.vala"
		_g_free0 (_tmp109_);
#line 150 "../src/HomeTimeline.vala"
		id_suffix = _tmp111_;
#line 151 "../src/HomeTimeline.vala"
		_tmp112_ = t;
#line 151 "../src/HomeTimeline.vala"
		_tmp113_ = ((DefaultTimeline*) self)->account;
#line 151 "../src/HomeTimeline.vala"
		_tmp114_ = _tmp113_->notifications;
#line 151 "../src/HomeTimeline.vala"
		_tmp115_ = summary;
#line 151 "../src/HomeTimeline.vala"
		_tmp116_ = t;
#line 151 "../src/HomeTimeline.vala"
		_tmp117_ = cb_tweet_get_real_text (_tmp116_);
#line 151 "../src/HomeTimeline.vala"
		_tmp118_ = _tmp117_;
#line 151 "../src/HomeTimeline.vala"
		_tmp119_ = id_suffix;
#line 151 "../src/HomeTimeline.vala"
		_tmp120_ = notification_manager_send (_tmp114_, _tmp115_, _tmp118_, _tmp119_);
#line 151 "../src/HomeTimeline.vala"
		_g_free0 (_tmp112_->notification_id);
#line 151 "../src/HomeTimeline.vala"
		_tmp112_->notification_id = _tmp120_;
#line 151 "../src/HomeTimeline.vala"
		_g_free0 (_tmp118_);
#line 142 "../src/HomeTimeline.vala"
		_g_free0 (id_suffix);
#line 142 "../src/HomeTimeline.vala"
		_g_free0 (summary);
#line 890 "HomeTimeline.c"
	} else {
		gboolean _tmp121_ = FALSE;
		gboolean _tmp122_ = FALSE;
#line 155 "../src/HomeTimeline.vala"
		if (stack_size != 0) {
#line 896 "HomeTimeline.c"
			gint _tmp123_;
			gint _tmp124_;
#line 155 "../src/HomeTimeline.vala"
			_tmp123_ = default_timeline_get_unread_count ((DefaultTimeline*) self);
#line 155 "../src/HomeTimeline.vala"
			_tmp124_ = _tmp123_;
#line 155 "../src/HomeTimeline.vala"
			_tmp122_ = (_tmp124_ % stack_size) == 0;
#line 905 "HomeTimeline.c"
		} else {
#line 155 "../src/HomeTimeline.vala"
			_tmp122_ = FALSE;
#line 909 "HomeTimeline.c"
		}
#line 155 "../src/HomeTimeline.vala"
		if (_tmp122_) {
#line 913 "HomeTimeline.c"
			gint _tmp125_;
			gint _tmp126_;
#line 156 "../src/HomeTimeline.vala"
			_tmp125_ = default_timeline_get_unread_count ((DefaultTimeline*) self);
#line 156 "../src/HomeTimeline.vala"
			_tmp126_ = _tmp125_;
#line 156 "../src/HomeTimeline.vala"
			_tmp121_ = _tmp126_ > 0;
#line 922 "HomeTimeline.c"
		} else {
#line 155 "../src/HomeTimeline.vala"
			_tmp121_ = FALSE;
#line 926 "HomeTimeline.c"
		}
#line 155 "../src/HomeTimeline.vala"
		if (_tmp121_) {
#line 930 "HomeTimeline.c"
			gchar* summary = NULL;
			gint _tmp127_;
			gint _tmp128_;
			gint _tmp129_;
			gint _tmp130_;
			gchar* _tmp131_;
			Account* _tmp132_;
			NotificationManager* _tmp133_;
			const gchar* _tmp134_;
			gchar* _tmp135_;
			gchar* _tmp136_;
#line 157 "../src/HomeTimeline.vala"
			_tmp127_ = default_timeline_get_unread_count ((DefaultTimeline*) self);
#line 157 "../src/HomeTimeline.vala"
			_tmp128_ = _tmp127_;
#line 157 "../src/HomeTimeline.vala"
			_tmp129_ = default_timeline_get_unread_count ((DefaultTimeline*) self);
#line 157 "../src/HomeTimeline.vala"
			_tmp130_ = _tmp129_;
#line 157 "../src/HomeTimeline.vala"
			_tmp131_ = g_strdup_printf (ngettext ("%d new Tweet!", "%d new Tweets!", (gulong) _tmp128_), _tmp130_);
#line 157 "../src/HomeTimeline.vala"
			summary = _tmp131_;
#line 159 "../src/HomeTimeline.vala"
			_tmp132_ = ((DefaultTimeline*) self)->account;
#line 159 "../src/HomeTimeline.vala"
			_tmp133_ = _tmp132_->notifications;
#line 159 "../src/HomeTimeline.vala"
			_tmp134_ = summary;
#line 159 "../src/HomeTimeline.vala"
			_tmp135_ = notification_manager_send (_tmp133_, _tmp134_, "", NULL);
#line 159 "../src/HomeTimeline.vala"
			_tmp136_ = _tmp135_;
#line 159 "../src/HomeTimeline.vala"
			_g_free0 (_tmp136_);
#line 155 "../src/HomeTimeline.vala"
			_g_free0 (summary);
#line 968 "HomeTimeline.c"
		}
	}
#line 58 "../src/HomeTimeline.vala"
	_g_object_unref0 (t);
#line 58 "../src/HomeTimeline.vala"
	_g_date_time_unref0 (now);
#line 975 "HomeTimeline.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 18 "../src/HomeTimeline.vala"
	g_boxed_free (json_node_get_type (), self);
#line 983 "HomeTimeline.c"
}

static void
home_timeline_load_tweets_from_follow_data_free (gpointer _data)
{
	HomeTimelineLoadTweetsFromFollowData* _data_;
	_data_ = _data;
#line 18 "../src/HomeTimeline.vala"
	__vala_JsonNode_free0 (_data_->follow_root);
#line 18 "../src/HomeTimeline.vala"
	_g_object_unref0 (_data_->self);
#line 18 "../src/HomeTimeline.vala"
	g_slice_free (HomeTimelineLoadTweetsFromFollowData, _data_);
#line 997 "HomeTimeline.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 18 "../src/HomeTimeline.vala"
	return self ? g_object_ref (self) : NULL;
#line 1005 "HomeTimeline.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 18 "../src/HomeTimeline.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 1013 "HomeTimeline.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 18 "../src/HomeTimeline.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 1021 "HomeTimeline.c"
}

static void
home_timeline_load_tweets_from_follow (HomeTimeline* self,
                                       JsonNode* follow_root,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	HomeTimelineLoadTweetsFromFollowData* _data_;
	HomeTimeline* _tmp0_;
	JsonNode* _tmp1_;
#line 18 "../src/HomeTimeline.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/HomeTimeline.vala"
	g_return_if_fail (follow_root != NULL);
#line 18 "../src/HomeTimeline.vala"
	_data_ = g_slice_new0 (HomeTimelineLoadTweetsFromFollowData);
#line 18 "../src/HomeTimeline.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 18 "../src/HomeTimeline.vala"
	g_task_set_task_data (_data_->_async_result, _data_, home_timeline_load_tweets_from_follow_data_free);
#line 18 "../src/HomeTimeline.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 18 "../src/HomeTimeline.vala"
	_data_->self = _tmp0_;
#line 18 "../src/HomeTimeline.vala"
	_tmp1_ = __vala_JsonNode_copy0 (follow_root);
#line 18 "../src/HomeTimeline.vala"
	__vala_JsonNode_free0 (_data_->follow_root);
#line 18 "../src/HomeTimeline.vala"
	_data_->follow_root = _tmp1_;
#line 18 "../src/HomeTimeline.vala"
	home_timeline_load_tweets_from_follow_co (_data_);
#line 1055 "HomeTimeline.c"
}

static void
home_timeline_load_tweets_from_follow_finish (HomeTimeline* self,
                                              GAsyncResult* _res_)
{
	HomeTimelineLoadTweetsFromFollowData* _data_;
#line 18 "../src/HomeTimeline.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1065 "HomeTimeline.c"
}

static void
home_timeline_load_tweets_from_follow_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	HomeTimelineLoadTweetsFromFollowData* _data_;
#line 166 "../src/HomeTimeline.vala"
	_data_ = _user_data_;
#line 166 "../src/HomeTimeline.vala"
	_data_->_source_object_ = source_object;
#line 166 "../src/HomeTimeline.vala"
	_data_->_res_ = _res_;
#line 166 "../src/HomeTimeline.vala"
	home_timeline_load_tweets_from_follow_co (_data_);
#line 1082 "HomeTimeline.c"
}

static void
___lambda219_ (HomeTimeline* self,
               JsonArray* array,
               guint idx,
               JsonNode* node)
{
#line 167 "../src/HomeTimeline.vala"
	g_return_if_fail (array != NULL);
#line 167 "../src/HomeTimeline.vala"
	g_return_if_fail (node != NULL);
#line 167 "../src/HomeTimeline.vala"
	home_timeline_add_tweet (self, node);
#line 1097 "HomeTimeline.c"
}

static void
____lambda219__json_array_foreach (JsonArray* array,
                                   guint index_,
                                   JsonNode* element_node,
                                   gpointer self)
{
#line 167 "../src/HomeTimeline.vala"
	___lambda219_ ((HomeTimeline*) self, array, index_, element_node);
#line 1108 "HomeTimeline.c"
}

static gboolean
home_timeline_load_tweets_from_follow_co (HomeTimelineLoadTweetsFromFollowData* _data_)
{
#line 163 "../src/HomeTimeline.vala"
	switch (_data_->_state_) {
#line 163 "../src/HomeTimeline.vala"
		case 0:
#line 1118 "HomeTimeline.c"
		goto _state_0;
#line 163 "../src/HomeTimeline.vala"
		case 1:
#line 1122 "HomeTimeline.c"
		goto _state_1;
		default:
#line 163 "../src/HomeTimeline.vala"
		g_assert_not_reached ();
#line 1127 "HomeTimeline.c"
	}
	_state_0:
#line 164 "../src/HomeTimeline.vala"
	_data_->follow_id = default_timeline_get_user_id ((DefaultTimeline*) _data_->self, _data_->follow_root);
#line 1132 "HomeTimeline.c"
	{
#line 166 "../src/HomeTimeline.vala"
		_data_->_tmp0_ = ((DefaultTimeline*) _data_->self)->account;
#line 166 "../src/HomeTimeline.vala"
		_data_->_tmp1_ = ((DefaultTimeline*) _data_->self)->tweet_list;
#line 166 "../src/HomeTimeline.vala"
		_data_->_tmp2_ = _data_->_tmp1_->model;
#line 166 "../src/HomeTimeline.vala"
		_data_->_state_ = 1;
#line 166 "../src/HomeTimeline.vala"
		user_utils_load_user_timeline_by_id (_data_->_tmp0_, _data_->follow_id, 200, _data_->_tmp2_->min_id, (gint64) -1, home_timeline_load_tweets_from_follow_ready, _data_);
#line 166 "../src/HomeTimeline.vala"
		return FALSE;
#line 1146 "HomeTimeline.c"
		_state_1:
#line 166 "../src/HomeTimeline.vala"
		_data_->_tmp3_ = user_utils_load_user_timeline_by_id_finish (_data_->_res_, &_data_->_inner_error0_);
#line 166 "../src/HomeTimeline.vala"
		_data_->root_array = _data_->_tmp3_;
#line 166 "../src/HomeTimeline.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1154 "HomeTimeline.c"
			goto __catch0_g_error;
		}
#line 167 "../src/HomeTimeline.vala"
		json_array_foreach_element (_data_->root_array, ____lambda219__json_array_foreach, _data_->self);
#line 165 "../src/HomeTimeline.vala"
		_json_array_unref0 (_data_->root_array);
#line 1161 "HomeTimeline.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 165 "../src/HomeTimeline.vala"
		_data_->e = _data_->_inner_error0_;
#line 165 "../src/HomeTimeline.vala"
		_data_->_inner_error0_ = NULL;
#line 171 "../src/HomeTimeline.vala"
		_data_->_tmp4_ = _data_->e;
#line 171 "../src/HomeTimeline.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 171 "../src/HomeTimeline.vala"
		g_warning ("HomeTimeline.vala:171: %s", _data_->_tmp5_);
#line 165 "../src/HomeTimeline.vala"
		_g_error_free0 (_data_->e);
#line 1178 "HomeTimeline.c"
	}
	__finally0:
#line 165 "../src/HomeTimeline.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 165 "../src/HomeTimeline.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 165 "../src/HomeTimeline.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 165 "../src/HomeTimeline.vala"
		g_object_unref (_data_->_async_result);
#line 165 "../src/HomeTimeline.vala"
		return FALSE;
#line 1191 "HomeTimeline.c"
	}
#line 163 "../src/HomeTimeline.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 163 "../src/HomeTimeline.vala"
	if (_data_->_state_ != 0) {
#line 163 "../src/HomeTimeline.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 163 "../src/HomeTimeline.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1201 "HomeTimeline.c"
		}
	}
#line 163 "../src/HomeTimeline.vala"
	g_object_unref (_data_->_async_result);
#line 163 "../src/HomeTimeline.vala"
	return FALSE;
#line 1208 "HomeTimeline.c"
}

static gchar*
home_timeline_real_get_title (DefaultTimeline* base)
{
	HomeTimeline * self;
	Account* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 175 "../src/HomeTimeline.vala"
	self = (HomeTimeline*) base;
#line 176 "../src/HomeTimeline.vala"
	_tmp0_ = ((DefaultTimeline*) self)->account;
#line 176 "../src/HomeTimeline.vala"
	_tmp1_ = _tmp0_->screen_name;
#line 176 "../src/HomeTimeline.vala"
	_tmp2_ = g_strconcat ("@", _tmp1_, NULL);
#line 176 "../src/HomeTimeline.vala"
	result = _tmp2_;
#line 176 "../src/HomeTimeline.vala"
	return result;
#line 1231 "HomeTimeline.c"
}

static void
home_timeline_real_create_radio_button (DefaultTimeline* base,
                                        GtkRadioButton* group)
{
	HomeTimeline * self;
	BadgeRadioButton* _tmp0_;
#line 179 "../src/HomeTimeline.vala"
	self = (HomeTimeline*) base;
#line 180 "../src/HomeTimeline.vala"
	_tmp0_ = badge_radio_button_new (group, "cawbird-user-home-symbolic", _ ("Home"));
#line 180 "../src/HomeTimeline.vala"
	g_object_ref_sink (_tmp0_);
#line 180 "../src/HomeTimeline.vala"
	_g_object_unref0 (((DefaultTimeline*) self)->radio_button);
#line 180 "../src/HomeTimeline.vala"
	((DefaultTimeline*) self)->radio_button = _tmp0_;
#line 1250 "HomeTimeline.c"
}

static const gchar*
home_timeline_real_get_function (DefaultTimeline* base)
{
	const gchar* result;
	HomeTimeline* self;
#line 22 "../src/HomeTimeline.vala"
	self = (HomeTimeline*) base;
#line 23 "../src/HomeTimeline.vala"
	result = "1.1/statuses/home_timeline.json";
#line 23 "../src/HomeTimeline.vala"
	return result;
#line 1264 "HomeTimeline.c"
}

static const gchar*
home_timeline_real_get_accessibility_name (DefaultTimeline* base)
{
	const gchar* result;
	HomeTimeline* self;
#line 28 "../src/HomeTimeline.vala"
	self = (HomeTimeline*) base;
#line 29 "../src/HomeTimeline.vala"
	result = _ ("Home timeline");
#line 29 "../src/HomeTimeline.vala"
	return result;
#line 1278 "HomeTimeline.c"
}

static void
home_timeline_class_init (HomeTimelineClass * klass,
                          gpointer klass_data)
{
#line 18 "../src/HomeTimeline.vala"
	home_timeline_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/HomeTimeline.vala"
	g_type_class_adjust_private_offset (klass, &HomeTimeline_private_offset);
#line 18 "../src/HomeTimeline.vala"
	((DefaultTimelineClass *) klass)->stream_message_received = (void (*) (DefaultTimeline*, CbStreamMessageType, JsonNode*)) home_timeline_real_stream_message_received;
#line 18 "../src/HomeTimeline.vala"
	((DefaultTimelineClass *) klass)->get_title = (gchar* (*) (DefaultTimeline*)) home_timeline_real_get_title;
#line 18 "../src/HomeTimeline.vala"
	((DefaultTimelineClass *) klass)->create_radio_button = (void (*) (DefaultTimeline*, GtkRadioButton*)) home_timeline_real_create_radio_button;
#line 18 "../src/HomeTimeline.vala"
	DEFAULT_TIMELINE_CLASS (klass)->get_function = (const gchar* (*) (DefaultTimeline*)) home_timeline_real_get_function;
#line 18 "../src/HomeTimeline.vala"
	DEFAULT_TIMELINE_CLASS (klass)->get_accessibility_name = (const gchar* (*) (DefaultTimeline*)) home_timeline_real_get_accessibility_name;
#line 18 "../src/HomeTimeline.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_home_timeline_get_property;
#line 18 "../src/HomeTimeline.vala"
	G_OBJECT_CLASS (klass)->finalize = home_timeline_finalize;
#line 18 "../src/HomeTimeline.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HOME_TIMELINE_FUNCTION_PROPERTY, home_timeline_properties[HOME_TIMELINE_FUNCTION_PROPERTY] = g_param_spec_string ("function", "function", "function", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/HomeTimeline.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HOME_TIMELINE_ACCESSIBILITY_NAME_PROPERTY, home_timeline_properties[HOME_TIMELINE_ACCESSIBILITY_NAME_PROPERTY] = g_param_spec_string ("accessibility-name", "accessibility-name", "accessibility-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1307 "HomeTimeline.c"
}

static void
home_timeline_cb_message_receiver_interface_init (CbMessageReceiverInterface * iface,
                                                  gpointer iface_data)
{
#line 18 "../src/HomeTimeline.vala"
	home_timeline_cb_message_receiver_parent_iface = g_type_interface_peek_parent (iface);
#line 18 "../src/HomeTimeline.vala"
	iface->stream_message_received = (void (*) (CbMessageReceiver*, CbStreamMessageType, JsonNode*)) home_timeline_real_stream_message_received;
#line 1318 "HomeTimeline.c"
}

static void
home_timeline_instance_init (HomeTimeline * self,
                             gpointer klass)
{
#line 18 "../src/HomeTimeline.vala"
	self->priv = home_timeline_get_instance_private (self);
#line 19 "../src/HomeTimeline.vala"
	self->priv->last_tweet_id = (gint64) 0;
#line 1329 "HomeTimeline.c"
}

static void
home_timeline_finalize (GObject * obj)
{
	HomeTimeline * self;
#line 18 "../src/HomeTimeline.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HOME_TIMELINE, HomeTimeline);
#line 18 "../src/HomeTimeline.vala"
	G_OBJECT_CLASS (home_timeline_parent_class)->finalize (obj);
#line 1340 "HomeTimeline.c"
}

static GType
home_timeline_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HomeTimelineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) home_timeline_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HomeTimeline), 0, (GInstanceInitFunc) home_timeline_instance_init, NULL };
	static const GInterfaceInfo cb_message_receiver_info = { (GInterfaceInitFunc) home_timeline_cb_message_receiver_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType home_timeline_type_id;
	home_timeline_type_id = g_type_register_static (TYPE_DEFAULT_TIMELINE, "HomeTimeline", &g_define_type_info, 0);
	g_type_add_interface_static (home_timeline_type_id, CB_TYPE_MESSAGE_RECEIVER, &cb_message_receiver_info);
	HomeTimeline_private_offset = g_type_add_instance_private (home_timeline_type_id, sizeof (HomeTimelinePrivate));
	return home_timeline_type_id;
}

GType
home_timeline_get_type (void)
{
	static volatile gsize home_timeline_type_id__once = 0;
	if (g_once_init_enter (&home_timeline_type_id__once)) {
		GType home_timeline_type_id;
		home_timeline_type_id = home_timeline_get_type_once ();
		g_once_init_leave (&home_timeline_type_id__once, home_timeline_type_id);
	}
	return home_timeline_type_id__once;
}

static void
_vala_home_timeline_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	HomeTimeline * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_HOME_TIMELINE, HomeTimeline);
#line 18 "../src/HomeTimeline.vala"
	switch (property_id) {
#line 18 "../src/HomeTimeline.vala"
		case HOME_TIMELINE_FUNCTION_PROPERTY:
#line 18 "../src/HomeTimeline.vala"
		g_value_set_string (value, default_timeline_get_function ((DefaultTimeline*) self));
#line 18 "../src/HomeTimeline.vala"
		break;
#line 18 "../src/HomeTimeline.vala"
		case HOME_TIMELINE_ACCESSIBILITY_NAME_PROPERTY:
#line 18 "../src/HomeTimeline.vala"
		g_value_set_string (value, default_timeline_get_accessibility_name ((DefaultTimeline*) self));
#line 18 "../src/HomeTimeline.vala"
		break;
#line 1389 "HomeTimeline.c"
		default:
#line 18 "../src/HomeTimeline.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/HomeTimeline.vala"
		break;
#line 1395 "HomeTimeline.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

