/* UserListEntry.c generated by valac 0.56.14, the Vala compiler
 * generated from UserListEntry.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include "CbTwitterItem.h"
#include <glib-object.h>
#include "cawbird.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <gio/gio.h>
#include "CbBundle.h"

#define PROFILE_PAGE_KEY_USER_ID 1
#define PROFILE_PAGE_KEY_SCREEN_NAME 0

#define TYPE_USER_LIST_ENTRY (user_list_entry_get_type ())
#define USER_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_LIST_ENTRY, UserListEntry))
#define USER_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_LIST_ENTRY, UserListEntryClass))
#define IS_USER_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_LIST_ENTRY))
#define IS_USER_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_LIST_ENTRY))
#define USER_LIST_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_LIST_ENTRY, UserListEntryClass))

typedef struct _UserListEntry UserListEntry;
typedef struct _UserListEntryClass UserListEntryClass;
typedef struct _UserListEntryPrivate UserListEntryPrivate;
enum  {
	USER_LIST_ENTRY_0_PROPERTY,
	USER_LIST_ENTRY_NAME_PROPERTY,
	USER_LIST_ENTRY_SCREEN_NAME_PROPERTY,
	USER_LIST_ENTRY_NAME_DISPLAY_LENGTH_PROPERTY,
	USER_LIST_ENTRY_AVATAR_URL_PROPERTY,
	USER_LIST_ENTRY_AVATAR_SURFACE_PROPERTY,
	USER_LIST_ENTRY_VERIFIED_PROPERTY,
	USER_LIST_ENTRY_PROTECTED_ACCOUNT_PROPERTY,
	USER_LIST_ENTRY_SEEN_PROPERTY,
	USER_LIST_ENTRY_SHOW_SETTINGS_PROPERTY,
	USER_LIST_ENTRY_USER_ID_PROPERTY,
	USER_LIST_ENTRY_NUM_PROPERTIES
};
static GParamSpec* user_list_entry_properties[USER_LIST_ENTRY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block55Data Block55Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	PAGE_STREAM = 0,
	PAGE_MENTIONS,
	PAGE_FAVORITES,
	PAGE_DM_THREADS,
	PAGE_LISTS,
	PAGE_FILTERS,
	PAGE_SEARCH,
	PAGE_PROFILE,
	PAGE_TWEET_INFO,
	PAGE_DM,
	PAGE_LIST_STATUSES,
	PAGE_PREVIOUS = 1024,
	PAGE_NEXT = 2048
} Page;

#define TYPE_PAGE (page_get_type ())
enum  {
	USER_LIST_ENTRY_ACTION_CLICKED_SIGNAL,
	USER_LIST_ENTRY_NUM_SIGNALS
};
static guint user_list_entry_signals[USER_LIST_ENTRY_NUM_SIGNALS] = {0};

struct _UserListEntry {
	GtkListBoxRow parent_instance;
	UserListEntryPrivate * priv;
};

struct _UserListEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _UserListEntryPrivate {
	GtkLabel* name_label;
	GtkLabel* screen_name_label;
	AvatarWidget* avatar_image;
	GtkButton* settings_button;
	GtkButton* new_window_button;
	GtkButton* profile_button;
	gint64 _user_id;
	GTimeSpan last_timediff;
	Account* account;
};

struct _Block55Data {
	int _ref_count_;
	UserListEntry* self;
	Account* acc;
};

static gint UserListEntry_private_offset;
static gpointer user_list_entry_parent_class = NULL;
static CbTwitterItemInterface * user_list_entry_cb_twitter_item_parent_iface = NULL;

VALA_EXTERN GType user_list_entry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void user_list_entry_set_screen_name (UserListEntry* self,
                                      const gchar* sn);
VALA_EXTERN UserListEntry* user_list_entry_new_from_account (Account* acc);
VALA_EXTERN UserListEntry* user_list_entry_construct_from_account (GType object_type,
                                                       Account* acc);
static Block55Data* block55_data_ref (Block55Data* _data55_);
static void block55_data_unref (void * _userdata_);
VALA_EXTERN void user_list_entry_set_name (UserListEntry* self,
                               const gchar* value);
VALA_EXTERN void user_list_entry_set_avatar_surface (UserListEntry* self,
                                         cairo_surface_t* value);
VALA_EXTERN void user_list_entry_set_user_id (UserListEntry* self,
                                  gint64 value);
static void __lambda169_ (Block55Data* _data55_,
                   const gchar* screen_name,
                   const gchar* name,
                   cairo_surface_t* nop,
                   cairo_surface_t* avatar);
static void ___lambda169__account_info_changed (Account* _sender,
                                         const gchar* screen_name,
                                         const gchar* name,
                                         cairo_surface_t* avatar_small,
                                         cairo_surface_t* avatar,
                                         gpointer self);
static void __lambda170_ (UserListEntry* self);
static void ___lambda170__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda171_ (UserListEntry* self,
                   GtkWindow* window);
static void user_list_entry_update_window_button_sensitivity (UserListEntry* self,
                                                       MainWindow* window,
                                                       gboolean new_value);
static void ___lambda171__gtk_application_window_added (GtkApplication* _sender,
                                                 GtkWindow* window,
                                                 gpointer self);
static void __lambda172_ (UserListEntry* self,
                   GtkWindow* window);
static void ___lambda172__gtk_application_window_removed (GtkApplication* _sender,
                                                   GtkWindow* window,
                                                   gpointer self);
static void __lambda173_ (UserListEntry* self,
                   gint64* old_id,
                   gint64 new_id);
VALA_EXTERN gint64 user_list_entry_get_user_id (UserListEntry* self);
static gboolean _int64_equal (const gint64 * s1,
                       const gint64 * s2);
static void ___lambda173__cawbird_account_window_changed (Cawbird* _sender,
                                                   gint64* old_id,
                                                   gint64 new_id,
                                                   gpointer self);
static void user_list_entry_real_set_avatar (UserListEntry* self,
                                      const gchar* avatar_url);
static gint user_list_entry_real_update_time_delta (CbTwitterItem* base,
                                             GDateTime* now);
static gint64 user_list_entry_real_get_sort_factor (CbTwitterItem* base);
static gint64 user_list_entry_real_get_timestamp (CbTwitterItem* base);
static GTimeSpan user_list_entry_real_get_last_set_timediff (CbTwitterItem* base);
static void user_list_entry_real_set_last_set_timediff (CbTwitterItem* base,
                                                 GTimeSpan span);
static void user_list_entry_settings_button_clicked_cb (UserListEntry* self);
static void _user_list_entry_settings_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self);
static void user_list_entry_new_window_button_clicked_cb (UserListEntry* self);
static void _user_list_entry_new_window_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void user_list_entry_profile_button_clicked_cb (UserListEntry* self);
VALA_EXTERN gchar* user_list_entry_get_screen_name (UserListEntry* self);
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
static void _user_list_entry_profile_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
VALA_EXTERN UserListEntry* user_list_entry_new (void);
VALA_EXTERN UserListEntry* user_list_entry_construct (GType object_type);
VALA_EXTERN gint user_list_entry_get_name_display_length (UserListEntry* self);
VALA_EXTERN void user_list_entry_set_name_display_length (UserListEntry* self,
                                              gint value);
VALA_EXTERN void user_list_entry_set_avatar_url (UserListEntry* self,
                                     const gchar* value);
VALA_EXTERN void user_list_entry_set_verified (UserListEntry* self,
                                   gboolean value);
VALA_EXTERN void user_list_entry_set_protected_account (UserListEntry* self,
                                            gboolean value);
VALA_EXTERN gboolean user_list_entry_get_seen (UserListEntry* self);
VALA_EXTERN void user_list_entry_set_seen (UserListEntry* self,
                               gboolean value);
VALA_EXTERN void user_list_entry_set_show_settings (UserListEntry* self,
                                        gboolean value);
static void user_list_entry_finalize (GObject * obj);
static GType user_list_entry_get_type_once (void);
static void _vala_user_list_entry_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_user_list_entry_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
user_list_entry_get_instance_private (UserListEntry* self)
{
	return G_STRUCT_MEMBER_P (self, UserListEntry_private_offset);
}

void
user_list_entry_set_screen_name (UserListEntry* self,
                                 const gchar* sn)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
#line 51 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/list/UserListEntry.vala"
	g_return_if_fail (sn != NULL);
#line 52 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->screen_name_label;
#line 52 "../src/list/UserListEntry.vala"
	gtk_label_set_label (_tmp0_, sn);
#line 53 "../src/list/UserListEntry.vala"
	_tmp1_ = self->priv->screen_name_label;
#line 53 "../src/list/UserListEntry.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, sn);
#line 249 "UserListEntry.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 97 "../src/list/UserListEntry.vala"
	return self ? g_object_ref (self) : NULL;
#line 257 "UserListEntry.c"
}

static Block55Data*
block55_data_ref (Block55Data* _data55_)
{
#line 97 "../src/list/UserListEntry.vala"
	g_atomic_int_inc (&_data55_->_ref_count_);
#line 97 "../src/list/UserListEntry.vala"
	return _data55_;
#line 267 "UserListEntry.c"
}

static void
block55_data_unref (void * _userdata_)
{
	Block55Data* _data55_;
	_data55_ = (Block55Data*) _userdata_;
#line 97 "../src/list/UserListEntry.vala"
	if (g_atomic_int_dec_and_test (&_data55_->_ref_count_)) {
#line 277 "UserListEntry.c"
		UserListEntry* self;
#line 97 "../src/list/UserListEntry.vala"
		self = _data55_->self;
#line 97 "../src/list/UserListEntry.vala"
		_g_object_unref0 (_data55_->acc);
#line 97 "../src/list/UserListEntry.vala"
		_g_object_unref0 (self);
#line 97 "../src/list/UserListEntry.vala"
		g_slice_free (Block55Data, _data55_);
#line 287 "UserListEntry.c"
	}
}

static void
__lambda169_ (Block55Data* _data55_,
              const gchar* screen_name,
              const gchar* name,
              cairo_surface_t* nop,
              cairo_surface_t* avatar)
{
	UserListEntry* self;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 103 "../src/list/UserListEntry.vala"
	self = _data55_->self;
#line 103 "../src/list/UserListEntry.vala"
	g_return_if_fail (screen_name != NULL);
#line 103 "../src/list/UserListEntry.vala"
	g_return_if_fail (name != NULL);
#line 103 "../src/list/UserListEntry.vala"
	g_return_if_fail (nop != NULL);
#line 103 "../src/list/UserListEntry.vala"
	g_return_if_fail (avatar != NULL);
#line 104 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->screen_name_label;
#line 104 "../src/list/UserListEntry.vala"
	_tmp1_ = _data55_->acc->screen_name;
#line 104 "../src/list/UserListEntry.vala"
	_tmp2_ = g_strconcat ("@", _tmp1_, NULL);
#line 104 "../src/list/UserListEntry.vala"
	_tmp3_ = _tmp2_;
#line 104 "../src/list/UserListEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp3_);
#line 104 "../src/list/UserListEntry.vala"
	_g_free0 (_tmp3_);
#line 105 "../src/list/UserListEntry.vala"
	user_list_entry_set_name (self, name);
#line 106 "../src/list/UserListEntry.vala"
	user_list_entry_set_avatar_surface (self, avatar);
#line 329 "UserListEntry.c"
}

static void
___lambda169__account_info_changed (Account* _sender,
                                    const gchar* screen_name,
                                    const gchar* name,
                                    cairo_surface_t* avatar_small,
                                    cairo_surface_t* avatar,
                                    gpointer self)
{
#line 103 "../src/list/UserListEntry.vala"
	__lambda169_ (self, screen_name, name, avatar_small, avatar);
#line 342 "UserListEntry.c"
}

static void
__lambda170_ (UserListEntry* self)
{
	Account* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
#line 109 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->account;
#line 109 "../src/list/UserListEntry.vala"
	_tmp1_ = account_get_avatar (_tmp0_);
#line 109 "../src/list/UserListEntry.vala"
	_tmp2_ = _tmp1_;
#line 109 "../src/list/UserListEntry.vala"
	user_list_entry_set_avatar_surface (self, _tmp2_);
#line 359 "UserListEntry.c"
}

static void
___lambda170__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 108 "../src/list/UserListEntry.vala"
	__lambda170_ ((UserListEntry*) self);
#line 369 "UserListEntry.c"
}

static void
__lambda171_ (UserListEntry* self,
              GtkWindow* window)
{
#line 112 "../src/list/UserListEntry.vala"
	g_return_if_fail (window != NULL);
#line 113 "../src/list/UserListEntry.vala"
	if (IS_MAIN_WINDOW (window)) {
#line 114 "../src/list/UserListEntry.vala"
		user_list_entry_update_window_button_sensitivity (self, G_TYPE_CHECK_INSTANCE_CAST (window, TYPE_MAIN_WINDOW, MainWindow), FALSE);
#line 382 "UserListEntry.c"
	}
}

static void
___lambda171__gtk_application_window_added (GtkApplication* _sender,
                                            GtkWindow* window,
                                            gpointer self)
{
#line 112 "../src/list/UserListEntry.vala"
	__lambda171_ ((UserListEntry*) self, window);
#line 393 "UserListEntry.c"
}

static void
__lambda172_ (UserListEntry* self,
              GtkWindow* window)
{
#line 118 "../src/list/UserListEntry.vala"
	g_return_if_fail (window != NULL);
#line 119 "../src/list/UserListEntry.vala"
	if (IS_MAIN_WINDOW (window)) {
#line 120 "../src/list/UserListEntry.vala"
		user_list_entry_update_window_button_sensitivity (self, G_TYPE_CHECK_INSTANCE_CAST (window, TYPE_MAIN_WINDOW, MainWindow), TRUE);
#line 406 "UserListEntry.c"
	}
}

static void
___lambda172__gtk_application_window_removed (GtkApplication* _sender,
                                              GtkWindow* window,
                                              gpointer self)
{
#line 118 "../src/list/UserListEntry.vala"
	__lambda172_ ((UserListEntry*) self, window);
#line 417 "UserListEntry.c"
}

static gboolean
_int64_equal (const gint64 * s1,
              const gint64 * s2)
{
#line 125 "../src/list/UserListEntry.vala"
	if (s1 == s2) {
#line 125 "../src/list/UserListEntry.vala"
		return TRUE;
#line 428 "UserListEntry.c"
	}
#line 125 "../src/list/UserListEntry.vala"
	if (s1 == NULL) {
#line 125 "../src/list/UserListEntry.vala"
		return FALSE;
#line 434 "UserListEntry.c"
	}
#line 125 "../src/list/UserListEntry.vala"
	if (s2 == NULL) {
#line 125 "../src/list/UserListEntry.vala"
		return FALSE;
#line 440 "UserListEntry.c"
	}
#line 125 "../src/list/UserListEntry.vala"
	return (*s1) == (*s2);
#line 444 "UserListEntry.c"
}

static void
__lambda173_ (UserListEntry* self,
              gint64* old_id,
              gint64 new_id)
{
	gint64 _tmp0_;
#line 125 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->_user_id;
#line 125 "../src/list/UserListEntry.vala"
	if (_int64_equal (old_id, &_tmp0_) == TRUE) {
#line 457 "UserListEntry.c"
		GtkButton* _tmp1_;
#line 126 "../src/list/UserListEntry.vala"
		_tmp1_ = self->priv->new_window_button;
#line 126 "../src/list/UserListEntry.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
#line 463 "UserListEntry.c"
	} else {
		gint64 _tmp2_;
#line 127 "../src/list/UserListEntry.vala"
		_tmp2_ = self->priv->_user_id;
#line 127 "../src/list/UserListEntry.vala"
		if (new_id == _tmp2_) {
#line 470 "UserListEntry.c"
			GtkButton* _tmp3_;
#line 128 "../src/list/UserListEntry.vala"
			_tmp3_ = self->priv->new_window_button;
#line 128 "../src/list/UserListEntry.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, FALSE);
#line 476 "UserListEntry.c"
		}
	}
}

static void
___lambda173__cawbird_account_window_changed (Cawbird* _sender,
                                              gint64* old_id,
                                              gint64 new_id,
                                              gpointer self)
{
#line 124 "../src/list/UserListEntry.vala"
	__lambda173_ ((UserListEntry*) self, old_id, new_id);
#line 489 "UserListEntry.c"
}

UserListEntry*
user_list_entry_construct_from_account (GType object_type,
                                        Account* acc)
{
	UserListEntry * self = NULL;
	Block55Data* _data55_;
	Account* _tmp0_;
	GtkLabel* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	Cawbird* cb = NULL;
	GApplication* _tmp8_;
	Cawbird* _tmp9_;
	GtkButton* _tmp10_;
#line 97 "../src/list/UserListEntry.vala"
	g_return_val_if_fail (acc != NULL, NULL);
#line 97 "../src/list/UserListEntry.vala"
	_data55_ = g_slice_new0 (Block55Data);
#line 97 "../src/list/UserListEntry.vala"
	_data55_->_ref_count_ = 1;
#line 97 "../src/list/UserListEntry.vala"
	_tmp0_ = _g_object_ref0 (acc);
#line 97 "../src/list/UserListEntry.vala"
	_g_object_unref0 (_data55_->acc);
#line 97 "../src/list/UserListEntry.vala"
	_data55_->acc = _tmp0_;
#line 97 "../src/list/UserListEntry.vala"
	self = (UserListEntry*) g_object_new (object_type, NULL);
#line 97 "../src/list/UserListEntry.vala"
	_data55_->self = g_object_ref (self);
#line 98 "../src/list/UserListEntry.vala"
	_tmp1_ = self->priv->screen_name_label;
#line 98 "../src/list/UserListEntry.vala"
	_tmp2_ = _data55_->acc->screen_name;
#line 98 "../src/list/UserListEntry.vala"
	_tmp3_ = g_strconcat ("@", _tmp2_, NULL);
#line 98 "../src/list/UserListEntry.vala"
	_tmp4_ = _tmp3_;
#line 98 "../src/list/UserListEntry.vala"
	gtk_label_set_label (_tmp1_, _tmp4_);
#line 98 "../src/list/UserListEntry.vala"
	_g_free0 (_tmp4_);
#line 99 "../src/list/UserListEntry.vala"
	_tmp5_ = _data55_->acc->name;
#line 99 "../src/list/UserListEntry.vala"
	user_list_entry_set_name (self, _tmp5_);
#line 100 "../src/list/UserListEntry.vala"
	_tmp6_ = account_get_avatar (_data55_->acc);
#line 100 "../src/list/UserListEntry.vala"
	_tmp7_ = _tmp6_;
#line 100 "../src/list/UserListEntry.vala"
	user_list_entry_set_avatar_surface (self, _tmp7_);
#line 101 "../src/list/UserListEntry.vala"
	self->priv->account = _data55_->acc;
#line 102 "../src/list/UserListEntry.vala"
	user_list_entry_set_user_id (self, _data55_->acc->id);
#line 103 "../src/list/UserListEntry.vala"
	g_signal_connect_data (_data55_->acc, "info-changed", (GCallback) ___lambda169__account_info_changed, block55_data_ref (_data55_), (GClosureNotify) block55_data_unref, 0);
#line 108 "../src/list/UserListEntry.vala"
	g_signal_connect_object ((GObject*) _data55_->acc, "notify::avatar", (GCallback) ___lambda170__g_object_notify, self, 0);
#line 111 "../src/list/UserListEntry.vala"
	_tmp8_ = g_application_get_default ();
#line 111 "../src/list/UserListEntry.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_CAWBIRD, Cawbird));
#line 111 "../src/list/UserListEntry.vala"
	cb = _tmp9_;
#line 112 "../src/list/UserListEntry.vala"
	g_signal_connect_object ((GtkApplication*) cb, "window-added", (GCallback) ___lambda171__gtk_application_window_added, self, 0);
#line 118 "../src/list/UserListEntry.vala"
	g_signal_connect_object ((GtkApplication*) cb, "window-removed", (GCallback) ___lambda172__gtk_application_window_removed, self, 0);
#line 124 "../src/list/UserListEntry.vala"
	g_signal_connect_object (cb, "account-window-changed", (GCallback) ___lambda173__cawbird_account_window_changed, self, 0);
#line 132 "../src/list/UserListEntry.vala"
	_tmp10_ = self->priv->new_window_button;
#line 132 "../src/list/UserListEntry.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, !cawbird_is_window_open_for_user_id (cb, _data55_->acc->id, NULL));
#line 97 "../src/list/UserListEntry.vala"
	_g_object_unref0 (cb);
#line 97 "../src/list/UserListEntry.vala"
	block55_data_unref (_data55_);
#line 97 "../src/list/UserListEntry.vala"
	_data55_ = NULL;
#line 97 "../src/list/UserListEntry.vala"
	return self;
#line 580 "UserListEntry.c"
}

UserListEntry*
user_list_entry_new_from_account (Account* acc)
{
#line 97 "../src/list/UserListEntry.vala"
	return user_list_entry_construct_from_account (TYPE_USER_LIST_ENTRY, acc);
#line 588 "UserListEntry.c"
}

static void
user_list_entry_real_set_avatar (UserListEntry* self,
                                 const gchar* avatar_url)
{
	Twitter* _tmp0_;
	Twitter* _tmp1_;
	gint64 _tmp2_;
	AvatarWidget* _tmp3_;
#line 135 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/list/UserListEntry.vala"
	g_return_if_fail (avatar_url != NULL);
#line 136 "../src/list/UserListEntry.vala"
	_tmp0_ = twitter_get ();
#line 136 "../src/list/UserListEntry.vala"
	_tmp1_ = _tmp0_;
#line 136 "../src/list/UserListEntry.vala"
	_tmp2_ = self->priv->_user_id;
#line 136 "../src/list/UserListEntry.vala"
	_tmp3_ = self->priv->avatar_image;
#line 136 "../src/list/UserListEntry.vala"
	twitter_get_avatar (_tmp1_, _tmp2_, avatar_url, _tmp3_, 48 * gtk_widget_get_scale_factor ((GtkWidget*) self), FALSE, NULL, NULL);
#line 136 "../src/list/UserListEntry.vala"
	_g_object_unref0 (_tmp1_);
#line 615 "UserListEntry.c"
}

static gint
user_list_entry_real_update_time_delta (CbTwitterItem* base,
                                        GDateTime* now)
{
	UserListEntry * self;
	gint result;
#line 139 "../src/list/UserListEntry.vala"
	self = (UserListEntry*) base;
#line 139 "../src/list/UserListEntry.vala"
	result = 0;
#line 139 "../src/list/UserListEntry.vala"
	return result;
#line 630 "UserListEntry.c"
}

static gint64
user_list_entry_real_get_sort_factor (CbTwitterItem* base)
{
	UserListEntry * self;
	gint64 result;
#line 141 "../src/list/UserListEntry.vala"
	self = (UserListEntry*) base;
#line 142 "../src/list/UserListEntry.vala"
	result = G_MAXINT64 - 1;
#line 142 "../src/list/UserListEntry.vala"
	return result;
#line 644 "UserListEntry.c"
}

static gint64
user_list_entry_real_get_timestamp (CbTwitterItem* base)
{
	UserListEntry * self;
	gint64 result;
#line 145 "../src/list/UserListEntry.vala"
	self = (UserListEntry*) base;
#line 146 "../src/list/UserListEntry.vala"
	result = (gint64) 0;
#line 146 "../src/list/UserListEntry.vala"
	return result;
#line 658 "UserListEntry.c"
}

static GTimeSpan
user_list_entry_real_get_last_set_timediff (CbTwitterItem* base)
{
	UserListEntry * self;
	GTimeSpan result;
#line 149 "../src/list/UserListEntry.vala"
	self = (UserListEntry*) base;
#line 150 "../src/list/UserListEntry.vala"
	result = self->priv->last_timediff;
#line 150 "../src/list/UserListEntry.vala"
	return result;
#line 672 "UserListEntry.c"
}

static void
user_list_entry_real_set_last_set_timediff (CbTwitterItem* base,
                                            GTimeSpan span)
{
	UserListEntry * self;
#line 153 "../src/list/UserListEntry.vala"
	self = (UserListEntry*) base;
#line 154 "../src/list/UserListEntry.vala"
	self->priv->last_timediff = span;
#line 684 "UserListEntry.c"
}

static void
user_list_entry_update_window_button_sensitivity (UserListEntry* self,
                                                  MainWindow* window,
                                                  gboolean new_value)
{
	gboolean _tmp0_ = FALSE;
	Account* _tmp1_;
#line 157 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/list/UserListEntry.vala"
	g_return_if_fail (window != NULL);
#line 158 "../src/list/UserListEntry.vala"
	_tmp1_ = window->account;
#line 158 "../src/list/UserListEntry.vala"
	if (_tmp1_ != NULL) {
#line 702 "UserListEntry.c"
		Account* _tmp2_;
		const gchar* _tmp3_;
		Account* _tmp4_;
		const gchar* _tmp5_;
#line 158 "../src/list/UserListEntry.vala"
		_tmp2_ = window->account;
#line 158 "../src/list/UserListEntry.vala"
		_tmp3_ = _tmp2_->screen_name;
#line 158 "../src/list/UserListEntry.vala"
		_tmp4_ = self->priv->account;
#line 158 "../src/list/UserListEntry.vala"
		_tmp5_ = _tmp4_->screen_name;
#line 158 "../src/list/UserListEntry.vala"
		_tmp0_ = g_strcmp0 (_tmp3_, _tmp5_) == 0;
#line 717 "UserListEntry.c"
	} else {
#line 158 "../src/list/UserListEntry.vala"
		_tmp0_ = FALSE;
#line 721 "UserListEntry.c"
	}
#line 158 "../src/list/UserListEntry.vala"
	if (_tmp0_) {
#line 725 "UserListEntry.c"
		GtkButton* _tmp6_;
#line 159 "../src/list/UserListEntry.vala"
		_tmp6_ = self->priv->new_window_button;
#line 159 "../src/list/UserListEntry.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, new_value);
#line 731 "UserListEntry.c"
	}
}

static void
user_list_entry_settings_button_clicked_cb (UserListEntry* self)
{
	GtkWindow* active_window = NULL;
	GApplication* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp3_;
	AccountDialog* dialog = NULL;
	Account* _tmp4_;
	AccountDialog* _tmp5_;
#line 164 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/list/UserListEntry.vala"
	g_signal_emit (self, user_list_entry_signals[USER_LIST_ENTRY_ACTION_CLICKED_SIGNAL], 0);
#line 166 "../src/list/UserListEntry.vala"
	_tmp0_ = g_application_get_default ();
#line 166 "../src/list/UserListEntry.vala"
	_tmp1_ = gtk_application_get_active_window (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 166 "../src/list/UserListEntry.vala"
	_tmp2_ = _tmp1_;
#line 166 "../src/list/UserListEntry.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 166 "../src/list/UserListEntry.vala"
	active_window = _tmp3_;
#line 167 "../src/list/UserListEntry.vala"
	_tmp4_ = self->priv->account;
#line 167 "../src/list/UserListEntry.vala"
	_tmp5_ = account_dialog_new (_tmp4_);
#line 167 "../src/list/UserListEntry.vala"
	g_object_ref_sink (_tmp5_);
#line 167 "../src/list/UserListEntry.vala"
	dialog = _tmp5_;
#line 168 "../src/list/UserListEntry.vala"
	gtk_window_set_transient_for ((GtkWindow*) dialog, active_window);
#line 169 "../src/list/UserListEntry.vala"
	gtk_window_set_modal ((GtkWindow*) dialog, TRUE);
#line 170 "../src/list/UserListEntry.vala"
	gtk_widget_show ((GtkWidget*) dialog);
#line 164 "../src/list/UserListEntry.vala"
	_g_object_unref0 (dialog);
#line 164 "../src/list/UserListEntry.vala"
	_g_object_unref0 (active_window);
#line 778 "UserListEntry.c"
}

static void
_user_list_entry_settings_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self)
{
#line 19 "../src/list/UserListEntry.vala"
	user_list_entry_settings_button_clicked_cb ((UserListEntry*) self);
#line 787 "UserListEntry.c"
}

static void
user_list_entry_new_window_button_clicked_cb (UserListEntry* self)
{
	Cawbird* cb = NULL;
	GApplication* _tmp0_;
	Cawbird* _tmp1_;
	MainWindow* window = NULL;
	Account* _tmp2_;
	MainWindow* _tmp3_;
#line 174 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/list/UserListEntry.vala"
	_tmp0_ = g_application_get_default ();
#line 175 "../src/list/UserListEntry.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_CAWBIRD, Cawbird));
#line 175 "../src/list/UserListEntry.vala"
	cb = _tmp1_;
#line 176 "../src/list/UserListEntry.vala"
	_tmp2_ = self->priv->account;
#line 176 "../src/list/UserListEntry.vala"
	_tmp3_ = main_window_new ((GtkApplication*) cb, _tmp2_);
#line 176 "../src/list/UserListEntry.vala"
	g_object_ref_sink (_tmp3_);
#line 176 "../src/list/UserListEntry.vala"
	window = _tmp3_;
#line 177 "../src/list/UserListEntry.vala"
	gtk_application_add_window ((GtkApplication*) cb, (GtkWindow*) window);
#line 178 "../src/list/UserListEntry.vala"
	gtk_widget_show_all ((GtkWidget*) window);
#line 179 "../src/list/UserListEntry.vala"
	g_signal_emit (self, user_list_entry_signals[USER_LIST_ENTRY_ACTION_CLICKED_SIGNAL], 0);
#line 174 "../src/list/UserListEntry.vala"
	_g_object_unref0 (window);
#line 174 "../src/list/UserListEntry.vala"
	_g_object_unref0 (cb);
#line 825 "UserListEntry.c"
}

static void
_user_list_entry_new_window_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 19 "../src/list/UserListEntry.vala"
	user_list_entry_new_window_button_clicked_cb ((UserListEntry*) self);
#line 834 "UserListEntry.c"
}

static void
user_list_entry_profile_button_clicked_cb (UserListEntry* self)
{
	GtkWindow* active_window = NULL;
	GApplication* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	GtkWindow* _tmp3_;
	GtkWindow* _tmp4_;
#line 183 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/list/UserListEntry.vala"
	g_signal_emit (self, user_list_entry_signals[USER_LIST_ENTRY_ACTION_CLICKED_SIGNAL], 0);
#line 185 "../src/list/UserListEntry.vala"
	_tmp0_ = g_application_get_default ();
#line 185 "../src/list/UserListEntry.vala"
	_tmp1_ = gtk_application_get_active_window (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 185 "../src/list/UserListEntry.vala"
	_tmp2_ = _tmp1_;
#line 185 "../src/list/UserListEntry.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 185 "../src/list/UserListEntry.vala"
	active_window = _tmp3_;
#line 186 "../src/list/UserListEntry.vala"
	_tmp4_ = active_window;
#line 186 "../src/list/UserListEntry.vala"
	if (IS_MAIN_WINDOW (_tmp4_)) {
#line 864 "UserListEntry.c"
		MainWindow* mw = NULL;
		GtkWindow* _tmp5_;
		MainWindow* _tmp6_;
		CbBundle* bundle = NULL;
		CbBundle* _tmp7_;
		CbBundle* _tmp8_;
		gint64 _tmp9_;
		CbBundle* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		MainWindow* _tmp14_;
		MainWidget* _tmp15_;
		CbBundle* _tmp16_;
#line 187 "../src/list/UserListEntry.vala"
		_tmp5_ = active_window;
#line 187 "../src/list/UserListEntry.vala"
		_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_MAIN_WINDOW, MainWindow));
#line 187 "../src/list/UserListEntry.vala"
		mw = _tmp6_;
#line 188 "../src/list/UserListEntry.vala"
		_tmp7_ = cb_bundle_new ();
#line 188 "../src/list/UserListEntry.vala"
		bundle = _tmp7_;
#line 189 "../src/list/UserListEntry.vala"
		_tmp8_ = bundle;
#line 189 "../src/list/UserListEntry.vala"
		_tmp9_ = self->priv->_user_id;
#line 189 "../src/list/UserListEntry.vala"
		cb_bundle_put_int64 (_tmp8_, PROFILE_PAGE_KEY_USER_ID, _tmp9_);
#line 190 "../src/list/UserListEntry.vala"
		_tmp10_ = bundle;
#line 190 "../src/list/UserListEntry.vala"
		_tmp11_ = user_list_entry_get_screen_name (self);
#line 190 "../src/list/UserListEntry.vala"
		_tmp12_ = _tmp11_;
#line 190 "../src/list/UserListEntry.vala"
		_tmp13_ = _tmp12_;
#line 190 "../src/list/UserListEntry.vala"
		cb_bundle_put_string (_tmp10_, PROFILE_PAGE_KEY_SCREEN_NAME, _tmp13_);
#line 190 "../src/list/UserListEntry.vala"
		_g_free0 (_tmp13_);
#line 191 "../src/list/UserListEntry.vala"
		_tmp14_ = mw;
#line 191 "../src/list/UserListEntry.vala"
		_tmp15_ = _tmp14_->main_widget;
#line 191 "../src/list/UserListEntry.vala"
		_tmp16_ = bundle;
#line 191 "../src/list/UserListEntry.vala"
		main_widget_switch_page (_tmp15_, (gint) PAGE_PROFILE, _tmp16_);
#line 186 "../src/list/UserListEntry.vala"
		_g_object_unref0 (bundle);
#line 186 "../src/list/UserListEntry.vala"
		_g_object_unref0 (mw);
#line 919 "UserListEntry.c"
	}
#line 183 "../src/list/UserListEntry.vala"
	_g_object_unref0 (active_window);
#line 923 "UserListEntry.c"
}

static void
_user_list_entry_profile_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 19 "../src/list/UserListEntry.vala"
	user_list_entry_profile_button_clicked_cb ((UserListEntry*) self);
#line 932 "UserListEntry.c"
}

UserListEntry*
user_list_entry_construct (GType object_type)
{
	UserListEntry * self = NULL;
#line 19 "../src/list/UserListEntry.vala"
	self = (UserListEntry*) g_object_new (object_type, NULL);
#line 19 "../src/list/UserListEntry.vala"
	return self;
#line 943 "UserListEntry.c"
}

UserListEntry*
user_list_entry_new (void)
{
#line 19 "../src/list/UserListEntry.vala"
	return user_list_entry_construct (TYPE_USER_LIST_ENTRY);
#line 951 "UserListEntry.c"
}

void
user_list_entry_set_name (UserListEntry* self,
                          const gchar* value)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
#line 34 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->name_label;
#line 35 "../src/list/UserListEntry.vala"
	gtk_label_set_label (_tmp0_, value);
#line 36 "../src/list/UserListEntry.vala"
	_tmp1_ = self->priv->name_label;
#line 36 "../src/list/UserListEntry.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, value);
#line 34 "../src/list/UserListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, user_list_entry_properties[USER_LIST_ENTRY_NAME_PROPERTY]);
#line 972 "UserListEntry.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 995 "UserListEntry.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 1004 "UserListEntry.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1023 "UserListEntry.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1027 "UserListEntry.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1033 "UserListEntry.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1043 "UserListEntry.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1051 "UserListEntry.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1055 "UserListEntry.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 1061 "UserListEntry.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 1071 "UserListEntry.c"
}

gchar*
user_list_entry_get_screen_name (UserListEntry* self)
{
	gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 41 "../src/list/UserListEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->screen_name_label;
#line 42 "../src/list/UserListEntry.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 42 "../src/list/UserListEntry.vala"
	_tmp2_ = _tmp1_;
#line 42 "../src/list/UserListEntry.vala"
	_tmp3_ = string_substring (_tmp2_, (glong) 1, (glong) -1);
#line 42 "../src/list/UserListEntry.vala"
	result = _tmp3_;
#line 42 "../src/list/UserListEntry.vala"
	return result;
#line 1096 "UserListEntry.c"
}

gint
user_list_entry_get_name_display_length (UserListEntry* self)
{
	gint result;
	GtkLabel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 47 "../src/list/UserListEntry.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->name_label;
#line 47 "../src/list/UserListEntry.vala"
	_tmp1_ = gtk_label_get_max_width_chars (_tmp0_);
#line 47 "../src/list/UserListEntry.vala"
	_tmp2_ = _tmp1_;
#line 47 "../src/list/UserListEntry.vala"
	result = _tmp2_;
#line 47 "../src/list/UserListEntry.vala"
	return result;
#line 1118 "UserListEntry.c"
}

void
user_list_entry_set_name_display_length (UserListEntry* self,
                                         gint value)
{
	GtkLabel* _tmp0_;
#line 48 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->name_label;
#line 48 "../src/list/UserListEntry.vala"
	gtk_label_set_max_width_chars (_tmp0_, value);
#line 48 "../src/list/UserListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, user_list_entry_properties[USER_LIST_ENTRY_NAME_DISPLAY_LENGTH_PROPERTY]);
#line 1134 "UserListEntry.c"
}

void
user_list_entry_set_avatar_url (UserListEntry* self,
                                const gchar* value)
{
#line 57 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/list/UserListEntry.vala"
	user_list_entry_real_set_avatar (self, value);
#line 57 "../src/list/UserListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, user_list_entry_properties[USER_LIST_ENTRY_AVATAR_URL_PROPERTY]);
#line 1147 "UserListEntry.c"
}

void
user_list_entry_set_avatar_surface (UserListEntry* self,
                                    cairo_surface_t* value)
{
	AvatarWidget* _tmp0_;
#line 61 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 61 "../src/list/UserListEntry.vala"
	avatar_widget_set_surface (_tmp0_, value);
#line 61 "../src/list/UserListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, user_list_entry_properties[USER_LIST_ENTRY_AVATAR_SURFACE_PROPERTY]);
#line 1163 "UserListEntry.c"
}

void
user_list_entry_set_verified (UserListEntry* self,
                              gboolean value)
{
	AvatarWidget* _tmp0_;
#line 65 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 66 "../src/list/UserListEntry.vala"
	avatar_widget_set_verified (_tmp0_, value);
#line 65 "../src/list/UserListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, user_list_entry_properties[USER_LIST_ENTRY_VERIFIED_PROPERTY]);
#line 1179 "UserListEntry.c"
}

void
user_list_entry_set_protected_account (UserListEntry* self,
                                       gboolean value)
{
	AvatarWidget* _tmp0_;
#line 71 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 72 "../src/list/UserListEntry.vala"
	avatar_widget_set_protected_account (_tmp0_, value);
#line 71 "../src/list/UserListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, user_list_entry_properties[USER_LIST_ENTRY_PROTECTED_ACCOUNT_PROPERTY]);
#line 1195 "UserListEntry.c"
}

gboolean
user_list_entry_get_seen (UserListEntry* self)
{
	gboolean result;
#line 77 "../src/list/UserListEntry.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 77 "../src/list/UserListEntry.vala"
	result = TRUE;
#line 77 "../src/list/UserListEntry.vala"
	return result;
#line 1208 "UserListEntry.c"
}

void
user_list_entry_set_seen (UserListEntry* self,
                          gboolean value)
{
#line 78 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/list/UserListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, user_list_entry_properties[USER_LIST_ENTRY_SEEN_PROPERTY]);
#line 1219 "UserListEntry.c"
}

void
user_list_entry_set_show_settings (UserListEntry* self,
                                   gboolean value)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
#line 82 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/list/UserListEntry.vala"
	_tmp0_ = self->priv->settings_button;
#line 83 "../src/list/UserListEntry.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 84 "../src/list/UserListEntry.vala"
	_tmp1_ = self->priv->new_window_button;
#line 84 "../src/list/UserListEntry.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, value);
#line 85 "../src/list/UserListEntry.vala"
	_tmp2_ = self->priv->profile_button;
#line 85 "../src/list/UserListEntry.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, value);
#line 82 "../src/list/UserListEntry.vala"
	g_object_notify_by_pspec ((GObject *) self, user_list_entry_properties[USER_LIST_ENTRY_SHOW_SETTINGS_PROPERTY]);
#line 1245 "UserListEntry.c"
}

gint64
user_list_entry_get_user_id (UserListEntry* self)
{
	gint64 result;
#line 89 "../src/list/UserListEntry.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 89 "../src/list/UserListEntry.vala"
	result = self->priv->_user_id;
#line 89 "../src/list/UserListEntry.vala"
	return result;
#line 1258 "UserListEntry.c"
}

void
user_list_entry_set_user_id (UserListEntry* self,
                             gint64 value)
{
	gint64 old_value;
#line 89 "../src/list/UserListEntry.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/list/UserListEntry.vala"
	old_value = user_list_entry_get_user_id (self);
#line 89 "../src/list/UserListEntry.vala"
	if (old_value != value) {
#line 89 "../src/list/UserListEntry.vala"
		self->priv->_user_id = value;
#line 89 "../src/list/UserListEntry.vala"
		g_object_notify_by_pspec ((GObject *) self, user_list_entry_properties[USER_LIST_ENTRY_USER_ID_PROPERTY]);
#line 1276 "UserListEntry.c"
	}
}

static void
user_list_entry_class_init (UserListEntryClass * klass,
                            gpointer klass_data)
{
#line 19 "../src/list/UserListEntry.vala"
	user_list_entry_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/list/UserListEntry.vala"
	g_type_class_adjust_private_offset (klass, &UserListEntry_private_offset);
#line 19 "../src/list/UserListEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_user_list_entry_get_property;
#line 19 "../src/list/UserListEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_user_list_entry_set_property;
#line 19 "../src/list/UserListEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = user_list_entry_finalize;
#line 19 "../src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_NAME_PROPERTY, user_list_entry_properties[USER_LIST_ENTRY_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 19 "../src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_SCREEN_NAME_PROPERTY, user_list_entry_properties[USER_LIST_ENTRY_SCREEN_NAME_PROPERTY] = g_param_spec_string ("screen-name", "screen-name", "screen-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 19 "../src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_NAME_DISPLAY_LENGTH_PROPERTY, user_list_entry_properties[USER_LIST_ENTRY_NAME_DISPLAY_LENGTH_PROPERTY] = g_param_spec_int ("name-display-length", "name-display-length", "name-display-length", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_AVATAR_URL_PROPERTY, user_list_entry_properties[USER_LIST_ENTRY_AVATAR_URL_PROPERTY] = g_param_spec_string ("avatar-url", "avatar-url", "avatar-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 19 "../src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_AVATAR_SURFACE_PROPERTY, user_list_entry_properties[USER_LIST_ENTRY_AVATAR_SURFACE_PROPERTY] = g_param_spec_boxed ("avatar-surface", "avatar-surface", "avatar-surface", cairo_gobject_surface_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 19 "../src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_VERIFIED_PROPERTY, user_list_entry_properties[USER_LIST_ENTRY_VERIFIED_PROPERTY] = g_param_spec_boolean ("verified", "verified", "verified", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 19 "../src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_PROTECTED_ACCOUNT_PROPERTY, user_list_entry_properties[USER_LIST_ENTRY_PROTECTED_ACCOUNT_PROPERTY] = g_param_spec_boolean ("protected-account", "protected-account", "protected-account", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 19 "../src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_SEEN_PROPERTY, user_list_entry_properties[USER_LIST_ENTRY_SEEN_PROPERTY] = g_param_spec_boolean ("seen", "seen", "seen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_SHOW_SETTINGS_PROPERTY, user_list_entry_properties[USER_LIST_ENTRY_SHOW_SETTINGS_PROPERTY] = g_param_spec_boolean ("show-settings", "show-settings", "show-settings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 19 "../src/list/UserListEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LIST_ENTRY_USER_ID_PROPERTY, user_list_entry_properties[USER_LIST_ENTRY_USER_ID_PROPERTY] = g_param_spec_int64 ("user-id", "user-id", "user-id", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/uk/co/ibboard/cawbird/ui/user-list-entry.ui");
#line 19 "../src/list/UserListEntry.vala"
	user_list_entry_signals[USER_LIST_ENTRY_ACTION_CLICKED_SIGNAL] = g_signal_new ("action-clicked", TYPE_USER_LIST_ENTRY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "name_label", FALSE, UserListEntry_private_offset + G_STRUCT_OFFSET (UserListEntryPrivate, name_label));
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "screen_name_label", FALSE, UserListEntry_private_offset + G_STRUCT_OFFSET (UserListEntryPrivate, screen_name_label));
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "avatar_image", FALSE, UserListEntry_private_offset + G_STRUCT_OFFSET (UserListEntryPrivate, avatar_image));
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "settings_button", FALSE, UserListEntry_private_offset + G_STRUCT_OFFSET (UserListEntryPrivate, settings_button));
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "new_window_button", FALSE, UserListEntry_private_offset + G_STRUCT_OFFSET (UserListEntryPrivate, new_window_button));
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "profile_button", FALSE, UserListEntry_private_offset + G_STRUCT_OFFSET (UserListEntryPrivate, profile_button));
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "settings_button_clicked_cb", G_CALLBACK(_user_list_entry_settings_button_clicked_cb_gtk_button_clicked));
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "new_window_button_clicked_cb", G_CALLBACK(_user_list_entry_new_window_button_clicked_cb_gtk_button_clicked));
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "profile_button_clicked_cb", G_CALLBACK(_user_list_entry_profile_button_clicked_cb_gtk_button_clicked));
#line 1336 "UserListEntry.c"
}

static void
user_list_entry_cb_twitter_item_interface_init (CbTwitterItemInterface * iface,
                                                gpointer iface_data)
{
#line 19 "../src/list/UserListEntry.vala"
	user_list_entry_cb_twitter_item_parent_iface = g_type_interface_peek_parent (iface);
#line 19 "../src/list/UserListEntry.vala"
	iface->update_time_delta = (gint (*) (CbTwitterItem*, GDateTime*)) user_list_entry_real_update_time_delta;
#line 19 "../src/list/UserListEntry.vala"
	iface->get_sort_factor = (gint64 (*) (CbTwitterItem*)) user_list_entry_real_get_sort_factor;
#line 19 "../src/list/UserListEntry.vala"
	iface->get_timestamp = (gint64 (*) (CbTwitterItem*)) user_list_entry_real_get_timestamp;
#line 19 "../src/list/UserListEntry.vala"
	iface->get_last_set_timediff = (GTimeSpan (*) (CbTwitterItem*)) user_list_entry_real_get_last_set_timediff;
#line 19 "../src/list/UserListEntry.vala"
	iface->set_last_set_timediff = (void (*) (CbTwitterItem*, GTimeSpan)) user_list_entry_real_set_last_set_timediff;
#line 1355 "UserListEntry.c"
}

static void
user_list_entry_instance_init (UserListEntry * self,
                               gpointer klass)
{
#line 19 "../src/list/UserListEntry.vala"
	self->priv = user_list_entry_get_instance_private (self);
#line 19 "../src/list/UserListEntry.vala"
	g_type_ensure (TYPE_AVATAR_WIDGET);
#line 19 "../src/list/UserListEntry.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1368 "UserListEntry.c"
}

static void
user_list_entry_finalize (GObject * obj)
{
	UserListEntry * self;
#line 19 "../src/list/UserListEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_LIST_ENTRY, UserListEntry);
#line 19 "../src/list/UserListEntry.vala"
	G_OBJECT_CLASS (user_list_entry_parent_class)->finalize (obj);
#line 1379 "UserListEntry.c"
}

static GType
user_list_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UserListEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_list_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserListEntry), 0, (GInstanceInitFunc) user_list_entry_instance_init, NULL };
	static const GInterfaceInfo cb_twitter_item_info = { (GInterfaceInitFunc) user_list_entry_cb_twitter_item_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType user_list_entry_type_id;
	user_list_entry_type_id = g_type_register_static (gtk_list_box_row_get_type (), "UserListEntry", &g_define_type_info, 0);
	g_type_add_interface_static (user_list_entry_type_id, CB_TYPE_TWITTER_ITEM, &cb_twitter_item_info);
	UserListEntry_private_offset = g_type_add_instance_private (user_list_entry_type_id, sizeof (UserListEntryPrivate));
	return user_list_entry_type_id;
}

GType
user_list_entry_get_type (void)
{
	static volatile gsize user_list_entry_type_id__once = 0;
	if (g_once_init_enter (&user_list_entry_type_id__once)) {
		GType user_list_entry_type_id;
		user_list_entry_type_id = user_list_entry_get_type_once ();
		g_once_init_leave (&user_list_entry_type_id__once, user_list_entry_type_id);
	}
	return user_list_entry_type_id__once;
}

static void
_vala_user_list_entry_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	UserListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_LIST_ENTRY, UserListEntry);
#line 19 "../src/list/UserListEntry.vala"
	switch (property_id) {
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_SCREEN_NAME_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		g_value_take_string (value, user_list_entry_get_screen_name (self));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_NAME_DISPLAY_LENGTH_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		g_value_set_int (value, user_list_entry_get_name_display_length (self));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_SEEN_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		g_value_set_boolean (value, user_list_entry_get_seen (self));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_USER_ID_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		g_value_set_int64 (value, user_list_entry_get_user_id (self));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 1440 "UserListEntry.c"
		default:
#line 19 "../src/list/UserListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 1446 "UserListEntry.c"
	}
}

static void
_vala_user_list_entry_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	UserListEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_LIST_ENTRY, UserListEntry);
#line 19 "../src/list/UserListEntry.vala"
	switch (property_id) {
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_NAME_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		user_list_entry_set_name (self, g_value_get_string (value));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_NAME_DISPLAY_LENGTH_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		user_list_entry_set_name_display_length (self, g_value_get_int (value));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_AVATAR_URL_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		user_list_entry_set_avatar_url (self, g_value_get_string (value));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_AVATAR_SURFACE_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		user_list_entry_set_avatar_surface (self, g_value_get_boxed (value));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_VERIFIED_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		user_list_entry_set_verified (self, g_value_get_boolean (value));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_PROTECTED_ACCOUNT_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		user_list_entry_set_protected_account (self, g_value_get_boolean (value));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_SEEN_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		user_list_entry_set_seen (self, g_value_get_boolean (value));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_SHOW_SETTINGS_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		user_list_entry_set_show_settings (self, g_value_get_boolean (value));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 19 "../src/list/UserListEntry.vala"
		case USER_LIST_ENTRY_USER_ID_PROPERTY:
#line 19 "../src/list/UserListEntry.vala"
		user_list_entry_set_user_id (self, g_value_get_int64 (value));
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 1514 "UserListEntry.c"
		default:
#line 19 "../src/list/UserListEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/list/UserListEntry.vala"
		break;
#line 1520 "UserListEntry.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

