/* AvatarBannerWidget.c generated by valac 0.56.14, the Vala compiler
 * generated from AvatarBannerWidget.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "cawbird.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <cairo-gobject.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define AVATAR_BANNER_WIDGET_MIN_HEIGHT 200
#define AVATAR_BANNER_WIDGET_MAX_HEIGHT 250
#define AVATAR_BANNER_WIDGET_BANNER_RATIO 0.5
#define AVATAR_BANNER_WIDGET_AVATAR_SIZE 48

#define TYPE_PIXBUF_BUTTON (pixbuf_button_get_type ())
#define PIXBUF_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXBUF_BUTTON, PixbufButton))
#define PIXBUF_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXBUF_BUTTON, PixbufButtonClass))
#define IS_PIXBUF_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXBUF_BUTTON))
#define IS_PIXBUF_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXBUF_BUTTON))
#define PIXBUF_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXBUF_BUTTON, PixbufButtonClass))

typedef struct _PixbufButton PixbufButton;
typedef struct _PixbufButtonClass PixbufButtonClass;
enum  {
	AVATAR_BANNER_WIDGET_0_PROPERTY,
	AVATAR_BANNER_WIDGET_NUM_PROPERTIES
};
static GParamSpec* avatar_banner_widget_properties[AVATAR_BANNER_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _AvatarBannerWidgetFetchBannerData AvatarBannerWidgetFetchBannerData;
enum  {
	AVATAR_BANNER_WIDGET_AVATAR_CHANGED_SIGNAL,
	AVATAR_BANNER_WIDGET_BANNER_CHANGED_SIGNAL,
	AVATAR_BANNER_WIDGET_AVATAR_CLICKED_SIGNAL,
	AVATAR_BANNER_WIDGET_BANNER_CLICKED_SIGNAL,
	AVATAR_BANNER_WIDGET_NUM_SIGNALS
};
static guint avatar_banner_widget_signals[AVATAR_BANNER_WIDGET_NUM_SIGNALS] = {0};

struct _AvatarBannerWidgetPrivate {
	Account* account;
	PixbufButton* set_banner_button;
	PixbufButton* set_avatar_button;
};

struct _AvatarBannerWidgetFetchBannerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AvatarBannerWidget* self;
	Account* _tmp0_;
	const gchar* _tmp1_;
	PixbufButton* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* pixbuf;
	Account* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
	PixbufButton* _tmp10_;
	GdkPixbuf* _tmp11_;
};

static gint AvatarBannerWidget_private_offset;
static gpointer avatar_banner_widget_parent_class = NULL;

VALA_EXTERN GType pixbuf_button_get_type (void) G_GNUC_CONST ;
static void avatar_banner_widget_fetch_banner (AvatarBannerWidget* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static void avatar_banner_widget_fetch_banner_finish (AvatarBannerWidget* self,
                                               GAsyncResult* _res_);
VALA_EXTERN void pixbuf_button_set_bg (PixbufButton* self,
                           cairo_surface_t* bg);
static gboolean avatar_banner_widget_real_draw (GtkWidget* base,
                                         cairo_t* ct);
static gint avatar_banner_widget_get_avatar_x (AvatarBannerWidget* self);
static gint avatar_banner_widget_get_avatar_y (AvatarBannerWidget* self);
static GtkSizeRequestMode avatar_banner_widget_real_get_request_mode (GtkWidget* base);
static void avatar_banner_widget_real_get_preferred_width (GtkWidget* base,
                                                    gint* min,
                                                    gint* nat);
static void avatar_banner_widget_real_get_preferred_height_for_width (GtkWidget* base,
                                                               gint width,
                                                               gint* min,
                                                               gint* nat);
static void avatar_banner_widget_fetch_banner_data_free (gpointer _data);
static gboolean avatar_banner_widget_fetch_banner_co (AvatarBannerWidgetFetchBannerData* _data_);
VALA_EXTERN void pixbuf_button_set_pixbuf (PixbufButton* self,
                               GdkPixbuf* pixbuf);
VALA_EXTERN void utils_download_pixbuf (const gchar* url,
                            GCancellable* cancellable,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_);
VALA_EXTERN GdkPixbuf* utils_download_pixbuf_finish (GAsyncResult* _res_);
static void avatar_banner_widget_fetch_banner_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void avatar_banner_widget_real_size_allocate (GtkWidget* base,
                                              GtkAllocation* allocation);
static void avatar_banner_widget_real_add (GtkContainer* base,
                                    GtkWidget* w);
static void avatar_banner_widget_real_remove (GtkContainer* base,
                                       GtkWidget* w);
static void avatar_banner_widget_real_forall_internal (GtkContainer* base,
                                                gboolean include_internals,
                                                GtkCallback cb,
                                                gpointer cb_target);
static void avatar_banner_widget_banner_clicked_cb (AvatarBannerWidget* self);
static void avatar_banner_widget_avatar_clicked_cb (AvatarBannerWidget* self);
static GObject * avatar_banner_widget_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
VALA_EXTERN PixbufButton* pixbuf_button_new (void);
VALA_EXTERN PixbufButton* pixbuf_button_construct (GType object_type);
static void _avatar_banner_widget_banner_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
static void _avatar_banner_widget_avatar_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
static void avatar_banner_widget_finalize (GObject * obj);
static GType avatar_banner_widget_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
avatar_banner_widget_get_instance_private (AvatarBannerWidget* self)
{
	return G_STRUCT_MEMBER_P (self, AvatarBannerWidget_private_offset);
}

void
avatar_banner_widget_set_account (AvatarBannerWidget* self,
                                  Account* account)
{
	PixbufButton* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
#line 55 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (account != NULL);
#line 56 "../src/widgets/AvatarBannerWidget.vala"
	self->priv->account = account;
#line 57 "../src/widgets/AvatarBannerWidget.vala"
	avatar_banner_widget_fetch_banner (self, NULL, NULL);
#line 58 "../src/widgets/AvatarBannerWidget.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 59 "../src/widgets/AvatarBannerWidget.vala"
	_tmp0_ = self->priv->set_avatar_button;
#line 59 "../src/widgets/AvatarBannerWidget.vala"
	_tmp1_ = account_get_avatar (account);
#line 59 "../src/widgets/AvatarBannerWidget.vala"
	_tmp2_ = _tmp1_;
#line 59 "../src/widgets/AvatarBannerWidget.vala"
	pixbuf_button_set_bg (_tmp0_, (cairo_surface_t*) _tmp2_);
#line 191 "AvatarBannerWidget.c"
}

static gboolean
avatar_banner_widget_real_draw (GtkWidget* base,
                                cairo_t* ct)
{
	AvatarBannerWidget * self;
	PixbufButton* _tmp0_;
	PixbufButton* _tmp1_;
	gboolean result;
#line 62 "../src/widgets/AvatarBannerWidget.vala"
	self = (AvatarBannerWidget*) base;
#line 62 "../src/widgets/AvatarBannerWidget.vala"
	g_return_val_if_fail (ct != NULL, FALSE);
#line 63 "../src/widgets/AvatarBannerWidget.vala"
	_tmp0_ = self->priv->set_banner_button;
#line 63 "../src/widgets/AvatarBannerWidget.vala"
	gtk_container_propagate_draw ((GtkContainer*) self, (GtkWidget*) _tmp0_, ct);
#line 64 "../src/widgets/AvatarBannerWidget.vala"
	_tmp1_ = self->priv->set_avatar_button;
#line 64 "../src/widgets/AvatarBannerWidget.vala"
	gtk_container_propagate_draw ((GtkContainer*) self, (GtkWidget*) _tmp1_, ct);
#line 66 "../src/widgets/AvatarBannerWidget.vala"
	result = GDK_EVENT_PROPAGATE;
#line 66 "../src/widgets/AvatarBannerWidget.vala"
	return result;
#line 218 "AvatarBannerWidget.c"
}

static gint
avatar_banner_widget_get_avatar_x (AvatarBannerWidget* self)
{
	gint result;
#line 69 "../src/widgets/AvatarBannerWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 70 "../src/widgets/AvatarBannerWidget.vala"
	result = (gtk_widget_get_allocated_width ((GtkWidget*) self) / 2) - (AVATAR_BANNER_WIDGET_AVATAR_SIZE / 2);
#line 70 "../src/widgets/AvatarBannerWidget.vala"
	return result;
#line 231 "AvatarBannerWidget.c"
}

static gint
avatar_banner_widget_get_avatar_y (AvatarBannerWidget* self)
{
	gint result;
#line 73 "../src/widgets/AvatarBannerWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 74 "../src/widgets/AvatarBannerWidget.vala"
	result = gtk_widget_get_allocated_height ((GtkWidget*) self) - AVATAR_BANNER_WIDGET_AVATAR_SIZE;
#line 74 "../src/widgets/AvatarBannerWidget.vala"
	return result;
#line 244 "AvatarBannerWidget.c"
}

static GtkSizeRequestMode
avatar_banner_widget_real_get_request_mode (GtkWidget* base)
{
	AvatarBannerWidget * self;
	GtkSizeRequestMode result;
#line 78 "../src/widgets/AvatarBannerWidget.vala"
	self = (AvatarBannerWidget*) base;
#line 79 "../src/widgets/AvatarBannerWidget.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 79 "../src/widgets/AvatarBannerWidget.vala"
	return result;
#line 258 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_real_get_preferred_width (GtkWidget* base,
                                               gint* min,
                                               gint* nat)
{
	AvatarBannerWidget * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
#line 82 "../src/widgets/AvatarBannerWidget.vala"
	self = (AvatarBannerWidget*) base;
#line 84 "../src/widgets/AvatarBannerWidget.vala"
	_vala_min = AVATAR_BANNER_WIDGET_AVATAR_SIZE + 40;
#line 85 "../src/widgets/AvatarBannerWidget.vala"
	_vala_nat = (gint) (AVATAR_BANNER_WIDGET_MIN_HEIGHT * (1 / AVATAR_BANNER_WIDGET_BANNER_RATIO));
#line 82 "../src/widgets/AvatarBannerWidget.vala"
	if (min) {
#line 82 "../src/widgets/AvatarBannerWidget.vala"
		*min = _vala_min;
#line 279 "AvatarBannerWidget.c"
	}
#line 82 "../src/widgets/AvatarBannerWidget.vala"
	if (nat) {
#line 82 "../src/widgets/AvatarBannerWidget.vala"
		*nat = _vala_nat;
#line 285 "AvatarBannerWidget.c"
	}
}

static void
avatar_banner_widget_real_get_preferred_height_for_width (GtkWidget* base,
                                                          gint width,
                                                          gint* min,
                                                          gint* nat)
{
	AvatarBannerWidget * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
#line 88 "../src/widgets/AvatarBannerWidget.vala"
	self = (AvatarBannerWidget*) base;
#line 91 "../src/widgets/AvatarBannerWidget.vala"
	_vala_min = (AVATAR_BANNER_WIDGET_AVATAR_SIZE / 3) + AVATAR_BANNER_WIDGET_MIN_HEIGHT;
#line 92 "../src/widgets/AvatarBannerWidget.vala"
	_vala_nat = MAX (_vala_min, MIN (AVATAR_BANNER_WIDGET_MAX_HEIGHT, ((gint) (width * AVATAR_BANNER_WIDGET_BANNER_RATIO)) + (AVATAR_BANNER_WIDGET_AVATAR_SIZE / 3)));
#line 88 "../src/widgets/AvatarBannerWidget.vala"
	if (min) {
#line 88 "../src/widgets/AvatarBannerWidget.vala"
		*min = _vala_min;
#line 308 "AvatarBannerWidget.c"
	}
#line 88 "../src/widgets/AvatarBannerWidget.vala"
	if (nat) {
#line 88 "../src/widgets/AvatarBannerWidget.vala"
		*nat = _vala_nat;
#line 314 "AvatarBannerWidget.c"
	}
}

static void
avatar_banner_widget_fetch_banner_data_free (gpointer _data)
{
	AvatarBannerWidgetFetchBannerData* _data_;
	_data_ = _data;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	_g_object_unref0 (_data_->self);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	g_slice_free (AvatarBannerWidgetFetchBannerData, _data_);
#line 327 "AvatarBannerWidget.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 335 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_fetch_banner (AvatarBannerWidget* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	AvatarBannerWidgetFetchBannerData* _data_;
	AvatarBannerWidget* _tmp0_;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	_data_ = g_slice_new0 (AvatarBannerWidgetFetchBannerData);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	g_task_set_task_data (_data_->_async_result, _data_, avatar_banner_widget_fetch_banner_data_free);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	_data_->self = _tmp0_;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	avatar_banner_widget_fetch_banner_co (_data_);
#line 359 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_fetch_banner_finish (AvatarBannerWidget* self,
                                          GAsyncResult* _res_)
{
	AvatarBannerWidgetFetchBannerData* _data_;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 369 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_fetch_banner_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	AvatarBannerWidgetFetchBannerData* _data_;
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_ = _user_data_;
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_source_object_ = source_object;
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_res_ = _res_;
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	avatar_banner_widget_fetch_banner_co (_data_);
#line 386 "AvatarBannerWidget.c"
}

static gboolean
avatar_banner_widget_fetch_banner_co (AvatarBannerWidgetFetchBannerData* _data_)
{
#line 95 "../src/widgets/AvatarBannerWidget.vala"
	switch (_data_->_state_) {
#line 95 "../src/widgets/AvatarBannerWidget.vala"
		case 0:
#line 396 "AvatarBannerWidget.c"
		goto _state_0;
#line 95 "../src/widgets/AvatarBannerWidget.vala"
		case 1:
#line 400 "AvatarBannerWidget.c"
		goto _state_1;
		default:
#line 95 "../src/widgets/AvatarBannerWidget.vala"
		g_assert_not_reached ();
#line 405 "AvatarBannerWidget.c"
	}
	_state_0:
#line 96 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_tmp0_ = _data_->self->priv->account;
#line 96 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_tmp1_ = _data_->_tmp0_->banner_url;
#line 96 "../src/widgets/AvatarBannerWidget.vala"
	if (_data_->_tmp1_ == NULL) {
#line 97 "../src/widgets/AvatarBannerWidget.vala"
		_data_->_tmp2_ = _data_->self->priv->set_banner_button;
#line 97 "../src/widgets/AvatarBannerWidget.vala"
		_data_->_tmp3_ = twitter_no_banner;
#line 97 "../src/widgets/AvatarBannerWidget.vala"
		pixbuf_button_set_pixbuf (_data_->_tmp2_, _data_->_tmp3_);
#line 98 "../src/widgets/AvatarBannerWidget.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 98 "../src/widgets/AvatarBannerWidget.vala"
		if (_data_->_state_ != 0) {
#line 98 "../src/widgets/AvatarBannerWidget.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 98 "../src/widgets/AvatarBannerWidget.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 428 "AvatarBannerWidget.c"
			}
		}
#line 98 "../src/widgets/AvatarBannerWidget.vala"
		g_object_unref (_data_->_async_result);
#line 98 "../src/widgets/AvatarBannerWidget.vala"
		return FALSE;
#line 435 "AvatarBannerWidget.c"
	}
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_tmp4_ = _data_->self->priv->account;
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_tmp5_ = _data_->_tmp4_->banner_url;
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_tmp6_ = g_strconcat (_data_->_tmp5_, "/600x200", NULL);
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_state_ = 1;
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	utils_download_pixbuf (_data_->_tmp7_, NULL, avatar_banner_widget_fetch_banner_ready, _data_);
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	return FALSE;
#line 451 "AvatarBannerWidget.c"
	_state_1:
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_tmp8_ = utils_download_pixbuf_finish (_data_->_res_);
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_g_free0 (_data_->_tmp7_);
#line 101 "../src/widgets/AvatarBannerWidget.vala"
	_data_->pixbuf = _data_->_tmp9_;
#line 102 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_tmp10_ = _data_->self->priv->set_banner_button;
#line 102 "../src/widgets/AvatarBannerWidget.vala"
	_data_->_tmp11_ = _data_->pixbuf;
#line 102 "../src/widgets/AvatarBannerWidget.vala"
	pixbuf_button_set_pixbuf (_data_->_tmp10_, _data_->_tmp11_);
#line 95 "../src/widgets/AvatarBannerWidget.vala"
	_g_object_unref0 (_data_->pixbuf);
#line 95 "../src/widgets/AvatarBannerWidget.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 95 "../src/widgets/AvatarBannerWidget.vala"
	if (_data_->_state_ != 0) {
#line 95 "../src/widgets/AvatarBannerWidget.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 95 "../src/widgets/AvatarBannerWidget.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 477 "AvatarBannerWidget.c"
		}
	}
#line 95 "../src/widgets/AvatarBannerWidget.vala"
	g_object_unref (_data_->_async_result);
#line 95 "../src/widgets/AvatarBannerWidget.vala"
	return FALSE;
#line 484 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_real_size_allocate (GtkWidget* base,
                                         GtkAllocation* allocation)
{
	AvatarBannerWidget * self;
	GtkAllocation _tmp0_;
	GtkRequisition child_requisition = {0};
	GtkAllocation child_allocation = {0};
	PixbufButton* _tmp1_;
	GtkRequisition _tmp2_ = {0};
	GtkAllocation _tmp3_;
	GtkAllocation _tmp4_;
	GtkAllocation _tmp5_;
	GtkRequisition _tmp6_;
	GtkAllocation _tmp7_;
	GtkAllocation _tmp8_;
	GtkRequisition _tmp9_;
	PixbufButton* _tmp10_;
	GtkAllocation _tmp11_;
	PixbufButton* _tmp12_;
	GtkRequisition _tmp13_ = {0};
	GtkAllocation _tmp14_;
	GtkAllocation _tmp15_;
	PixbufButton* _tmp16_;
	GtkAllocation _tmp17_;
#line 105 "../src/widgets/AvatarBannerWidget.vala"
	self = (AvatarBannerWidget*) base;
#line 105 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (allocation != NULL);
#line 106 "../src/widgets/AvatarBannerWidget.vala"
	_tmp0_ = *allocation;
#line 106 "../src/widgets/AvatarBannerWidget.vala"
	GTK_WIDGET_CLASS (avatar_banner_widget_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), &_tmp0_);
#line 109 "../src/widgets/AvatarBannerWidget.vala"
	memset (&child_allocation, 0, sizeof (GtkAllocation));
#line 112 "../src/widgets/AvatarBannerWidget.vala"
	_tmp1_ = self->priv->set_banner_button;
#line 112 "../src/widgets/AvatarBannerWidget.vala"
	gtk_widget_get_preferred_size ((GtkWidget*) _tmp1_, &_tmp2_, NULL);
#line 112 "../src/widgets/AvatarBannerWidget.vala"
	child_requisition = _tmp2_;
#line 113 "../src/widgets/AvatarBannerWidget.vala"
	_tmp3_ = *allocation;
#line 113 "../src/widgets/AvatarBannerWidget.vala"
	child_allocation.x = _tmp3_.x;
#line 114 "../src/widgets/AvatarBannerWidget.vala"
	_tmp4_ = *allocation;
#line 114 "../src/widgets/AvatarBannerWidget.vala"
	child_allocation.y = _tmp4_.y;
#line 115 "../src/widgets/AvatarBannerWidget.vala"
	_tmp5_ = *allocation;
#line 115 "../src/widgets/AvatarBannerWidget.vala"
	_tmp6_ = child_requisition;
#line 115 "../src/widgets/AvatarBannerWidget.vala"
	child_allocation.width = MAX (_tmp5_.width, _tmp6_.width);
#line 116 "../src/widgets/AvatarBannerWidget.vala"
	_tmp7_ = *allocation;
#line 116 "../src/widgets/AvatarBannerWidget.vala"
	child_allocation.height = (gint) (_tmp7_.width * AVATAR_BANNER_WIDGET_BANNER_RATIO);
#line 117 "../src/widgets/AvatarBannerWidget.vala"
	_tmp8_ = *allocation;
#line 117 "../src/widgets/AvatarBannerWidget.vala"
	_tmp9_ = child_requisition;
#line 117 "../src/widgets/AvatarBannerWidget.vala"
	child_allocation.height = MAX (_tmp8_.height - (AVATAR_BANNER_WIDGET_AVATAR_SIZE / 2), _tmp9_.height);
#line 118 "../src/widgets/AvatarBannerWidget.vala"
	_tmp10_ = self->priv->set_banner_button;
#line 118 "../src/widgets/AvatarBannerWidget.vala"
	_tmp11_ = child_allocation;
#line 118 "../src/widgets/AvatarBannerWidget.vala"
	gtk_widget_size_allocate ((GtkWidget*) _tmp10_, &_tmp11_);
#line 122 "../src/widgets/AvatarBannerWidget.vala"
	_tmp12_ = self->priv->set_avatar_button;
#line 122 "../src/widgets/AvatarBannerWidget.vala"
	gtk_widget_get_preferred_size ((GtkWidget*) _tmp12_, &_tmp13_, NULL);
#line 122 "../src/widgets/AvatarBannerWidget.vala"
	child_requisition = _tmp13_;
#line 123 "../src/widgets/AvatarBannerWidget.vala"
	_tmp14_ = *allocation;
#line 123 "../src/widgets/AvatarBannerWidget.vala"
	child_allocation.x = avatar_banner_widget_get_avatar_x (self) + _tmp14_.x;
#line 124 "../src/widgets/AvatarBannerWidget.vala"
	_tmp15_ = *allocation;
#line 124 "../src/widgets/AvatarBannerWidget.vala"
	child_allocation.y = avatar_banner_widget_get_avatar_y (self) + _tmp15_.y;
#line 125 "../src/widgets/AvatarBannerWidget.vala"
	child_allocation.width = AVATAR_BANNER_WIDGET_AVATAR_SIZE;
#line 126 "../src/widgets/AvatarBannerWidget.vala"
	child_allocation.height = AVATAR_BANNER_WIDGET_AVATAR_SIZE;
#line 127 "../src/widgets/AvatarBannerWidget.vala"
	_tmp16_ = self->priv->set_avatar_button;
#line 127 "../src/widgets/AvatarBannerWidget.vala"
	_tmp17_ = child_allocation;
#line 127 "../src/widgets/AvatarBannerWidget.vala"
	gtk_widget_size_allocate ((GtkWidget*) _tmp16_, &_tmp17_);
#line 582 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_real_add (GtkContainer* base,
                               GtkWidget* w)
{
	AvatarBannerWidget * self;
#line 130 "../src/widgets/AvatarBannerWidget.vala"
	self = (AvatarBannerWidget*) base;
#line 130 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (w != NULL);
#line 131 "../src/widgets/AvatarBannerWidget.vala"
	gtk_widget_set_parent (w, (GtkWidget*) ((GtkContainer*) self));
#line 596 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_real_remove (GtkContainer* base,
                                  GtkWidget* w)
{
	AvatarBannerWidget * self;
#line 134 "../src/widgets/AvatarBannerWidget.vala"
	self = (AvatarBannerWidget*) base;
#line 134 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (w != NULL);
#line 135 "../src/widgets/AvatarBannerWidget.vala"
	gtk_widget_unparent (w);
#line 610 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_real_forall_internal (GtkContainer* base,
                                           gboolean include_internals,
                                           GtkCallback cb,
                                           gpointer cb_target)
{
	AvatarBannerWidget * self;
	PixbufButton* _tmp0_;
	PixbufButton* _tmp1_;
#line 138 "../src/widgets/AvatarBannerWidget.vala"
	self = (AvatarBannerWidget*) base;
#line 139 "../src/widgets/AvatarBannerWidget.vala"
	_tmp0_ = self->priv->set_banner_button;
#line 139 "../src/widgets/AvatarBannerWidget.vala"
	cb ((GtkWidget*) _tmp0_, cb_target);
#line 140 "../src/widgets/AvatarBannerWidget.vala"
	_tmp1_ = self->priv->set_avatar_button;
#line 140 "../src/widgets/AvatarBannerWidget.vala"
	cb ((GtkWidget*) _tmp1_, cb_target);
#line 632 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_banner_clicked_cb (AvatarBannerWidget* self)
{
#line 143 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/widgets/AvatarBannerWidget.vala"
	g_signal_emit (self, avatar_banner_widget_signals[AVATAR_BANNER_WIDGET_BANNER_CLICKED_SIGNAL], 0);
#line 642 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_avatar_clicked_cb (AvatarBannerWidget* self)
{
#line 147 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/widgets/AvatarBannerWidget.vala"
	g_signal_emit (self, avatar_banner_widget_signals[AVATAR_BANNER_WIDGET_AVATAR_CLICKED_SIGNAL], 0);
#line 652 "AvatarBannerWidget.c"
}

void
avatar_banner_widget_set_avatar (AvatarBannerWidget* self,
                                 GdkPixbuf* avatar)
{
	PixbufButton* _tmp0_;
#line 151 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (avatar != NULL);
#line 152 "../src/widgets/AvatarBannerWidget.vala"
	_tmp0_ = self->priv->set_avatar_button;
#line 152 "../src/widgets/AvatarBannerWidget.vala"
	pixbuf_button_set_pixbuf (_tmp0_, avatar);
#line 668 "AvatarBannerWidget.c"
}

void
avatar_banner_widget_set_banner (AvatarBannerWidget* self,
                                 GdkPixbuf* banner)
{
	PixbufButton* _tmp0_;
#line 155 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/widgets/AvatarBannerWidget.vala"
	g_return_if_fail (banner != NULL);
#line 156 "../src/widgets/AvatarBannerWidget.vala"
	_tmp0_ = self->priv->set_banner_button;
#line 156 "../src/widgets/AvatarBannerWidget.vala"
	pixbuf_button_set_pixbuf (_tmp0_, banner);
#line 684 "AvatarBannerWidget.c"
}

AvatarBannerWidget*
avatar_banner_widget_construct (GType object_type)
{
	AvatarBannerWidget * self = NULL;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	self = (AvatarBannerWidget*) g_object_new (object_type, NULL);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	return self;
#line 695 "AvatarBannerWidget.c"
}

AvatarBannerWidget*
avatar_banner_widget_new (void)
{
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	return avatar_banner_widget_construct (TYPE_AVATAR_BANNER_WIDGET);
#line 703 "AvatarBannerWidget.c"
}

static void
_avatar_banner_widget_banner_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 42 "../src/widgets/AvatarBannerWidget.vala"
	avatar_banner_widget_banner_clicked_cb ((AvatarBannerWidget*) self);
#line 712 "AvatarBannerWidget.c"
}

static void
_avatar_banner_widget_avatar_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 48 "../src/widgets/AvatarBannerWidget.vala"
	avatar_banner_widget_avatar_clicked_cb ((AvatarBannerWidget*) self);
#line 721 "AvatarBannerWidget.c"
}

static GObject *
avatar_banner_widget_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AvatarBannerWidget * self;
	GtkStyleContext* _tmp0_;
	PixbufButton* _tmp1_;
	PixbufButton* _tmp2_;
	PixbufButton* _tmp3_;
	PixbufButton* _tmp4_;
	PixbufButton* _tmp5_;
	PixbufButton* _tmp6_;
	PixbufButton* _tmp7_;
	PixbufButton* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	PixbufButton* _tmp11_;
#line 35 "../src/widgets/AvatarBannerWidget.vala"
	parent_class = G_OBJECT_CLASS (avatar_banner_widget_parent_class);
#line 35 "../src/widgets/AvatarBannerWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 35 "../src/widgets/AvatarBannerWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AVATAR_BANNER_WIDGET, AvatarBannerWidget);
#line 36 "../src/widgets/AvatarBannerWidget.vala"
	gtk_widget_set_has_window ((GtkWidget*) self, FALSE);
#line 37 "../src/widgets/AvatarBannerWidget.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 37 "../src/widgets/AvatarBannerWidget.vala"
	gtk_style_context_add_class (_tmp0_, "avatar");
#line 40 "../src/widgets/AvatarBannerWidget.vala"
	_tmp1_ = pixbuf_button_new ();
#line 40 "../src/widgets/AvatarBannerWidget.vala"
	g_object_ref_sink (_tmp1_);
#line 40 "../src/widgets/AvatarBannerWidget.vala"
	_g_object_unref0 (self->priv->set_banner_button);
#line 40 "../src/widgets/AvatarBannerWidget.vala"
	self->priv->set_banner_button = _tmp1_;
#line 41 "../src/widgets/AvatarBannerWidget.vala"
	_tmp2_ = self->priv->set_banner_button;
#line 41 "../src/widgets/AvatarBannerWidget.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
#line 42 "../src/widgets/AvatarBannerWidget.vala"
	_tmp3_ = self->priv->set_banner_button;
#line 42 "../src/widgets/AvatarBannerWidget.vala"
	g_signal_connect_object ((GtkButton*) _tmp3_, "clicked", (GCallback) _avatar_banner_widget_banner_clicked_cb_gtk_button_clicked, self, 0);
#line 43 "../src/widgets/AvatarBannerWidget.vala"
	_tmp4_ = self->priv->set_banner_button;
#line 43 "../src/widgets/AvatarBannerWidget.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
#line 46 "../src/widgets/AvatarBannerWidget.vala"
	_tmp5_ = pixbuf_button_new ();
#line 46 "../src/widgets/AvatarBannerWidget.vala"
	g_object_ref_sink (_tmp5_);
#line 46 "../src/widgets/AvatarBannerWidget.vala"
	_g_object_unref0 (self->priv->set_avatar_button);
#line 46 "../src/widgets/AvatarBannerWidget.vala"
	self->priv->set_avatar_button = _tmp5_;
#line 47 "../src/widgets/AvatarBannerWidget.vala"
	_tmp6_ = self->priv->set_avatar_button;
#line 47 "../src/widgets/AvatarBannerWidget.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp6_);
#line 48 "../src/widgets/AvatarBannerWidget.vala"
	_tmp7_ = self->priv->set_avatar_button;
#line 48 "../src/widgets/AvatarBannerWidget.vala"
	g_signal_connect_object ((GtkButton*) _tmp7_, "clicked", (GCallback) _avatar_banner_widget_avatar_clicked_cb_gtk_button_clicked, self, 0);
#line 49 "../src/widgets/AvatarBannerWidget.vala"
	_tmp8_ = self->priv->set_avatar_button;
#line 49 "../src/widgets/AvatarBannerWidget.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp8_);
#line 50 "../src/widgets/AvatarBannerWidget.vala"
	_tmp9_ = settings_get ();
#line 50 "../src/widgets/AvatarBannerWidget.vala"
	_tmp10_ = _tmp9_;
#line 50 "../src/widgets/AvatarBannerWidget.vala"
	_tmp11_ = self->priv->set_avatar_button;
#line 50 "../src/widgets/AvatarBannerWidget.vala"
	g_settings_bind (_tmp10_, "round-avatars", (GObject*) _tmp11_, "round", G_SETTINGS_BIND_DEFAULT);
#line 50 "../src/widgets/AvatarBannerWidget.vala"
	_g_object_unref0 (_tmp10_);
#line 35 "../src/widgets/AvatarBannerWidget.vala"
	return obj;
#line 808 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_class_init (AvatarBannerWidgetClass * klass,
                                 gpointer klass_data)
{
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	avatar_banner_widget_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	g_type_class_adjust_private_offset (klass, &AvatarBannerWidget_private_offset);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) avatar_banner_widget_real_draw;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) avatar_banner_widget_real_get_request_mode;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) avatar_banner_widget_real_get_preferred_width;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) avatar_banner_widget_real_get_preferred_height_for_width;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) avatar_banner_widget_real_size_allocate;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	((GtkContainerClass *) klass)->add = (void (*) (GtkContainer*, GtkWidget*)) avatar_banner_widget_real_add;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	((GtkContainerClass *) klass)->remove = (void (*) (GtkContainer*, GtkWidget*)) avatar_banner_widget_real_remove;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	((GtkContainerClass *) klass)->forall = (void (*) (GtkContainer*, gboolean, GtkCallback, gpointer)) avatar_banner_widget_real_forall_internal;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = avatar_banner_widget_constructor;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = avatar_banner_widget_finalize;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	avatar_banner_widget_signals[AVATAR_BANNER_WIDGET_AVATAR_CHANGED_SIGNAL] = g_signal_new ("avatar-changed", TYPE_AVATAR_BANNER_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gdk_pixbuf_get_type ());
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	avatar_banner_widget_signals[AVATAR_BANNER_WIDGET_BANNER_CHANGED_SIGNAL] = g_signal_new ("banner-changed", TYPE_AVATAR_BANNER_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gdk_pixbuf_get_type ());
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	avatar_banner_widget_signals[AVATAR_BANNER_WIDGET_AVATAR_CLICKED_SIGNAL] = g_signal_new ("avatar-clicked", TYPE_AVATAR_BANNER_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	avatar_banner_widget_signals[AVATAR_BANNER_WIDGET_BANNER_CLICKED_SIGNAL] = g_signal_new ("banner-clicked", TYPE_AVATAR_BANNER_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 847 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_instance_init (AvatarBannerWidget * self,
                                    gpointer klass)
{
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	self->priv = avatar_banner_widget_get_instance_private (self);
#line 856 "AvatarBannerWidget.c"
}

static void
avatar_banner_widget_finalize (GObject * obj)
{
	AvatarBannerWidget * self;
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AVATAR_BANNER_WIDGET, AvatarBannerWidget);
#line 26 "../src/widgets/AvatarBannerWidget.vala"
	_g_object_unref0 (self->priv->set_banner_button);
#line 27 "../src/widgets/AvatarBannerWidget.vala"
	_g_object_unref0 (self->priv->set_avatar_button);
#line 18 "../src/widgets/AvatarBannerWidget.vala"
	G_OBJECT_CLASS (avatar_banner_widget_parent_class)->finalize (obj);
#line 871 "AvatarBannerWidget.c"
}

static GType
avatar_banner_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AvatarBannerWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) avatar_banner_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AvatarBannerWidget), 0, (GInstanceInitFunc) avatar_banner_widget_instance_init, NULL };
	GType avatar_banner_widget_type_id;
	avatar_banner_widget_type_id = g_type_register_static (gtk_container_get_type (), "AvatarBannerWidget", &g_define_type_info, 0);
	AvatarBannerWidget_private_offset = g_type_add_instance_private (avatar_banner_widget_type_id, sizeof (AvatarBannerWidgetPrivate));
	return avatar_banner_widget_type_id;
}

GType
avatar_banner_widget_get_type (void)
{
	static volatile gsize avatar_banner_widget_type_id__once = 0;
	if (g_once_init_enter (&avatar_banner_widget_type_id__once)) {
		GType avatar_banner_widget_type_id;
		avatar_banner_widget_type_id = avatar_banner_widget_get_type_once ();
		g_once_init_leave (&avatar_banner_widget_type_id__once, avatar_banner_widget_type_id);
	}
	return avatar_banner_widget_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

