/* AvatarWidget.c generated by valac 0.56.14, the Vala compiler
 * generated from AvatarWidget.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "cawbird.h"
#include <glib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>

#define AVATAR_WIDGET_SMALL 0
#define AVATAR_WIDGET_LARGE 1
#define AVATAR_WIDGET_OVERLAP_DIST 40
#define TRANSITION_DURATION (200 * 1000)

enum  {
	AVATAR_WIDGET_0_PROPERTY,
	AVATAR_WIDGET_MAKE_ROUND_PROPERTY,
	AVATAR_WIDGET_VERIFIED_PROPERTY,
	AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY,
	AVATAR_WIDGET_OVERLAP_PROPERTY,
	AVATAR_WIDGET_SIZE_PROPERTY,
	AVATAR_WIDGET_SURFACE_PROPERTY,
	AVATAR_WIDGET_NUM_PROPERTIES
};
static GParamSpec* avatar_widget_properties[AVATAR_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AvatarWidgetPrivate {
	gboolean _round;
	gboolean _verified;
	gboolean _protected_account;
	gboolean _overlap;
	gint _size;
	cairo_surface_t* _surface;
	gdouble alpha;
	gint64 start_time;
};

static gint AvatarWidget_private_offset;
static gpointer avatar_widget_parent_class = NULL;
static cairo_surface_t** avatar_widget_verified_icons;
static gint avatar_widget_verified_icons_length1;
static cairo_surface_t** avatar_widget_verified_icons = NULL;
static gint avatar_widget_verified_icons_length1 = 0;
static gint _avatar_widget_verified_icons_size_ = 0;
static cairo_surface_t** avatar_widget_protected_account_icons;
static gint avatar_widget_protected_account_icons_length1;
static cairo_surface_t** avatar_widget_protected_account_icons = NULL;
static gint avatar_widget_protected_account_icons_length1 = 0;
static gint _avatar_widget_protected_account_icons_size_ = 0;

static void avatar_widget_start_animation (AvatarWidget* self);
static gboolean avatar_widget_fade_in_cb (AvatarWidget* self,
                                   GtkWidget* widget,
                                   GdkFrameClock* frame_clock);
static gboolean _avatar_widget_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                                      GdkFrameClock* frame_clock,
                                                      gpointer self);
VALA_EXTERN gdouble ease_out_cubic (gdouble t);
static gboolean avatar_widget_real_draw (GtkWidget* base,
                                  cairo_t* ctx);
static void avatar_widget_real_size_allocate (GtkWidget* base,
                                       GtkAllocation* alloc);
static void avatar_widget_real_get_preferred_width (GtkWidget* base,
                                             gint* min,
                                             gint* nat);
static void avatar_widget_real_get_preferred_height (GtkWidget* base,
                                              gint* min,
                                              gint* nat);
static GObject * avatar_widget_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void avatar_widget_finalize (GObject * obj);
static GType avatar_widget_get_type_once (void);
static void _vala_avatar_widget_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_avatar_widget_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gint AVATAR_WIDGET_VERIFIED_SIZES[2] = {12, 25};
static const gint AVATAR_WIDGET_PROTECTED_ACCOUNT_SIZES[2] = {16, 32};

static inline gpointer
avatar_widget_get_instance_private (AvatarWidget* self)
{
	return G_STRUCT_MEMBER_P (self, AvatarWidget_private_offset);
}

static gboolean
_avatar_widget_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                             GdkFrameClock* frame_clock,
                                             gpointer self)
{
	gboolean result;
	result = avatar_widget_fade_in_cb ((AvatarWidget*) self, widget, frame_clock);
#line 141 "../src/widgets/AvatarWidget.vala"
	return result;
#line 144 "AvatarWidget.c"
}

static void
avatar_widget_start_animation (AvatarWidget* self)
{
	GdkFrameClock* _tmp0_;
#line 135 "../src/widgets/AvatarWidget.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/widgets/AvatarWidget.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
#line 137 "../src/widgets/AvatarWidget.vala"
		return;
#line 157 "AvatarWidget.c"
	}
#line 139 "../src/widgets/AvatarWidget.vala"
	self->priv->alpha = 0.0;
#line 140 "../src/widgets/AvatarWidget.vala"
	_tmp0_ = gtk_widget_get_frame_clock ((GtkWidget*) self);
#line 140 "../src/widgets/AvatarWidget.vala"
	self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp0_);
#line 141 "../src/widgets/AvatarWidget.vala"
	gtk_widget_add_tick_callback ((GtkWidget*) self, _avatar_widget_fade_in_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 167 "AvatarWidget.c"
}

static gboolean
avatar_widget_fade_in_cb (AvatarWidget* self,
                          GtkWidget* widget,
                          GdkFrameClock* frame_clock)
{
	gint64 now = 0LL;
	gdouble t = 0.0;
	gboolean result;
#line 144 "../src/widgets/AvatarWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 144 "../src/widgets/AvatarWidget.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 144 "../src/widgets/AvatarWidget.vala"
	g_return_val_if_fail (frame_clock != NULL, FALSE);
#line 145 "../src/widgets/AvatarWidget.vala"
	now = gdk_frame_clock_get_frame_time (frame_clock);
#line 146 "../src/widgets/AvatarWidget.vala"
	t = (now - self->priv->start_time) / ((gdouble) TRANSITION_DURATION);
#line 148 "../src/widgets/AvatarWidget.vala"
	if (t >= 1.0) {
#line 149 "../src/widgets/AvatarWidget.vala"
		t = 1.0;
#line 192 "AvatarWidget.c"
	}
#line 152 "../src/widgets/AvatarWidget.vala"
	self->priv->alpha = ease_out_cubic (t);
#line 153 "../src/widgets/AvatarWidget.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 155 "../src/widgets/AvatarWidget.vala"
	result = t < 1.0;
#line 155 "../src/widgets/AvatarWidget.vala"
	return result;
#line 202 "AvatarWidget.c"
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 221 "../src/widgets/AvatarWidget.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 210 "AvatarWidget.c"
}

static gboolean
avatar_widget_real_draw (GtkWidget* base,
                         cairo_t* ctx)
{
	AvatarWidget * self;
	gint width = 0;
	gint _tmp0_;
	gint height = 0;
	gint _tmp1_;
	cairo_surface_t* _tmp2_;
	gdouble surface_scale = 0.0;
	cairo_surface_t* _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_t* ct = NULL;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	gdouble scale = 0.0;
	cairo_surface_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_surface_t* _tmp14_;
	cairo_t* _tmp15_;
	gint y = 0;
	gboolean _tmp16_;
	cairo_surface_t* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp31_;
	gboolean result;
#line 160 "../src/widgets/AvatarWidget.vala"
	self = (AvatarWidget*) base;
#line 160 "../src/widgets/AvatarWidget.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 161 "../src/widgets/AvatarWidget.vala"
	_tmp0_ = self->priv->_size;
#line 161 "../src/widgets/AvatarWidget.vala"
	width = _tmp0_;
#line 162 "../src/widgets/AvatarWidget.vala"
	_tmp1_ = self->priv->_size;
#line 162 "../src/widgets/AvatarWidget.vala"
	height = _tmp1_;
#line 164 "../src/widgets/AvatarWidget.vala"
	_tmp2_ = self->priv->_surface;
#line 164 "../src/widgets/AvatarWidget.vala"
	if (_tmp2_ == NULL) {
#line 165 "../src/widgets/AvatarWidget.vala"
		result = GDK_EVENT_PROPAGATE;
#line 165 "../src/widgets/AvatarWidget.vala"
		return result;
#line 266 "AvatarWidget.c"
	}
#line 169 "../src/widgets/AvatarWidget.vala"
	_tmp3_ = self->priv->_surface;
#line 169 "../src/widgets/AvatarWidget.vala"
	cairo_surface_get_device_scale (_tmp3_, &_tmp4_, &_tmp5_);
#line 169 "../src/widgets/AvatarWidget.vala"
	surface_scale = _tmp4_;
#line 169 "../src/widgets/AvatarWidget.vala"
	surface_scale = _tmp5_;
#line 171 "../src/widgets/AvatarWidget.vala"
	if (width != height) {
#line 172 "../src/widgets/AvatarWidget.vala"
		g_warning ("AvatarWidget.vala:172: Avatar with mapped with width %d and height %d", width, height);
#line 280 "AvatarWidget.c"
	}
#line 175 "../src/widgets/AvatarWidget.vala"
	_tmp6_ = cairo_get_target (ctx);
#line 175 "../src/widgets/AvatarWidget.vala"
	_tmp7_ = cairo_surface_create_similar (_tmp6_, CAIRO_CONTENT_COLOR_ALPHA, width, height);
#line 175 "../src/widgets/AvatarWidget.vala"
	surface = _tmp7_;
#line 178 "../src/widgets/AvatarWidget.vala"
	_tmp8_ = surface;
#line 178 "../src/widgets/AvatarWidget.vala"
	_tmp9_ = cairo_create (_tmp8_);
#line 178 "../src/widgets/AvatarWidget.vala"
	ct = _tmp9_;
#line 180 "../src/widgets/AvatarWidget.vala"
	_tmp10_ = self->priv->_surface;
#line 180 "../src/widgets/AvatarWidget.vala"
	scale = ((gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self)) / ((gdouble) (cairo_image_surface_get_width (_tmp10_) / surface_scale));
#line 183 "../src/widgets/AvatarWidget.vala"
	_tmp11_ = ct;
#line 183 "../src/widgets/AvatarWidget.vala"
	cairo_rectangle (_tmp11_, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height);
#line 184 "../src/widgets/AvatarWidget.vala"
	_tmp12_ = ct;
#line 184 "../src/widgets/AvatarWidget.vala"
	cairo_scale (_tmp12_, scale, scale);
#line 185 "../src/widgets/AvatarWidget.vala"
	_tmp13_ = ct;
#line 185 "../src/widgets/AvatarWidget.vala"
	_tmp14_ = self->priv->_surface;
#line 185 "../src/widgets/AvatarWidget.vala"
	cairo_set_source_surface (_tmp13_, _tmp14_, (gdouble) 0, (gdouble) 0);
#line 186 "../src/widgets/AvatarWidget.vala"
	_tmp15_ = ct;
#line 186 "../src/widgets/AvatarWidget.vala"
	cairo_fill (_tmp15_);
#line 189 "../src/widgets/AvatarWidget.vala"
	_tmp16_ = self->priv->_overlap;
#line 189 "../src/widgets/AvatarWidget.vala"
	if (_tmp16_) {
#line 190 "../src/widgets/AvatarWidget.vala"
		y = -AVATAR_WIDGET_OVERLAP_DIST;
#line 322 "AvatarWidget.c"
	} else {
#line 192 "../src/widgets/AvatarWidget.vala"
		y = 0;
#line 326 "AvatarWidget.c"
	}
#line 194 "../src/widgets/AvatarWidget.vala"
	if (self->priv->_round) {
#line 330 "AvatarWidget.c"
		cairo_t* _tmp17_;
		cairo_t* _tmp18_;
		cairo_t* _tmp19_;
		cairo_t* _tmp20_;
		GtkStyleContext* _tmp21_;
#line 195 "../src/widgets/AvatarWidget.vala"
		_tmp17_ = ct;
#line 195 "../src/widgets/AvatarWidget.vala"
		cairo_scale (_tmp17_, 1.0 / scale, 1.0 / scale);
#line 196 "../src/widgets/AvatarWidget.vala"
		_tmp18_ = ct;
#line 196 "../src/widgets/AvatarWidget.vala"
		cairo_set_operator (_tmp18_, CAIRO_OPERATOR_DEST_IN);
#line 197 "../src/widgets/AvatarWidget.vala"
		_tmp19_ = ct;
#line 197 "../src/widgets/AvatarWidget.vala"
		cairo_arc (_tmp19_, width / 2.0, height / 2.0, (width / 2.0) - 0.5, (gdouble) 0, 2 * G_PI);
#line 201 "../src/widgets/AvatarWidget.vala"
		_tmp20_ = ct;
#line 201 "../src/widgets/AvatarWidget.vala"
		cairo_fill (_tmp20_);
#line 203 "../src/widgets/AvatarWidget.vala"
		_tmp21_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 203 "../src/widgets/AvatarWidget.vala"
		gtk_render_frame (_tmp21_, ctx, (gdouble) 0, (gdouble) y, (gdouble) width, (gdouble) height);
#line 356 "AvatarWidget.c"
	}
#line 207 "../src/widgets/AvatarWidget.vala"
	_tmp22_ = surface;
#line 207 "../src/widgets/AvatarWidget.vala"
	cairo_set_source_surface (ctx, _tmp22_, (gdouble) 0, (gdouble) y);
#line 208 "../src/widgets/AvatarWidget.vala"
	cairo_paint_with_alpha (ctx, self->priv->alpha);
#line 210 "../src/widgets/AvatarWidget.vala"
	_tmp23_ = self->priv->_verified;
#line 210 "../src/widgets/AvatarWidget.vala"
	if (_tmp23_) {
#line 368 "AvatarWidget.c"
		gdouble verified_scale = 0.0;
		gint index = 0;
		gboolean _tmp24_ = FALSE;
		gint _tmp25_ = 0;
		gint scale_factor = 0;
		cairo_surface_t* verified_img = NULL;
		cairo_surface_t** _tmp26_;
		gint _tmp26__length1;
		cairo_surface_t* _tmp27_;
		cairo_surface_t* _tmp28_;
		cairo_surface_t* _tmp29_;
		gint _tmp30_;
#line 211 "../src/widgets/AvatarWidget.vala"
		verified_scale = 1.0;
#line 212 "../src/widgets/AvatarWidget.vala"
		index = AVATAR_WIDGET_SMALL;
#line 213 "../src/widgets/AvatarWidget.vala"
		if (width > 48) {
#line 214 "../src/widgets/AvatarWidget.vala"
			index = AVATAR_WIDGET_LARGE;
#line 389 "AvatarWidget.c"
		}
#line 216 "../src/widgets/AvatarWidget.vala"
		if (index == AVATAR_WIDGET_LARGE) {
#line 216 "../src/widgets/AvatarWidget.vala"
			_tmp24_ = self->priv->_size < 100;
#line 395 "AvatarWidget.c"
		} else {
#line 216 "../src/widgets/AvatarWidget.vala"
			_tmp24_ = FALSE;
#line 399 "AvatarWidget.c"
		}
#line 216 "../src/widgets/AvatarWidget.vala"
		if (_tmp24_) {
#line 217 "../src/widgets/AvatarWidget.vala"
			verified_scale = ((gdouble) self->priv->_size) / 100.0;
#line 405 "AvatarWidget.c"
		}
#line 220 "../src/widgets/AvatarWidget.vala"
		if (gtk_widget_get_scale_factor ((GtkWidget*) self) == 1) {
#line 220 "../src/widgets/AvatarWidget.vala"
			_tmp25_ = 0;
#line 411 "AvatarWidget.c"
		} else {
#line 220 "../src/widgets/AvatarWidget.vala"
			_tmp25_ = 1;
#line 415 "AvatarWidget.c"
		}
#line 220 "../src/widgets/AvatarWidget.vala"
		scale_factor = _tmp25_;
#line 221 "../src/widgets/AvatarWidget.vala"
		_tmp26_ = avatar_widget_verified_icons;
#line 221 "../src/widgets/AvatarWidget.vala"
		_tmp26__length1 = avatar_widget_verified_icons_length1;
#line 221 "../src/widgets/AvatarWidget.vala"
		_tmp27_ = _tmp26_[(scale_factor * 2) + index];
#line 221 "../src/widgets/AvatarWidget.vala"
		_tmp28_ = _cairo_surface_reference0 (_tmp27_);
#line 221 "../src/widgets/AvatarWidget.vala"
		verified_img = _tmp28_;
#line 222 "../src/widgets/AvatarWidget.vala"
		cairo_scale (ctx, verified_scale, verified_scale);
#line 223 "../src/widgets/AvatarWidget.vala"
		_tmp29_ = verified_img;
#line 223 "../src/widgets/AvatarWidget.vala"
		_tmp30_ = AVATAR_WIDGET_VERIFIED_SIZES[index];
#line 223 "../src/widgets/AvatarWidget.vala"
		cairo_set_source_surface (ctx, _tmp29_, (width - (_tmp30_ * verified_scale)) / verified_scale, (gdouble) y);
#line 226 "../src/widgets/AvatarWidget.vala"
		cairo_paint_with_alpha (ctx, self->priv->alpha);
#line 210 "../src/widgets/AvatarWidget.vala"
		_cairo_surface_destroy0 (verified_img);
#line 441 "AvatarWidget.c"
	}
#line 229 "../src/widgets/AvatarWidget.vala"
	_tmp31_ = self->priv->_protected_account;
#line 229 "../src/widgets/AvatarWidget.vala"
	if (_tmp31_) {
#line 447 "AvatarWidget.c"
		gdouble protected_scale = 0.0;
		gint index = 0;
		gboolean _tmp32_ = FALSE;
		gint _tmp33_ = 0;
		gint scale_factor = 0;
		cairo_surface_t* protected_account_img = NULL;
		cairo_surface_t** _tmp34_;
		gint _tmp34__length1;
		cairo_surface_t* _tmp35_;
		cairo_surface_t* _tmp36_;
		gdouble protected_y = 0.0;
		gint _tmp37_;
		gboolean _tmp38_;
		cairo_surface_t* _tmp39_;
		gint _tmp40_;
#line 230 "../src/widgets/AvatarWidget.vala"
		protected_scale = 1.0;
#line 231 "../src/widgets/AvatarWidget.vala"
		index = AVATAR_WIDGET_SMALL;
#line 232 "../src/widgets/AvatarWidget.vala"
		if (width > 48) {
#line 233 "../src/widgets/AvatarWidget.vala"
			index = AVATAR_WIDGET_LARGE;
#line 471 "AvatarWidget.c"
		}
#line 235 "../src/widgets/AvatarWidget.vala"
		if (index == AVATAR_WIDGET_LARGE) {
#line 235 "../src/widgets/AvatarWidget.vala"
			_tmp32_ = self->priv->_size < 100;
#line 477 "AvatarWidget.c"
		} else {
#line 235 "../src/widgets/AvatarWidget.vala"
			_tmp32_ = FALSE;
#line 481 "AvatarWidget.c"
		}
#line 235 "../src/widgets/AvatarWidget.vala"
		if (_tmp32_) {
#line 236 "../src/widgets/AvatarWidget.vala"
			protected_scale = ((gdouble) self->priv->_size) / 100.0;
#line 487 "AvatarWidget.c"
		}
#line 239 "../src/widgets/AvatarWidget.vala"
		if (gtk_widget_get_scale_factor ((GtkWidget*) self) == 1) {
#line 239 "../src/widgets/AvatarWidget.vala"
			_tmp33_ = 0;
#line 493 "AvatarWidget.c"
		} else {
#line 239 "../src/widgets/AvatarWidget.vala"
			_tmp33_ = 1;
#line 497 "AvatarWidget.c"
		}
#line 239 "../src/widgets/AvatarWidget.vala"
		scale_factor = _tmp33_;
#line 240 "../src/widgets/AvatarWidget.vala"
		_tmp34_ = avatar_widget_protected_account_icons;
#line 240 "../src/widgets/AvatarWidget.vala"
		_tmp34__length1 = avatar_widget_protected_account_icons_length1;
#line 240 "../src/widgets/AvatarWidget.vala"
		_tmp35_ = _tmp34_[(scale_factor * 2) + index];
#line 240 "../src/widgets/AvatarWidget.vala"
		_tmp36_ = _cairo_surface_reference0 (_tmp35_);
#line 240 "../src/widgets/AvatarWidget.vala"
		protected_account_img = _tmp36_;
#line 241 "../src/widgets/AvatarWidget.vala"
		cairo_scale (ctx, protected_scale, protected_scale);
#line 242 "../src/widgets/AvatarWidget.vala"
		_tmp37_ = AVATAR_WIDGET_PROTECTED_ACCOUNT_SIZES[index];
#line 242 "../src/widgets/AvatarWidget.vala"
		protected_y = (height - (_tmp37_ * protected_scale)) / protected_scale;
#line 244 "../src/widgets/AvatarWidget.vala"
		_tmp38_ = self->priv->_overlap;
#line 244 "../src/widgets/AvatarWidget.vala"
		if (_tmp38_) {
#line 245 "../src/widgets/AvatarWidget.vala"
			protected_y -= (gdouble) AVATAR_WIDGET_OVERLAP_DIST;
#line 523 "AvatarWidget.c"
		}
#line 247 "../src/widgets/AvatarWidget.vala"
		_tmp39_ = protected_account_img;
#line 247 "../src/widgets/AvatarWidget.vala"
		_tmp40_ = AVATAR_WIDGET_PROTECTED_ACCOUNT_SIZES[index];
#line 247 "../src/widgets/AvatarWidget.vala"
		cairo_set_source_surface (ctx, _tmp39_, (width - (_tmp40_ * protected_scale)) / protected_scale, protected_y);
#line 250 "../src/widgets/AvatarWidget.vala"
		cairo_paint_with_alpha (ctx, self->priv->alpha);
#line 229 "../src/widgets/AvatarWidget.vala"
		_cairo_surface_destroy0 (protected_account_img);
#line 535 "AvatarWidget.c"
	}
#line 253 "../src/widgets/AvatarWidget.vala"
	result = GDK_EVENT_PROPAGATE;
#line 253 "../src/widgets/AvatarWidget.vala"
	_cairo_destroy0 (ct);
#line 253 "../src/widgets/AvatarWidget.vala"
	_cairo_surface_destroy0 (surface);
#line 253 "../src/widgets/AvatarWidget.vala"
	return result;
#line 545 "AvatarWidget.c"
}

static void
avatar_widget_real_size_allocate (GtkWidget* base,
                                  GtkAllocation* alloc)
{
	AvatarWidget * self;
	GtkAllocation _tmp0_;
	gboolean _tmp1_;
#line 256 "../src/widgets/AvatarWidget.vala"
	self = (AvatarWidget*) base;
#line 256 "../src/widgets/AvatarWidget.vala"
	g_return_if_fail (alloc != NULL);
#line 257 "../src/widgets/AvatarWidget.vala"
	_tmp0_ = *alloc;
#line 257 "../src/widgets/AvatarWidget.vala"
	GTK_WIDGET_CLASS (avatar_widget_parent_class)->size_allocate (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), &_tmp0_);
#line 259 "../src/widgets/AvatarWidget.vala"
	_tmp1_ = self->priv->_overlap;
#line 259 "../src/widgets/AvatarWidget.vala"
	if (_tmp1_) {
#line 567 "AvatarWidget.c"
		GtkAllocation _tmp2_;
#line 260 "../src/widgets/AvatarWidget.vala"
		(*alloc).y = (*alloc).y - AVATAR_WIDGET_OVERLAP_DIST;
#line 261 "../src/widgets/AvatarWidget.vala"
		(*alloc).height = (*alloc).height + AVATAR_WIDGET_OVERLAP_DIST;
#line 262 "../src/widgets/AvatarWidget.vala"
		_tmp2_ = *alloc;
#line 262 "../src/widgets/AvatarWidget.vala"
		gtk_widget_set_clip ((GtkWidget*) self, &_tmp2_);
#line 577 "AvatarWidget.c"
	}
}

static void
avatar_widget_real_get_preferred_width (GtkWidget* base,
                                        gint* min,
                                        gint* nat)
{
	AvatarWidget * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 266 "../src/widgets/AvatarWidget.vala"
	self = (AvatarWidget*) base;
#line 267 "../src/widgets/AvatarWidget.vala"
	_tmp0_ = self->priv->_size;
#line 267 "../src/widgets/AvatarWidget.vala"
	_vala_min = _tmp0_;
#line 268 "../src/widgets/AvatarWidget.vala"
	_tmp1_ = self->priv->_size;
#line 268 "../src/widgets/AvatarWidget.vala"
	_vala_nat = _tmp1_;
#line 266 "../src/widgets/AvatarWidget.vala"
	if (min) {
#line 266 "../src/widgets/AvatarWidget.vala"
		*min = _vala_min;
#line 605 "AvatarWidget.c"
	}
#line 266 "../src/widgets/AvatarWidget.vala"
	if (nat) {
#line 266 "../src/widgets/AvatarWidget.vala"
		*nat = _vala_nat;
#line 611 "AvatarWidget.c"
	}
}

static void
avatar_widget_real_get_preferred_height (GtkWidget* base,
                                         gint* min,
                                         gint* nat)
{
	AvatarWidget * self;
	gint _vala_min = 0;
	gint _vala_nat = 0;
	gboolean _tmp0_;
#line 271 "../src/widgets/AvatarWidget.vala"
	self = (AvatarWidget*) base;
#line 272 "../src/widgets/AvatarWidget.vala"
	_tmp0_ = self->priv->_overlap;
#line 272 "../src/widgets/AvatarWidget.vala"
	if (_tmp0_) {
#line 630 "AvatarWidget.c"
		gint _tmp1_;
		gint _tmp2_;
#line 273 "../src/widgets/AvatarWidget.vala"
		_tmp1_ = self->priv->_size;
#line 273 "../src/widgets/AvatarWidget.vala"
		_vala_min = _tmp1_ - AVATAR_WIDGET_OVERLAP_DIST;
#line 274 "../src/widgets/AvatarWidget.vala"
		_tmp2_ = self->priv->_size;
#line 274 "../src/widgets/AvatarWidget.vala"
		_vala_nat = _tmp2_ - AVATAR_WIDGET_OVERLAP_DIST;
#line 641 "AvatarWidget.c"
	} else {
		gint _tmp3_;
		gint _tmp4_;
#line 276 "../src/widgets/AvatarWidget.vala"
		_tmp3_ = self->priv->_size;
#line 276 "../src/widgets/AvatarWidget.vala"
		_vala_min = _tmp3_;
#line 277 "../src/widgets/AvatarWidget.vala"
		_tmp4_ = self->priv->_size;
#line 277 "../src/widgets/AvatarWidget.vala"
		_vala_nat = _tmp4_;
#line 653 "AvatarWidget.c"
	}
#line 271 "../src/widgets/AvatarWidget.vala"
	if (min) {
#line 271 "../src/widgets/AvatarWidget.vala"
		*min = _vala_min;
#line 659 "AvatarWidget.c"
	}
#line 271 "../src/widgets/AvatarWidget.vala"
	if (nat) {
#line 271 "../src/widgets/AvatarWidget.vala"
		*nat = _vala_nat;
#line 665 "AvatarWidget.c"
	}
}

AvatarWidget*
avatar_widget_construct (GType object_type)
{
	AvatarWidget * self = NULL;
#line 18 "../src/widgets/AvatarWidget.vala"
	self = (AvatarWidget*) gtk_widget_new (object_type, NULL);
#line 18 "../src/widgets/AvatarWidget.vala"
	return self;
#line 677 "AvatarWidget.c"
}

AvatarWidget*
avatar_widget_new (void)
{
#line 18 "../src/widgets/AvatarWidget.vala"
	return avatar_widget_construct (TYPE_AVATAR_WIDGET);
#line 685 "AvatarWidget.c"
}

gboolean
avatar_widget_get_make_round (AvatarWidget* self)
{
	gboolean result;
#line 24 "../src/widgets/AvatarWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/widgets/AvatarWidget.vala"
	result = self->priv->_round;
#line 25 "../src/widgets/AvatarWidget.vala"
	return result;
#line 698 "AvatarWidget.c"
}

void
avatar_widget_set_make_round (AvatarWidget* self,
                              gboolean value)
{
#line 27 "../src/widgets/AvatarWidget.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/widgets/AvatarWidget.vala"
	if (value == self->priv->_round) {
#line 29 "../src/widgets/AvatarWidget.vala"
		return;
#line 711 "AvatarWidget.c"
	}
#line 31 "../src/widgets/AvatarWidget.vala"
	if (value) {
#line 715 "AvatarWidget.c"
		GtkStyleContext* _tmp0_;
#line 32 "../src/widgets/AvatarWidget.vala"
		_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 32 "../src/widgets/AvatarWidget.vala"
		gtk_style_context_add_class (_tmp0_, "avatar-round");
#line 721 "AvatarWidget.c"
	} else {
		GtkStyleContext* _tmp1_;
#line 34 "../src/widgets/AvatarWidget.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 34 "../src/widgets/AvatarWidget.vala"
		gtk_style_context_remove_class (_tmp1_, "avatar-round");
#line 728 "AvatarWidget.c"
	}
#line 37 "../src/widgets/AvatarWidget.vala"
	self->priv->_round = value;
#line 38 "../src/widgets/AvatarWidget.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 27 "../src/widgets/AvatarWidget.vala"
	g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_MAKE_ROUND_PROPERTY]);
#line 736 "AvatarWidget.c"
}

gboolean
avatar_widget_get_verified (AvatarWidget* self)
{
	gboolean result;
#line 41 "../src/widgets/AvatarWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/widgets/AvatarWidget.vala"
	result = self->priv->_verified;
#line 41 "../src/widgets/AvatarWidget.vala"
	return result;
#line 749 "AvatarWidget.c"
}

void
avatar_widget_set_verified (AvatarWidget* self,
                            gboolean value)
{
	gboolean old_value;
#line 41 "../src/widgets/AvatarWidget.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/widgets/AvatarWidget.vala"
	old_value = avatar_widget_get_verified (self);
#line 41 "../src/widgets/AvatarWidget.vala"
	if (old_value != value) {
#line 41 "../src/widgets/AvatarWidget.vala"
		self->priv->_verified = value;
#line 41 "../src/widgets/AvatarWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_VERIFIED_PROPERTY]);
#line 767 "AvatarWidget.c"
	}
}

gboolean
avatar_widget_get_protected_account (AvatarWidget* self)
{
	gboolean result;
#line 42 "../src/widgets/AvatarWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/widgets/AvatarWidget.vala"
	result = self->priv->_protected_account;
#line 42 "../src/widgets/AvatarWidget.vala"
	return result;
#line 781 "AvatarWidget.c"
}

void
avatar_widget_set_protected_account (AvatarWidget* self,
                                     gboolean value)
{
	gboolean old_value;
#line 42 "../src/widgets/AvatarWidget.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/widgets/AvatarWidget.vala"
	old_value = avatar_widget_get_protected_account (self);
#line 42 "../src/widgets/AvatarWidget.vala"
	if (old_value != value) {
#line 42 "../src/widgets/AvatarWidget.vala"
		self->priv->_protected_account = value;
#line 42 "../src/widgets/AvatarWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY]);
#line 799 "AvatarWidget.c"
	}
}

gboolean
avatar_widget_get_overlap (AvatarWidget* self)
{
	gboolean result;
#line 43 "../src/widgets/AvatarWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/widgets/AvatarWidget.vala"
	result = self->priv->_overlap;
#line 43 "../src/widgets/AvatarWidget.vala"
	return result;
#line 813 "AvatarWidget.c"
}

void
avatar_widget_set_overlap (AvatarWidget* self,
                           gboolean value)
{
	gboolean old_value;
#line 43 "../src/widgets/AvatarWidget.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/widgets/AvatarWidget.vala"
	old_value = avatar_widget_get_overlap (self);
#line 43 "../src/widgets/AvatarWidget.vala"
	if (old_value != value) {
#line 43 "../src/widgets/AvatarWidget.vala"
		self->priv->_overlap = value;
#line 43 "../src/widgets/AvatarWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_OVERLAP_PROPERTY]);
#line 831 "AvatarWidget.c"
	}
}

gint
avatar_widget_get_size (AvatarWidget* self)
{
	gint result;
#line 44 "../src/widgets/AvatarWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/widgets/AvatarWidget.vala"
	result = self->priv->_size;
#line 44 "../src/widgets/AvatarWidget.vala"
	return result;
#line 845 "AvatarWidget.c"
}

void
avatar_widget_set_size (AvatarWidget* self,
                        gint value)
{
	gint old_value;
#line 44 "../src/widgets/AvatarWidget.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/widgets/AvatarWidget.vala"
	old_value = avatar_widget_get_size (self);
#line 44 "../src/widgets/AvatarWidget.vala"
	if (old_value != value) {
#line 44 "../src/widgets/AvatarWidget.vala"
		self->priv->_size = value;
#line 44 "../src/widgets/AvatarWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_SIZE_PROPERTY]);
#line 863 "AvatarWidget.c"
	}
}

cairo_surface_t*
avatar_widget_get_surface (AvatarWidget* self)
{
	cairo_surface_t* result;
	cairo_surface_t* _tmp0_;
#line 48 "../src/widgets/AvatarWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/widgets/AvatarWidget.vala"
	_tmp0_ = self->priv->_surface;
#line 49 "../src/widgets/AvatarWidget.vala"
	result = _tmp0_;
#line 49 "../src/widgets/AvatarWidget.vala"
	return result;
#line 880 "AvatarWidget.c"
}

void
avatar_widget_set_surface (AvatarWidget* self,
                           cairo_surface_t* value)
{
	cairo_surface_t* _tmp0_;
	gboolean animate = FALSE;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp5_;
	cairo_surface_t* _tmp6_;
#line 51 "../src/widgets/AvatarWidget.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/widgets/AvatarWidget.vala"
	_tmp0_ = self->priv->_surface;
#line 52 "../src/widgets/AvatarWidget.vala"
	if (_tmp0_ == value) {
#line 52 "../src/widgets/AvatarWidget.vala"
		return;
#line 900 "AvatarWidget.c"
	}
#line 54 "../src/widgets/AvatarWidget.vala"
	animate = FALSE;
#line 56 "../src/widgets/AvatarWidget.vala"
	_tmp1_ = self->priv->_surface;
#line 56 "../src/widgets/AvatarWidget.vala"
	if (_tmp1_ != NULL) {
#line 908 "AvatarWidget.c"
		Twitter* _tmp2_;
		Twitter* _tmp3_;
		cairo_surface_t* _tmp4_;
#line 57 "../src/widgets/AvatarWidget.vala"
		_tmp2_ = twitter_get ();
#line 57 "../src/widgets/AvatarWidget.vala"
		_tmp3_ = _tmp2_;
#line 57 "../src/widgets/AvatarWidget.vala"
		_tmp4_ = self->priv->_surface;
#line 57 "../src/widgets/AvatarWidget.vala"
		twitter_unref_avatar (_tmp3_, _tmp4_);
#line 57 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp3_);
#line 922 "AvatarWidget.c"
	} else {
#line 59 "../src/widgets/AvatarWidget.vala"
		animate = TRUE;
#line 926 "AvatarWidget.c"
	}
#line 61 "../src/widgets/AvatarWidget.vala"
	_tmp5_ = _cairo_surface_reference0 ((cairo_surface_t*) value);
#line 61 "../src/widgets/AvatarWidget.vala"
	_cairo_surface_destroy0 (self->priv->_surface);
#line 61 "../src/widgets/AvatarWidget.vala"
	self->priv->_surface = _tmp5_;
#line 63 "../src/widgets/AvatarWidget.vala"
	_tmp6_ = self->priv->_surface;
#line 63 "../src/widgets/AvatarWidget.vala"
	if (_tmp6_ != NULL) {
#line 938 "AvatarWidget.c"
		Twitter* _tmp7_;
		Twitter* _tmp8_;
		cairo_surface_t* _tmp9_;
#line 64 "../src/widgets/AvatarWidget.vala"
		_tmp7_ = twitter_get ();
#line 64 "../src/widgets/AvatarWidget.vala"
		_tmp8_ = _tmp7_;
#line 64 "../src/widgets/AvatarWidget.vala"
		_tmp9_ = self->priv->_surface;
#line 64 "../src/widgets/AvatarWidget.vala"
		twitter_ref_avatar (_tmp8_, _tmp9_);
#line 64 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp8_);
#line 65 "../src/widgets/AvatarWidget.vala"
		if (animate) {
#line 66 "../src/widgets/AvatarWidget.vala"
			avatar_widget_start_animation (self);
#line 956 "AvatarWidget.c"
		}
	}
#line 69 "../src/widgets/AvatarWidget.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 51 "../src/widgets/AvatarWidget.vala"
	g_object_notify_by_pspec ((GObject *) self, avatar_widget_properties[AVATAR_WIDGET_SURFACE_PROPERTY]);
#line 963 "AvatarWidget.c"
}

static GObject *
avatar_widget_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AvatarWidget * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
#line 121 "../src/widgets/AvatarWidget.vala"
	parent_class = G_OBJECT_CLASS (avatar_widget_parent_class);
#line 121 "../src/widgets/AvatarWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 121 "../src/widgets/AvatarWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AVATAR_WIDGET, AvatarWidget);
#line 122 "../src/widgets/AvatarWidget.vala"
	gtk_widget_set_has_window ((GtkWidget*) self, FALSE);
#line 123 "../src/widgets/AvatarWidget.vala"
	_tmp0_ = settings_get ();
#line 123 "../src/widgets/AvatarWidget.vala"
	_tmp1_ = _tmp0_;
#line 123 "../src/widgets/AvatarWidget.vala"
	g_settings_bind (_tmp1_, "round-avatars", (GObject*) self, "make_round", G_SETTINGS_BIND_DEFAULT);
#line 123 "../src/widgets/AvatarWidget.vala"
	_g_object_unref0 (_tmp1_);
#line 125 "../src/widgets/AvatarWidget.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 125 "../src/widgets/AvatarWidget.vala"
	gtk_style_context_add_class (_tmp2_, "avatar");
#line 126 "../src/widgets/AvatarWidget.vala"
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 126 "../src/widgets/AvatarWidget.vala"
	gtk_style_context_add_class (_tmp3_, "avatar-round");
#line 121 "../src/widgets/AvatarWidget.vala"
	return obj;
#line 1004 "AvatarWidget.c"
}

static void
avatar_widget_class_init (AvatarWidgetClass * klass,
                          gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 18 "../src/widgets/AvatarWidget.vala"
	avatar_widget_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/AvatarWidget.vala"
	g_type_class_adjust_private_offset (klass, &AvatarWidget_private_offset);
#line 18 "../src/widgets/AvatarWidget.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) avatar_widget_real_draw;
#line 18 "../src/widgets/AvatarWidget.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) avatar_widget_real_size_allocate;
#line 18 "../src/widgets/AvatarWidget.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) avatar_widget_real_get_preferred_width;
#line 18 "../src/widgets/AvatarWidget.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) avatar_widget_real_get_preferred_height;
#line 18 "../src/widgets/AvatarWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_avatar_widget_get_property;
#line 18 "../src/widgets/AvatarWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_avatar_widget_set_property;
#line 18 "../src/widgets/AvatarWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = avatar_widget_constructor;
#line 18 "../src/widgets/AvatarWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = avatar_widget_finalize;
#line 18 "../src/widgets/AvatarWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_MAKE_ROUND_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_MAKE_ROUND_PROPERTY] = g_param_spec_boolean ("make-round", "make-round", "make-round", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/widgets/AvatarWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_VERIFIED_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_VERIFIED_PROPERTY] = g_param_spec_boolean ("verified", "verified", "verified", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/widgets/AvatarWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY] = g_param_spec_boolean ("protected-account", "protected-account", "protected-account", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/widgets/AvatarWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_OVERLAP_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_OVERLAP_PROPERTY] = g_param_spec_boolean ("overlap", "overlap", "overlap", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/widgets/AvatarWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_SIZE_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 48, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/widgets/AvatarWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), AVATAR_WIDGET_SURFACE_PROPERTY, avatar_widget_properties[AVATAR_WIDGET_SURFACE_PROPERTY] = g_param_spec_boxed ("surface", "surface", "surface", cairo_gobject_surface_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1044 "AvatarWidget.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_ = NULL;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_ = NULL;
		GdkPixbuf* _tmp7_;
		cairo_surface_t* _tmp8_;
		cairo_surface_t* _tmp9_;
		cairo_surface_t* _tmp10_;
		cairo_surface_t* _tmp11_;
		cairo_surface_t** _tmp12_;
#line 85 "../src/widgets/AvatarWidget.vala"
		_tmp1_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/verified-small.png", &_inner_error0_);
#line 85 "../src/widgets/AvatarWidget.vala"
		_tmp0_ = _tmp1_;
#line 85 "../src/widgets/AvatarWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1065 "AvatarWidget.c"
			goto __catch0_g_error;
		}
#line 88 "../src/widgets/AvatarWidget.vala"
		_tmp3_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/verified-large.png", &_inner_error0_);
#line 88 "../src/widgets/AvatarWidget.vala"
		_tmp2_ = _tmp3_;
#line 88 "../src/widgets/AvatarWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp0_);
#line 1076 "AvatarWidget.c"
			goto __catch0_g_error;
		}
#line 91 "../src/widgets/AvatarWidget.vala"
		_tmp5_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/verified-small@2.png", &_inner_error0_);
#line 91 "../src/widgets/AvatarWidget.vala"
		_tmp4_ = _tmp5_;
#line 91 "../src/widgets/AvatarWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp2_);
#line 91 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp0_);
#line 1089 "AvatarWidget.c"
			goto __catch0_g_error;
		}
#line 94 "../src/widgets/AvatarWidget.vala"
		_tmp7_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/verified-large@2.png", &_inner_error0_);
#line 94 "../src/widgets/AvatarWidget.vala"
		_tmp6_ = _tmp7_;
#line 94 "../src/widgets/AvatarWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp4_);
#line 94 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp2_);
#line 94 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp0_);
#line 1104 "AvatarWidget.c"
			goto __catch0_g_error;
		}
#line 83 "../src/widgets/AvatarWidget.vala"
		_tmp8_ = gdk_cairo_surface_create_from_pixbuf (_tmp0_, 1, NULL);
#line 83 "../src/widgets/AvatarWidget.vala"
		_tmp9_ = gdk_cairo_surface_create_from_pixbuf (_tmp2_, 1, NULL);
#line 83 "../src/widgets/AvatarWidget.vala"
		_tmp10_ = gdk_cairo_surface_create_from_pixbuf (_tmp4_, 2, NULL);
#line 83 "../src/widgets/AvatarWidget.vala"
		_tmp11_ = gdk_cairo_surface_create_from_pixbuf (_tmp6_, 2, NULL);
#line 83 "../src/widgets/AvatarWidget.vala"
		_tmp12_ = g_new0 (cairo_surface_t*, 4 + 1);
#line 83 "../src/widgets/AvatarWidget.vala"
		_tmp12_[0] = _tmp8_;
#line 83 "../src/widgets/AvatarWidget.vala"
		_tmp12_[1] = _tmp9_;
#line 83 "../src/widgets/AvatarWidget.vala"
		_tmp12_[2] = _tmp10_;
#line 83 "../src/widgets/AvatarWidget.vala"
		_tmp12_[3] = _tmp11_;
#line 83 "../src/widgets/AvatarWidget.vala"
		avatar_widget_verified_icons = (_vala_array_free (avatar_widget_verified_icons, avatar_widget_verified_icons_length1, (GDestroyNotify) cairo_surface_destroy), NULL);
#line 83 "../src/widgets/AvatarWidget.vala"
		avatar_widget_verified_icons = _tmp12_;
#line 83 "../src/widgets/AvatarWidget.vala"
		avatar_widget_verified_icons_length1 = 4;
#line 83 "../src/widgets/AvatarWidget.vala"
		_avatar_widget_verified_icons_size_ = avatar_widget_verified_icons_length1;
#line 82 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp6_);
#line 82 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp4_);
#line 82 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp2_);
#line 82 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp0_);
#line 1141 "AvatarWidget.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 82 "../src/widgets/AvatarWidget.vala"
		e = _inner_error0_;
#line 82 "../src/widgets/AvatarWidget.vala"
		_inner_error0_ = NULL;
#line 98 "../src/widgets/AvatarWidget.vala"
		_tmp13_ = e;
#line 98 "../src/widgets/AvatarWidget.vala"
		_tmp14_ = _tmp13_->message;
#line 98 "../src/widgets/AvatarWidget.vala"
		g_critical ("AvatarWidget.vala:98: %s", _tmp14_);
#line 82 "../src/widgets/AvatarWidget.vala"
		_g_error_free0 (e);
#line 1161 "AvatarWidget.c"
	}
	__finally0:
#line 82 "../src/widgets/AvatarWidget.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "../src/widgets/AvatarWidget.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 82 "../src/widgets/AvatarWidget.vala"
		g_clear_error (&_inner_error0_);
#line 1170 "AvatarWidget.c"
	}
	{
		GdkPixbuf* _tmp15_ = NULL;
		GdkPixbuf* _tmp16_;
		GdkPixbuf* _tmp17_ = NULL;
		GdkPixbuf* _tmp18_;
		GdkPixbuf* _tmp19_ = NULL;
		GdkPixbuf* _tmp20_;
		GdkPixbuf* _tmp21_ = NULL;
		GdkPixbuf* _tmp22_;
		cairo_surface_t* _tmp23_;
		cairo_surface_t* _tmp24_;
		cairo_surface_t* _tmp25_;
		cairo_surface_t* _tmp26_;
		cairo_surface_t** _tmp27_;
#line 104 "../src/widgets/AvatarWidget.vala"
		_tmp16_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/protected-account-small.png", &_inner_error0_);
#line 104 "../src/widgets/AvatarWidget.vala"
		_tmp15_ = _tmp16_;
#line 104 "../src/widgets/AvatarWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1192 "AvatarWidget.c"
			goto __catch1_g_error;
		}
#line 107 "../src/widgets/AvatarWidget.vala"
		_tmp18_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/protected-account-large.png", &_inner_error0_);
#line 107 "../src/widgets/AvatarWidget.vala"
		_tmp17_ = _tmp18_;
#line 107 "../src/widgets/AvatarWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 107 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp15_);
#line 1203 "AvatarWidget.c"
			goto __catch1_g_error;
		}
#line 110 "../src/widgets/AvatarWidget.vala"
		_tmp20_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/protected-account-small@2.png", &_inner_error0_);
#line 110 "../src/widgets/AvatarWidget.vala"
		_tmp19_ = _tmp20_;
#line 110 "../src/widgets/AvatarWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 110 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp17_);
#line 110 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp15_);
#line 1216 "AvatarWidget.c"
			goto __catch1_g_error;
		}
#line 113 "../src/widgets/AvatarWidget.vala"
		_tmp22_ = gdk_pixbuf_new_from_resource ("/uk/co/ibboard/cawbird/data/protected-account-large@2.png", &_inner_error0_);
#line 113 "../src/widgets/AvatarWidget.vala"
		_tmp21_ = _tmp22_;
#line 113 "../src/widgets/AvatarWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp19_);
#line 113 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp17_);
#line 113 "../src/widgets/AvatarWidget.vala"
			_g_object_unref0 (_tmp15_);
#line 1231 "AvatarWidget.c"
			goto __catch1_g_error;
		}
#line 102 "../src/widgets/AvatarWidget.vala"
		_tmp23_ = gdk_cairo_surface_create_from_pixbuf (_tmp15_, 1, NULL);
#line 102 "../src/widgets/AvatarWidget.vala"
		_tmp24_ = gdk_cairo_surface_create_from_pixbuf (_tmp17_, 1, NULL);
#line 102 "../src/widgets/AvatarWidget.vala"
		_tmp25_ = gdk_cairo_surface_create_from_pixbuf (_tmp19_, 2, NULL);
#line 102 "../src/widgets/AvatarWidget.vala"
		_tmp26_ = gdk_cairo_surface_create_from_pixbuf (_tmp21_, 2, NULL);
#line 102 "../src/widgets/AvatarWidget.vala"
		_tmp27_ = g_new0 (cairo_surface_t*, 4 + 1);
#line 102 "../src/widgets/AvatarWidget.vala"
		_tmp27_[0] = _tmp23_;
#line 102 "../src/widgets/AvatarWidget.vala"
		_tmp27_[1] = _tmp24_;
#line 102 "../src/widgets/AvatarWidget.vala"
		_tmp27_[2] = _tmp25_;
#line 102 "../src/widgets/AvatarWidget.vala"
		_tmp27_[3] = _tmp26_;
#line 102 "../src/widgets/AvatarWidget.vala"
		avatar_widget_protected_account_icons = (_vala_array_free (avatar_widget_protected_account_icons, avatar_widget_protected_account_icons_length1, (GDestroyNotify) cairo_surface_destroy), NULL);
#line 102 "../src/widgets/AvatarWidget.vala"
		avatar_widget_protected_account_icons = _tmp27_;
#line 102 "../src/widgets/AvatarWidget.vala"
		avatar_widget_protected_account_icons_length1 = 4;
#line 102 "../src/widgets/AvatarWidget.vala"
		_avatar_widget_protected_account_icons_size_ = avatar_widget_protected_account_icons_length1;
#line 101 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp21_);
#line 101 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp19_);
#line 101 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp17_);
#line 101 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp15_);
#line 1268 "AvatarWidget.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp28_;
		const gchar* _tmp29_;
#line 101 "../src/widgets/AvatarWidget.vala"
		e = _inner_error0_;
#line 101 "../src/widgets/AvatarWidget.vala"
		_inner_error0_ = NULL;
#line 117 "../src/widgets/AvatarWidget.vala"
		_tmp28_ = e;
#line 117 "../src/widgets/AvatarWidget.vala"
		_tmp29_ = _tmp28_->message;
#line 117 "../src/widgets/AvatarWidget.vala"
		g_critical ("AvatarWidget.vala:117: %s", _tmp29_);
#line 101 "../src/widgets/AvatarWidget.vala"
		_g_error_free0 (e);
#line 1288 "AvatarWidget.c"
	}
	__finally1:
#line 101 "../src/widgets/AvatarWidget.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 101 "../src/widgets/AvatarWidget.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 101 "../src/widgets/AvatarWidget.vala"
		g_clear_error (&_inner_error0_);
#line 1297 "AvatarWidget.c"
	}
}

static void
avatar_widget_instance_init (AvatarWidget * self,
                             gpointer klass)
{
#line 18 "../src/widgets/AvatarWidget.vala"
	self->priv = avatar_widget_get_instance_private (self);
#line 22 "../src/widgets/AvatarWidget.vala"
	self->priv->_round = TRUE;
#line 41 "../src/widgets/AvatarWidget.vala"
	self->priv->_verified = FALSE;
#line 42 "../src/widgets/AvatarWidget.vala"
	self->priv->_protected_account = FALSE;
#line 43 "../src/widgets/AvatarWidget.vala"
	self->priv->_overlap = FALSE;
#line 44 "../src/widgets/AvatarWidget.vala"
	self->priv->_size = 48;
#line 72 "../src/widgets/AvatarWidget.vala"
	self->priv->alpha = (gdouble) 1.0f;
#line 1319 "AvatarWidget.c"
}

static void
avatar_widget_finalize (GObject * obj)
{
	AvatarWidget * self;
	cairo_surface_t* _tmp0_;
#line 18 "../src/widgets/AvatarWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_AVATAR_WIDGET, AvatarWidget);
#line 130 "../src/widgets/AvatarWidget.vala"
	_tmp0_ = self->priv->_surface;
#line 130 "../src/widgets/AvatarWidget.vala"
	if (_tmp0_ != NULL) {
#line 1333 "AvatarWidget.c"
		Twitter* _tmp1_;
		Twitter* _tmp2_;
		cairo_surface_t* _tmp3_;
#line 131 "../src/widgets/AvatarWidget.vala"
		_tmp1_ = twitter_get ();
#line 131 "../src/widgets/AvatarWidget.vala"
		_tmp2_ = _tmp1_;
#line 131 "../src/widgets/AvatarWidget.vala"
		_tmp3_ = self->priv->_surface;
#line 131 "../src/widgets/AvatarWidget.vala"
		twitter_unref_avatar (_tmp2_, _tmp3_);
#line 131 "../src/widgets/AvatarWidget.vala"
		_g_object_unref0 (_tmp2_);
#line 1347 "AvatarWidget.c"
	}
#line 46 "../src/widgets/AvatarWidget.vala"
	_cairo_surface_destroy0 (self->priv->_surface);
#line 18 "../src/widgets/AvatarWidget.vala"
	G_OBJECT_CLASS (avatar_widget_parent_class)->finalize (obj);
#line 1353 "AvatarWidget.c"
}

static GType
avatar_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AvatarWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) avatar_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AvatarWidget), 0, (GInstanceInitFunc) avatar_widget_instance_init, NULL };
	GType avatar_widget_type_id;
	avatar_widget_type_id = g_type_register_static (gtk_widget_get_type (), "AvatarWidget", &g_define_type_info, 0);
	AvatarWidget_private_offset = g_type_add_instance_private (avatar_widget_type_id, sizeof (AvatarWidgetPrivate));
	return avatar_widget_type_id;
}

GType
avatar_widget_get_type (void)
{
	static volatile gsize avatar_widget_type_id__once = 0;
	if (g_once_init_enter (&avatar_widget_type_id__once)) {
		GType avatar_widget_type_id;
		avatar_widget_type_id = avatar_widget_get_type_once ();
		g_once_init_leave (&avatar_widget_type_id__once, avatar_widget_type_id);
	}
	return avatar_widget_type_id__once;
}

static void
_vala_avatar_widget_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	AvatarWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_AVATAR_WIDGET, AvatarWidget);
#line 18 "../src/widgets/AvatarWidget.vala"
	switch (property_id) {
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_MAKE_ROUND_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		g_value_set_boolean (value, avatar_widget_get_make_round (self));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_VERIFIED_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		g_value_set_boolean (value, avatar_widget_get_verified (self));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		g_value_set_boolean (value, avatar_widget_get_protected_account (self));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_OVERLAP_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		g_value_set_boolean (value, avatar_widget_get_overlap (self));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_SIZE_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		g_value_set_int (value, avatar_widget_get_size (self));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_SURFACE_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		g_value_set_boxed (value, avatar_widget_get_surface (self));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 1424 "AvatarWidget.c"
		default:
#line 18 "../src/widgets/AvatarWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 1430 "AvatarWidget.c"
	}
}

static void
_vala_avatar_widget_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	AvatarWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_AVATAR_WIDGET, AvatarWidget);
#line 18 "../src/widgets/AvatarWidget.vala"
	switch (property_id) {
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_MAKE_ROUND_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		avatar_widget_set_make_round (self, g_value_get_boolean (value));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_VERIFIED_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		avatar_widget_set_verified (self, g_value_get_boolean (value));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_PROTECTED_ACCOUNT_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		avatar_widget_set_protected_account (self, g_value_get_boolean (value));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_OVERLAP_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		avatar_widget_set_overlap (self, g_value_get_boolean (value));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_SIZE_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		avatar_widget_set_size (self, g_value_get_int (value));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 18 "../src/widgets/AvatarWidget.vala"
		case AVATAR_WIDGET_SURFACE_PROPERTY:
#line 18 "../src/widgets/AvatarWidget.vala"
		avatar_widget_set_surface (self, g_value_get_boxed (value));
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 1480 "AvatarWidget.c"
		default:
#line 18 "../src/widgets/AvatarWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/AvatarWidget.vala"
		break;
#line 1486 "AvatarWidget.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

