/* CropWidget.c generated by valac 0.56.14, the Vala compiler
 * generated from CropWidget.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <string.h>
#include "cawbird.h"

#define CROP_WIDGET_MIN_SIZE 48

#define TYPE_CROP_WIDGET (crop_widget_get_type ())
#define CROP_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CROP_WIDGET, CropWidget))
#define CROP_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CROP_WIDGET, CropWidgetClass))
#define IS_CROP_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CROP_WIDGET))
#define IS_CROP_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CROP_WIDGET))
#define CROP_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CROP_WIDGET, CropWidgetClass))

typedef struct _CropWidget CropWidget;
typedef struct _CropWidgetClass CropWidgetClass;
typedef struct _CropWidgetPrivate CropWidgetPrivate;
enum  {
	CROP_WIDGET_0_PROPERTY,
	CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY,
	CROP_WIDGET_NUM_PROPERTIES
};
static GParamSpec* crop_widget_properties[CROP_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CropWidget {
	GtkDrawingArea parent_instance;
	CropWidgetPrivate * priv;
};

struct _CropWidgetClass {
	GtkDrawingAreaClass parent_class;
};

struct _CropWidgetPrivate {
	GtkGestureDrag* drag_gesture;
	GdkPixbuf* image;
	GdkRectangle selection_rect;
	GdkRectangle image_rect;
	GdkCursor* drag_cursor;
	GdkCursor* default_cursor;
	GdkCursor* resize_cursor;
	gboolean selection_grabbed;
	gboolean resize_area_grabbed;
	gint drag_diff_x;
	gint drag_diff_y;
	gint resize_diff_x;
	gint resize_diff_y;
	gboolean resize_area_hovered;
	gdouble current_scale;
	gint min_width;
	gdouble drag_start_x;
	gdouble drag_start_y;
	gdouble _desired_aspect_ratio;
};

static gint CropWidget_private_offset;
static gpointer crop_widget_parent_class = NULL;

VALA_EXTERN GType crop_widget_get_type (void) G_GNUC_CONST ;
static gboolean crop_widget_mouse_motion_cb (CropWidget* self,
                                      GdkEventMotion* event);
static gboolean crop_widget_over_resize_area (CropWidget* self,
                                       gdouble x,
                                       gdouble y);
static inline void crop_widget_set_cursor (CropWidget* self,
                             GdkCursor* cursor);
static gboolean crop_widget_cursor_in_selection (CropWidget* self,
                                          gdouble x,
                                          gdouble y);
static void crop_widget_drag_gesture_update_cb (CropWidget* self,
                                         GtkGestureDrag* gesture,
                                         gdouble offset_x,
                                         gdouble offset_y);
static void crop_widget_resize_selection_rect (CropWidget* self,
                                        gdouble x,
                                        gdouble y);
static void crop_widget_drag_gesture_begin_cb (CropWidget* self,
                                        GtkGestureDrag* gesture,
                                        gdouble x,
                                        gdouble y);
static void crop_widget_drag_gesture_end_cb (CropWidget* self,
                                      GtkGestureDrag* gesture,
                                      gdouble offset_x,
                                      gdouble offset_y);
static inline void crop_widget_restrict_selection_size (CropWidget* self);
VALA_EXTERN gdouble crop_widget_get_desired_aspect_ratio (CropWidget* self);
VALA_EXTERN void crop_widget_set_image (CropWidget* self,
                            GdkPixbuf* image);
static void crop_widget_calculate_image_rect (CropWidget* self);
static gboolean crop_widget_real_draw (GtkWidget* base,
                                cairo_t* ct);
static void crop_widget_real_size_allocate (GtkWidget* base,
                                     GtkAllocation* alloc);
VALA_EXTERN GdkPixbuf* crop_widget_get_cropped_image (CropWidget* self);
VALA_EXTERN void crop_widget_set_min_size (CropWidget* self,
                               gint min_width);
VALA_EXTERN CropWidget* crop_widget_new (void);
VALA_EXTERN CropWidget* crop_widget_construct (GType object_type);
VALA_EXTERN void crop_widget_set_desired_aspect_ratio (CropWidget* self,
                                           gdouble value);
static GObject * crop_widget_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static gboolean _crop_widget_mouse_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                      GdkEventMotion* event,
                                                                      gpointer self);
static void _crop_widget_drag_gesture_begin_cb_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                                     gdouble start_x,
                                                                     gdouble start_y,
                                                                     gpointer self);
static void _crop_widget_drag_gesture_end_cb_gtk_gesture_drag_drag_end (GtkGestureDrag* _sender,
                                                                 gdouble offset_x,
                                                                 gdouble offset_y,
                                                                 gpointer self);
static void _crop_widget_drag_gesture_update_cb_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                       gdouble offset_x,
                                                                       gdouble offset_y,
                                                                       gpointer self);
static void crop_widget_finalize (GObject * obj);
static GType crop_widget_get_type_once (void);
static void _vala_crop_widget_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_crop_widget_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
crop_widget_get_instance_private (CropWidget* self)
{
	return G_STRUCT_MEMBER_P (self, CropWidget_private_offset);
}

static gboolean
crop_widget_mouse_motion_cb (CropWidget* self,
                             GdkEventMotion* event)
{
	gboolean result;
#line 69 "../src/widgets/CropWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "../src/widgets/CropWidget.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 73 "../src/widgets/CropWidget.vala"
	if (crop_widget_over_resize_area (self, event->x, event->y)) {
#line 183 "CropWidget.c"
		GdkCursor* _tmp0_;
#line 74 "../src/widgets/CropWidget.vala"
		_tmp0_ = self->priv->resize_cursor;
#line 74 "../src/widgets/CropWidget.vala"
		crop_widget_set_cursor (self, _tmp0_);
#line 75 "../src/widgets/CropWidget.vala"
		self->priv->resize_area_hovered = TRUE;
#line 76 "../src/widgets/CropWidget.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 77 "../src/widgets/CropWidget.vala"
		result = FALSE;
#line 77 "../src/widgets/CropWidget.vala"
		return result;
#line 197 "CropWidget.c"
	} else {
#line 78 "../src/widgets/CropWidget.vala"
		if (self->priv->resize_area_hovered) {
#line 201 "CropWidget.c"
			GdkCursor* _tmp1_;
#line 79 "../src/widgets/CropWidget.vala"
			self->priv->resize_area_hovered = FALSE;
#line 80 "../src/widgets/CropWidget.vala"
			_tmp1_ = self->priv->default_cursor;
#line 80 "../src/widgets/CropWidget.vala"
			crop_widget_set_cursor (self, _tmp1_);
#line 81 "../src/widgets/CropWidget.vala"
			gtk_widget_queue_draw ((GtkWidget*) self);
#line 211 "CropWidget.c"
		}
	}
#line 85 "../src/widgets/CropWidget.vala"
	if (crop_widget_cursor_in_selection (self, event->x, event->y)) {
#line 216 "CropWidget.c"
		GdkCursor* _tmp2_;
#line 86 "../src/widgets/CropWidget.vala"
		_tmp2_ = self->priv->drag_cursor;
#line 86 "../src/widgets/CropWidget.vala"
		crop_widget_set_cursor (self, _tmp2_);
#line 222 "CropWidget.c"
	} else {
		GdkCursor* _tmp3_;
#line 88 "../src/widgets/CropWidget.vala"
		_tmp3_ = self->priv->default_cursor;
#line 88 "../src/widgets/CropWidget.vala"
		crop_widget_set_cursor (self, _tmp3_);
#line 229 "CropWidget.c"
	}
#line 91 "../src/widgets/CropWidget.vala"
	result = FALSE;
#line 91 "../src/widgets/CropWidget.vala"
	return result;
#line 235 "CropWidget.c"
}

static void
crop_widget_drag_gesture_update_cb (CropWidget* self,
                                    GtkGestureDrag* gesture,
                                    gdouble offset_x,
                                    gdouble offset_y)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
#line 94 "../src/widgets/CropWidget.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/widgets/CropWidget.vala"
	g_return_if_fail (gesture != NULL);
#line 97 "../src/widgets/CropWidget.vala"
	x = self->priv->drag_start_x + offset_x;
#line 98 "../src/widgets/CropWidget.vala"
	y = self->priv->drag_start_y + offset_y;
#line 101 "../src/widgets/CropWidget.vala"
	if (self->priv->resize_area_grabbed) {
#line 102 "../src/widgets/CropWidget.vala"
		crop_widget_resize_selection_rect (self, x, y);
#line 258 "CropWidget.c"
	}
#line 106 "../src/widgets/CropWidget.vala"
	if (self->priv->selection_grabbed) {
#line 262 "CropWidget.c"
		GdkRectangle _tmp0_;
		GdkRectangle _tmp1_;
		GdkRectangle _tmp3_;
		GdkRectangle _tmp4_;
		GdkRectangle _tmp6_;
		GdkRectangle _tmp7_;
		GdkRectangle _tmp8_;
		GdkRectangle _tmp9_;
		GdkRectangle _tmp13_;
		GdkRectangle _tmp14_;
		GdkRectangle _tmp15_;
		GdkRectangle _tmp16_;
#line 107 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.x = ((gint) x) - self->priv->drag_diff_x;
#line 108 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.y = ((gint) y) - self->priv->drag_diff_y;
#line 111 "../src/widgets/CropWidget.vala"
		_tmp0_ = self->priv->selection_rect;
#line 111 "../src/widgets/CropWidget.vala"
		_tmp1_ = self->priv->image_rect;
#line 111 "../src/widgets/CropWidget.vala"
		if (_tmp0_.x < _tmp1_.x) {
#line 285 "CropWidget.c"
			GdkRectangle _tmp2_;
#line 112 "../src/widgets/CropWidget.vala"
			_tmp2_ = self->priv->image_rect;
#line 112 "../src/widgets/CropWidget.vala"
			self->priv->selection_rect.x = _tmp2_.x;
#line 291 "CropWidget.c"
		}
#line 114 "../src/widgets/CropWidget.vala"
		_tmp3_ = self->priv->selection_rect;
#line 114 "../src/widgets/CropWidget.vala"
		_tmp4_ = self->priv->image_rect;
#line 114 "../src/widgets/CropWidget.vala"
		if (_tmp3_.y < _tmp4_.y) {
#line 299 "CropWidget.c"
			GdkRectangle _tmp5_;
#line 115 "../src/widgets/CropWidget.vala"
			_tmp5_ = self->priv->image_rect;
#line 115 "../src/widgets/CropWidget.vala"
			self->priv->selection_rect.y = _tmp5_.y;
#line 305 "CropWidget.c"
		}
#line 117 "../src/widgets/CropWidget.vala"
		_tmp6_ = self->priv->selection_rect;
#line 117 "../src/widgets/CropWidget.vala"
		_tmp7_ = self->priv->selection_rect;
#line 117 "../src/widgets/CropWidget.vala"
		_tmp8_ = self->priv->image_rect;
#line 117 "../src/widgets/CropWidget.vala"
		_tmp9_ = self->priv->image_rect;
#line 117 "../src/widgets/CropWidget.vala"
		if ((_tmp6_.x + _tmp7_.width) > (_tmp8_.x + _tmp9_.width)) {
#line 317 "CropWidget.c"
			GdkRectangle _tmp10_;
			GdkRectangle _tmp11_;
			GdkRectangle _tmp12_;
#line 118 "../src/widgets/CropWidget.vala"
			_tmp10_ = self->priv->image_rect;
#line 118 "../src/widgets/CropWidget.vala"
			_tmp11_ = self->priv->image_rect;
#line 118 "../src/widgets/CropWidget.vala"
			_tmp12_ = self->priv->selection_rect;
#line 118 "../src/widgets/CropWidget.vala"
			self->priv->selection_rect.x = (_tmp10_.x + _tmp11_.width) - _tmp12_.width;
#line 329 "CropWidget.c"
		}
#line 120 "../src/widgets/CropWidget.vala"
		_tmp13_ = self->priv->selection_rect;
#line 120 "../src/widgets/CropWidget.vala"
		_tmp14_ = self->priv->selection_rect;
#line 120 "../src/widgets/CropWidget.vala"
		_tmp15_ = self->priv->image_rect;
#line 120 "../src/widgets/CropWidget.vala"
		_tmp16_ = self->priv->image_rect;
#line 120 "../src/widgets/CropWidget.vala"
		if ((_tmp13_.y + _tmp14_.height) > (_tmp15_.y + _tmp16_.height)) {
#line 341 "CropWidget.c"
			GdkRectangle _tmp17_;
			GdkRectangle _tmp18_;
			GdkRectangle _tmp19_;
#line 121 "../src/widgets/CropWidget.vala"
			_tmp17_ = self->priv->image_rect;
#line 121 "../src/widgets/CropWidget.vala"
			_tmp18_ = self->priv->image_rect;
#line 121 "../src/widgets/CropWidget.vala"
			_tmp19_ = self->priv->selection_rect;
#line 121 "../src/widgets/CropWidget.vala"
			self->priv->selection_rect.y = (_tmp17_.y + _tmp18_.height) - _tmp19_.height;
#line 353 "CropWidget.c"
		}
#line 123 "../src/widgets/CropWidget.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 124 "../src/widgets/CropWidget.vala"
		return;
#line 359 "CropWidget.c"
	}
}

static void
crop_widget_drag_gesture_begin_cb (CropWidget* self,
                                   GtkGestureDrag* gesture,
                                   gdouble x,
                                   gdouble y)
{
#line 128 "../src/widgets/CropWidget.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/widgets/CropWidget.vala"
	g_return_if_fail (gesture != NULL);
#line 131 "../src/widgets/CropWidget.vala"
	self->priv->drag_start_x = x;
#line 132 "../src/widgets/CropWidget.vala"
	self->priv->drag_start_y = y;
#line 135 "../src/widgets/CropWidget.vala"
	if (crop_widget_over_resize_area (self, x, y)) {
#line 379 "CropWidget.c"
		GdkRectangle _tmp0_;
		GdkRectangle _tmp1_;
		GdkRectangle _tmp2_;
		GdkRectangle _tmp3_;
		GdkCursor* _tmp4_;
#line 136 "../src/widgets/CropWidget.vala"
		self->priv->resize_area_grabbed = TRUE;
#line 137 "../src/widgets/CropWidget.vala"
		_tmp0_ = self->priv->selection_rect;
#line 137 "../src/widgets/CropWidget.vala"
		_tmp1_ = self->priv->selection_rect;
#line 137 "../src/widgets/CropWidget.vala"
		self->priv->resize_diff_x = ((gint) x) - (_tmp0_.x + _tmp1_.width);
#line 138 "../src/widgets/CropWidget.vala"
		_tmp2_ = self->priv->selection_rect;
#line 138 "../src/widgets/CropWidget.vala"
		_tmp3_ = self->priv->selection_rect;
#line 138 "../src/widgets/CropWidget.vala"
		self->priv->resize_diff_y = ((gint) y) - (_tmp2_.y + _tmp3_.height);
#line 139 "../src/widgets/CropWidget.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 140 "../src/widgets/CropWidget.vala"
		_tmp4_ = self->priv->resize_cursor;
#line 140 "../src/widgets/CropWidget.vala"
		crop_widget_set_cursor (self, _tmp4_);
#line 141 "../src/widgets/CropWidget.vala"
		return;
#line 407 "CropWidget.c"
	}
#line 145 "../src/widgets/CropWidget.vala"
	if (crop_widget_cursor_in_selection (self, x, y)) {
#line 411 "CropWidget.c"
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_;
		GdkCursor* _tmp7_;
#line 146 "../src/widgets/CropWidget.vala"
		self->priv->selection_grabbed = TRUE;
#line 147 "../src/widgets/CropWidget.vala"
		_tmp5_ = self->priv->selection_rect;
#line 147 "../src/widgets/CropWidget.vala"
		self->priv->drag_diff_x = (gint) (x - _tmp5_.x);
#line 148 "../src/widgets/CropWidget.vala"
		_tmp6_ = self->priv->selection_rect;
#line 148 "../src/widgets/CropWidget.vala"
		self->priv->drag_diff_y = (gint) (y - _tmp6_.y);
#line 149 "../src/widgets/CropWidget.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 150 "../src/widgets/CropWidget.vala"
		_tmp7_ = self->priv->drag_cursor;
#line 150 "../src/widgets/CropWidget.vala"
		crop_widget_set_cursor (self, _tmp7_);
#line 151 "../src/widgets/CropWidget.vala"
		return;
#line 433 "CropWidget.c"
	}
#line 154 "../src/widgets/CropWidget.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_DENIED);
#line 437 "CropWidget.c"
}

static void
crop_widget_drag_gesture_end_cb (CropWidget* self,
                                 GtkGestureDrag* gesture,
                                 gdouble offset_x,
                                 gdouble offset_y)
{
#line 157 "../src/widgets/CropWidget.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/widgets/CropWidget.vala"
	g_return_if_fail (gesture != NULL);
#line 160 "../src/widgets/CropWidget.vala"
	if (self->priv->selection_grabbed) {
#line 452 "CropWidget.c"
		GdkCursor* _tmp0_;
#line 161 "../src/widgets/CropWidget.vala"
		self->priv->selection_grabbed = FALSE;
#line 162 "../src/widgets/CropWidget.vala"
		_tmp0_ = self->priv->default_cursor;
#line 162 "../src/widgets/CropWidget.vala"
		crop_widget_set_cursor (self, _tmp0_);
#line 163 "../src/widgets/CropWidget.vala"
		return;
#line 462 "CropWidget.c"
	}
#line 166 "../src/widgets/CropWidget.vala"
	if (self->priv->resize_area_grabbed) {
#line 466 "CropWidget.c"
		GdkCursor* _tmp1_;
#line 167 "../src/widgets/CropWidget.vala"
		self->priv->resize_area_grabbed = FALSE;
#line 168 "../src/widgets/CropWidget.vala"
		_tmp1_ = self->priv->default_cursor;
#line 168 "../src/widgets/CropWidget.vala"
		crop_widget_set_cursor (self, _tmp1_);
#line 169 "../src/widgets/CropWidget.vala"
		return;
#line 476 "CropWidget.c"
	}
}

static inline void
crop_widget_restrict_selection_size (CropWidget* self)
{
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
	GdkRectangle _tmp14_;
	GdkRectangle _tmp15_;
	GdkRectangle _tmp16_;
	GdkRectangle _tmp17_;
	GdkRectangle _tmp21_;
	GdkRectangle _tmp22_;
	GdkRectangle _tmp23_;
	GdkRectangle _tmp24_;
#line 173 "../src/widgets/CropWidget.vala"
	g_return_if_fail (self != NULL);
#line 174 "../src/widgets/CropWidget.vala"
	_tmp0_ = self->priv->selection_rect;
#line 174 "../src/widgets/CropWidget.vala"
	_tmp1_ = self->priv->image_rect;
#line 174 "../src/widgets/CropWidget.vala"
	if (_tmp0_.width > _tmp1_.width) {
#line 508 "CropWidget.c"
		GdkRectangle _tmp2_;
#line 175 "../src/widgets/CropWidget.vala"
		_tmp2_ = self->priv->image_rect;
#line 175 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.width = _tmp2_.width;
#line 514 "CropWidget.c"
	}
#line 177 "../src/widgets/CropWidget.vala"
	_tmp3_ = self->priv->selection_rect;
#line 177 "../src/widgets/CropWidget.vala"
	_tmp4_ = self->priv->image_rect;
#line 177 "../src/widgets/CropWidget.vala"
	if (_tmp3_.height > _tmp4_.height) {
#line 522 "CropWidget.c"
		GdkRectangle _tmp5_;
#line 178 "../src/widgets/CropWidget.vala"
		_tmp5_ = self->priv->image_rect;
#line 178 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.height = _tmp5_.height;
#line 528 "CropWidget.c"
	}
#line 181 "../src/widgets/CropWidget.vala"
	_tmp6_ = self->priv->selection_rect;
#line 181 "../src/widgets/CropWidget.vala"
	if (((gdouble) _tmp6_.width) < (self->priv->min_width * self->priv->current_scale)) {
#line 534 "CropWidget.c"
		gdouble _tmp7_;
#line 182 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.width = (gint) (self->priv->min_width * self->priv->current_scale);
#line 183 "../src/widgets/CropWidget.vala"
		_tmp7_ = self->priv->_desired_aspect_ratio;
#line 183 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.height = (gint) ((self->priv->min_width * self->priv->current_scale) / _tmp7_);
#line 542 "CropWidget.c"
	}
#line 186 "../src/widgets/CropWidget.vala"
	_tmp8_ = self->priv->selection_rect;
#line 186 "../src/widgets/CropWidget.vala"
	_tmp9_ = self->priv->image_rect;
#line 186 "../src/widgets/CropWidget.vala"
	if (_tmp8_.x < _tmp9_.x) {
#line 550 "CropWidget.c"
		GdkRectangle _tmp10_;
#line 187 "../src/widgets/CropWidget.vala"
		_tmp10_ = self->priv->image_rect;
#line 187 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.x = _tmp10_.x;
#line 556 "CropWidget.c"
	}
#line 189 "../src/widgets/CropWidget.vala"
	_tmp11_ = self->priv->selection_rect;
#line 189 "../src/widgets/CropWidget.vala"
	_tmp12_ = self->priv->image_rect;
#line 189 "../src/widgets/CropWidget.vala"
	if (_tmp11_.y < _tmp12_.y) {
#line 564 "CropWidget.c"
		GdkRectangle _tmp13_;
#line 190 "../src/widgets/CropWidget.vala"
		_tmp13_ = self->priv->image_rect;
#line 190 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.y = _tmp13_.y;
#line 570 "CropWidget.c"
	}
#line 193 "../src/widgets/CropWidget.vala"
	_tmp14_ = self->priv->selection_rect;
#line 193 "../src/widgets/CropWidget.vala"
	_tmp15_ = self->priv->selection_rect;
#line 193 "../src/widgets/CropWidget.vala"
	_tmp16_ = self->priv->image_rect;
#line 193 "../src/widgets/CropWidget.vala"
	_tmp17_ = self->priv->image_rect;
#line 193 "../src/widgets/CropWidget.vala"
	if ((_tmp14_.x + _tmp15_.width) > (_tmp16_.x + _tmp17_.width)) {
#line 582 "CropWidget.c"
		GdkRectangle _tmp18_;
		GdkRectangle _tmp19_;
		GdkRectangle _tmp20_;
#line 194 "../src/widgets/CropWidget.vala"
		_tmp18_ = self->priv->image_rect;
#line 194 "../src/widgets/CropWidget.vala"
		_tmp19_ = self->priv->image_rect;
#line 194 "../src/widgets/CropWidget.vala"
		_tmp20_ = self->priv->selection_rect;
#line 194 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.x = (_tmp18_.x + _tmp19_.width) - _tmp20_.width;
#line 594 "CropWidget.c"
	}
#line 196 "../src/widgets/CropWidget.vala"
	_tmp21_ = self->priv->selection_rect;
#line 196 "../src/widgets/CropWidget.vala"
	_tmp22_ = self->priv->selection_rect;
#line 196 "../src/widgets/CropWidget.vala"
	_tmp23_ = self->priv->image_rect;
#line 196 "../src/widgets/CropWidget.vala"
	_tmp24_ = self->priv->image_rect;
#line 196 "../src/widgets/CropWidget.vala"
	if ((_tmp21_.y + _tmp22_.height) > (_tmp23_.y + _tmp24_.height)) {
#line 606 "CropWidget.c"
		GdkRectangle _tmp25_;
		GdkRectangle _tmp26_;
		GdkRectangle _tmp27_;
#line 197 "../src/widgets/CropWidget.vala"
		_tmp25_ = self->priv->image_rect;
#line 197 "../src/widgets/CropWidget.vala"
		_tmp26_ = self->priv->image_rect;
#line 197 "../src/widgets/CropWidget.vala"
		_tmp27_ = self->priv->selection_rect;
#line 197 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.y = (_tmp25_.y + _tmp26_.height) - _tmp27_.height;
#line 618 "CropWidget.c"
	}
}

static void
crop_widget_resize_selection_rect (CropWidget* self,
                                   gdouble x,
                                   gdouble y)
{
	gint max_width = 0;
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	gdouble _tmp3_;
	gint new_width = 0;
	GdkRectangle _tmp4_;
	gint new_height = 0;
	gdouble _tmp5_;
#line 201 "../src/widgets/CropWidget.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/widgets/CropWidget.vala"
	if (!self->priv->resize_area_grabbed) {
#line 204 "../src/widgets/CropWidget.vala"
		return;
#line 642 "CropWidget.c"
	}
#line 206 "../src/widgets/CropWidget.vala"
	_tmp0_ = self->priv->image_rect;
#line 206 "../src/widgets/CropWidget.vala"
	_tmp1_ = self->priv->image_rect;
#line 206 "../src/widgets/CropWidget.vala"
	_tmp2_ = self->priv->image_rect;
#line 206 "../src/widgets/CropWidget.vala"
	_tmp3_ = self->priv->_desired_aspect_ratio;
#line 206 "../src/widgets/CropWidget.vala"
	max_width = MIN (_tmp0_.width, MIN ((gint) _tmp1_.width, (gint) (_tmp2_.height * _tmp3_)));
#line 210 "../src/widgets/CropWidget.vala"
	_tmp4_ = self->priv->selection_rect;
#line 210 "../src/widgets/CropWidget.vala"
	new_width = (((gint) x) - _tmp4_.x) - self->priv->resize_diff_x;
#line 211 "../src/widgets/CropWidget.vala"
	_tmp5_ = self->priv->_desired_aspect_ratio;
#line 211 "../src/widgets/CropWidget.vala"
	new_height = (gint) (new_width / _tmp5_);
#line 213 "../src/widgets/CropWidget.vala"
	if (new_width <= max_width) {
#line 214 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.width = new_width;
#line 215 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.height = new_height;
#line 668 "CropWidget.c"
	} else {
		gdouble _tmp6_;
#line 217 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.width = max_width;
#line 220 "../src/widgets/CropWidget.vala"
		_tmp6_ = self->priv->_desired_aspect_ratio;
#line 220 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.height = (gint) (max_width / _tmp6_);
#line 677 "CropWidget.c"
	}
#line 223 "../src/widgets/CropWidget.vala"
	crop_widget_restrict_selection_size (self);
#line 225 "../src/widgets/CropWidget.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 683 "CropWidget.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 229 "../src/widgets/CropWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 691 "CropWidget.c"
}

void
crop_widget_set_image (CropWidget* self,
                       GdkPixbuf* image)
{
	GdkPixbuf* _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	gdouble _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
	GdkRectangle _tmp13_;
	GdkRectangle _tmp14_;
#line 228 "../src/widgets/CropWidget.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/widgets/CropWidget.vala"
	_tmp0_ = _g_object_ref0 (image);
#line 229 "../src/widgets/CropWidget.vala"
	_g_object_unref0 (self->priv->image);
#line 229 "../src/widgets/CropWidget.vala"
	self->priv->image = _tmp0_;
#line 230 "../src/widgets/CropWidget.vala"
	crop_widget_calculate_image_rect (self);
#line 235 "../src/widgets/CropWidget.vala"
	_tmp1_ = self->priv->image_rect;
#line 235 "../src/widgets/CropWidget.vala"
	self->priv->selection_rect.width = _tmp1_.width;
#line 236 "../src/widgets/CropWidget.vala"
	_tmp2_ = self->priv->selection_rect;
#line 236 "../src/widgets/CropWidget.vala"
	_tmp3_ = self->priv->_desired_aspect_ratio;
#line 236 "../src/widgets/CropWidget.vala"
	self->priv->selection_rect.height = (gint) (_tmp2_.width / _tmp3_);
#line 238 "../src/widgets/CropWidget.vala"
	_tmp4_ = self->priv->selection_rect;
#line 238 "../src/widgets/CropWidget.vala"
	_tmp5_ = self->priv->image_rect;
#line 238 "../src/widgets/CropWidget.vala"
	if (_tmp4_.height > _tmp5_.height) {
#line 736 "CropWidget.c"
		GdkRectangle _tmp6_;
		GdkRectangle _tmp7_;
		gdouble _tmp8_;
#line 239 "../src/widgets/CropWidget.vala"
		_tmp6_ = self->priv->image_rect;
#line 239 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.height = _tmp6_.height;
#line 240 "../src/widgets/CropWidget.vala"
		_tmp7_ = self->priv->selection_rect;
#line 240 "../src/widgets/CropWidget.vala"
		_tmp8_ = self->priv->_desired_aspect_ratio;
#line 240 "../src/widgets/CropWidget.vala"
		self->priv->selection_rect.width = (gint) (_tmp7_.height * _tmp8_);
#line 750 "CropWidget.c"
	}
#line 243 "../src/widgets/CropWidget.vala"
	_tmp9_ = self->priv->image_rect;
#line 243 "../src/widgets/CropWidget.vala"
	_tmp10_ = self->priv->image_rect;
#line 243 "../src/widgets/CropWidget.vala"
	_tmp11_ = self->priv->selection_rect;
#line 243 "../src/widgets/CropWidget.vala"
	self->priv->selection_rect.x = _tmp9_.x + ((_tmp10_.width - _tmp11_.width) / 2);
#line 244 "../src/widgets/CropWidget.vala"
	_tmp12_ = self->priv->image_rect;
#line 244 "../src/widgets/CropWidget.vala"
	_tmp13_ = self->priv->image_rect;
#line 244 "../src/widgets/CropWidget.vala"
	_tmp14_ = self->priv->selection_rect;
#line 244 "../src/widgets/CropWidget.vala"
	self->priv->selection_rect.y = _tmp12_.y + ((_tmp13_.height - _tmp14_.height) / 2);
#line 246 "../src/widgets/CropWidget.vala"
	crop_widget_restrict_selection_size (self);
#line 247 "../src/widgets/CropWidget.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 772 "CropWidget.c"
}

static gboolean
crop_widget_real_draw (GtkWidget* base,
                       cairo_t* ct)
{
	CropWidget * self;
	GdkPixbuf* _tmp0_;
	gint widget_width = 0;
	gint widget_height = 0;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
	GdkRectangle _tmp13_;
	GdkRectangle _tmp14_;
	GdkRectangle _tmp15_;
	gboolean _tmp16_ = FALSE;
	gboolean result;
#line 251 "../src/widgets/CropWidget.vala"
	self = (CropWidget*) base;
#line 251 "../src/widgets/CropWidget.vala"
	g_return_val_if_fail (ct != NULL, FALSE);
#line 252 "../src/widgets/CropWidget.vala"
	_tmp0_ = self->priv->image;
#line 252 "../src/widgets/CropWidget.vala"
	if (_tmp0_ == NULL) {
#line 253 "../src/widgets/CropWidget.vala"
		result = GDK_EVENT_PROPAGATE;
#line 253 "../src/widgets/CropWidget.vala"
		return result;
#line 812 "CropWidget.c"
	}
#line 255 "../src/widgets/CropWidget.vala"
	widget_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 256 "../src/widgets/CropWidget.vala"
	widget_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 258 "../src/widgets/CropWidget.vala"
	cairo_set_line_width (ct, 1.0);
#line 261 "../src/widgets/CropWidget.vala"
	cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) widget_width, (gdouble) widget_height);
#line 262 "../src/widgets/CropWidget.vala"
	cairo_set_source_rgba (ct, 0.3, 0.3, 0.3, 1.0);
#line 263 "../src/widgets/CropWidget.vala"
	cairo_fill (ct);
#line 266 "../src/widgets/CropWidget.vala"
	cairo_save (ct);
#line 267 "../src/widgets/CropWidget.vala"
	_tmp1_ = self->priv->image_rect;
#line 267 "../src/widgets/CropWidget.vala"
	_tmp2_ = self->priv->image_rect;
#line 267 "../src/widgets/CropWidget.vala"
	_tmp3_ = self->priv->image_rect;
#line 267 "../src/widgets/CropWidget.vala"
	_tmp4_ = self->priv->image_rect;
#line 267 "../src/widgets/CropWidget.vala"
	cairo_rectangle (ct, (gdouble) _tmp1_.x, (gdouble) _tmp2_.y, (gdouble) _tmp3_.width, (gdouble) _tmp4_.height);
#line 269 "../src/widgets/CropWidget.vala"
	cairo_scale (ct, self->priv->current_scale, self->priv->current_scale);
#line 270 "../src/widgets/CropWidget.vala"
	_tmp5_ = self->priv->image;
#line 270 "../src/widgets/CropWidget.vala"
	_tmp6_ = self->priv->image_rect;
#line 270 "../src/widgets/CropWidget.vala"
	_tmp7_ = self->priv->image_rect;
#line 270 "../src/widgets/CropWidget.vala"
	gdk_cairo_set_source_pixbuf (ct, _tmp5_, _tmp6_.x / self->priv->current_scale, _tmp7_.y / self->priv->current_scale);
#line 273 "../src/widgets/CropWidget.vala"
	cairo_fill (ct);
#line 274 "../src/widgets/CropWidget.vala"
	cairo_restore (ct);
#line 277 "../src/widgets/CropWidget.vala"
	_tmp8_ = self->priv->selection_rect;
#line 277 "../src/widgets/CropWidget.vala"
	_tmp9_ = self->priv->selection_rect;
#line 277 "../src/widgets/CropWidget.vala"
	_tmp10_ = self->priv->selection_rect;
#line 277 "../src/widgets/CropWidget.vala"
	_tmp11_ = self->priv->selection_rect;
#line 277 "../src/widgets/CropWidget.vala"
	cairo_rectangle (ct, (gdouble) _tmp8_.x, (gdouble) _tmp9_.y, (gdouble) _tmp10_.width, (gdouble) _tmp11_.height);
#line 279 "../src/widgets/CropWidget.vala"
	cairo_set_source_rgba (ct, 1.0, 1.0, 1.0, 1.0);
#line 280 "../src/widgets/CropWidget.vala"
	cairo_stroke (ct);
#line 283 "../src/widgets/CropWidget.vala"
	_tmp12_ = self->priv->selection_rect;
#line 283 "../src/widgets/CropWidget.vala"
	_tmp13_ = self->priv->selection_rect;
#line 283 "../src/widgets/CropWidget.vala"
	_tmp14_ = self->priv->selection_rect;
#line 283 "../src/widgets/CropWidget.vala"
	_tmp15_ = self->priv->selection_rect;
#line 283 "../src/widgets/CropWidget.vala"
	cairo_rectangle (ct, (gdouble) ((_tmp12_.x + _tmp13_.width) - 15), (gdouble) ((_tmp14_.y + _tmp15_.height) - 15), 14.5, 14.5);
#line 287 "../src/widgets/CropWidget.vala"
	if (self->priv->resize_area_hovered) {
#line 287 "../src/widgets/CropWidget.vala"
		_tmp16_ = TRUE;
#line 880 "CropWidget.c"
	} else {
#line 287 "../src/widgets/CropWidget.vala"
		_tmp16_ = self->priv->resize_area_grabbed;
#line 884 "CropWidget.c"
	}
#line 287 "../src/widgets/CropWidget.vala"
	if (_tmp16_) {
#line 288 "../src/widgets/CropWidget.vala"
		cairo_set_source_rgba (ct, 0.0, 0.0, 0.6, 0.7);
#line 890 "CropWidget.c"
	} else {
#line 290 "../src/widgets/CropWidget.vala"
		cairo_set_source_rgba (ct, 1.0, 1.0, 1.0, 0.7);
#line 894 "CropWidget.c"
	}
#line 291 "../src/widgets/CropWidget.vala"
	cairo_fill (ct);
#line 293 "../src/widgets/CropWidget.vala"
	result = GDK_EVENT_PROPAGATE;
#line 293 "../src/widgets/CropWidget.vala"
	return result;
#line 902 "CropWidget.c"
}

static inline void
crop_widget_set_cursor (CropWidget* self,
                        GdkCursor* cursor)
{
	GdkWindow* _tmp0_;
#line 296 "../src/widgets/CropWidget.vala"
	g_return_if_fail (self != NULL);
#line 296 "../src/widgets/CropWidget.vala"
	g_return_if_fail (cursor != NULL);
#line 297 "../src/widgets/CropWidget.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 297 "../src/widgets/CropWidget.vala"
	gdk_window_set_cursor (_tmp0_, cursor);
#line 918 "CropWidget.c"
}

static gboolean
crop_widget_cursor_in_selection (CropWidget* self,
                                 gdouble x,
                                 gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkRectangle _tmp3_;
	gboolean result;
#line 300 "../src/widgets/CropWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 301 "../src/widgets/CropWidget.vala"
	_tmp3_ = self->priv->selection_rect;
#line 301 "../src/widgets/CropWidget.vala"
	if (x >= ((gdouble) _tmp3_.x)) {
#line 937 "CropWidget.c"
		GdkRectangle _tmp4_;
		GdkRectangle _tmp5_;
#line 302 "../src/widgets/CropWidget.vala"
		_tmp4_ = self->priv->selection_rect;
#line 302 "../src/widgets/CropWidget.vala"
		_tmp5_ = self->priv->selection_rect;
#line 302 "../src/widgets/CropWidget.vala"
		_tmp2_ = x <= ((gdouble) (_tmp4_.x + _tmp5_.width));
#line 946 "CropWidget.c"
	} else {
#line 301 "../src/widgets/CropWidget.vala"
		_tmp2_ = FALSE;
#line 950 "CropWidget.c"
	}
#line 301 "../src/widgets/CropWidget.vala"
	if (_tmp2_) {
#line 954 "CropWidget.c"
		GdkRectangle _tmp6_;
#line 303 "../src/widgets/CropWidget.vala"
		_tmp6_ = self->priv->selection_rect;
#line 303 "../src/widgets/CropWidget.vala"
		_tmp1_ = y >= ((gdouble) _tmp6_.y);
#line 960 "CropWidget.c"
	} else {
#line 301 "../src/widgets/CropWidget.vala"
		_tmp1_ = FALSE;
#line 964 "CropWidget.c"
	}
#line 301 "../src/widgets/CropWidget.vala"
	if (_tmp1_) {
#line 968 "CropWidget.c"
		GdkRectangle _tmp7_;
		GdkRectangle _tmp8_;
#line 304 "../src/widgets/CropWidget.vala"
		_tmp7_ = self->priv->selection_rect;
#line 304 "../src/widgets/CropWidget.vala"
		_tmp8_ = self->priv->selection_rect;
#line 304 "../src/widgets/CropWidget.vala"
		_tmp0_ = y <= ((gdouble) (_tmp7_.y + _tmp8_.height));
#line 977 "CropWidget.c"
	} else {
#line 301 "../src/widgets/CropWidget.vala"
		_tmp0_ = FALSE;
#line 981 "CropWidget.c"
	}
#line 301 "../src/widgets/CropWidget.vala"
	result = _tmp0_;
#line 301 "../src/widgets/CropWidget.vala"
	return result;
#line 987 "CropWidget.c"
}

static void
crop_widget_real_size_allocate (GtkWidget* base,
                                GtkAllocation* alloc)
{
	CropWidget * self;
	GtkAllocation _tmp0_;
#line 308 "../src/widgets/CropWidget.vala"
	self = (CropWidget*) base;
#line 308 "../src/widgets/CropWidget.vala"
	g_return_if_fail (alloc != NULL);
#line 309 "../src/widgets/CropWidget.vala"
	_tmp0_ = *alloc;
#line 309 "../src/widgets/CropWidget.vala"
	GTK_WIDGET_CLASS (crop_widget_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_drawing_area_get_type (), GtkDrawingArea), &_tmp0_);
#line 310 "../src/widgets/CropWidget.vala"
	crop_widget_calculate_image_rect (self);
#line 311 "../src/widgets/CropWidget.vala"
	crop_widget_restrict_selection_size (self);
#line 1008 "CropWidget.c"
}

static void
crop_widget_calculate_image_rect (CropWidget* self)
{
	gint widget_width = 0;
	gint widget_height = 0;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
#line 314 "../src/widgets/CropWidget.vala"
	g_return_if_fail (self != NULL);
#line 315 "../src/widgets/CropWidget.vala"
	widget_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 316 "../src/widgets/CropWidget.vala"
	widget_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 318 "../src/widgets/CropWidget.vala"
	_tmp0_ = self->priv->image;
#line 318 "../src/widgets/CropWidget.vala"
	if (_tmp0_ == NULL) {
#line 319 "../src/widgets/CropWidget.vala"
		return;
#line 1037 "CropWidget.c"
	}
#line 323 "../src/widgets/CropWidget.vala"
	_tmp1_ = self->priv->image;
#line 323 "../src/widgets/CropWidget.vala"
	_tmp2_ = self->priv->image;
#line 323 "../src/widgets/CropWidget.vala"
	if (gdk_pixbuf_get_width (_tmp1_) > gdk_pixbuf_get_height (_tmp2_)) {
#line 1045 "CropWidget.c"
		GdkPixbuf* _tmp3_;
#line 324 "../src/widgets/CropWidget.vala"
		_tmp3_ = self->priv->image;
#line 324 "../src/widgets/CropWidget.vala"
		self->priv->current_scale = ((gdouble) widget_width) / gdk_pixbuf_get_width (_tmp3_);
#line 1051 "CropWidget.c"
	} else {
		GdkPixbuf* _tmp4_;
#line 326 "../src/widgets/CropWidget.vala"
		_tmp4_ = self->priv->image;
#line 326 "../src/widgets/CropWidget.vala"
		self->priv->current_scale = ((gdouble) widget_height) / gdk_pixbuf_get_height (_tmp4_);
#line 1058 "CropWidget.c"
	}
#line 329 "../src/widgets/CropWidget.vala"
	_tmp5_ = self->priv->image;
#line 329 "../src/widgets/CropWidget.vala"
	if ((gdk_pixbuf_get_width (_tmp5_) * self->priv->current_scale) > ((gdouble) widget_width)) {
#line 1064 "CropWidget.c"
		GdkPixbuf* _tmp6_;
#line 330 "../src/widgets/CropWidget.vala"
		_tmp6_ = self->priv->image;
#line 330 "../src/widgets/CropWidget.vala"
		self->priv->current_scale = ((gdouble) widget_width) / gdk_pixbuf_get_width (_tmp6_);
#line 1070 "CropWidget.c"
	}
#line 332 "../src/widgets/CropWidget.vala"
	_tmp7_ = self->priv->image;
#line 332 "../src/widgets/CropWidget.vala"
	if ((gdk_pixbuf_get_height (_tmp7_) * self->priv->current_scale) > ((gdouble) widget_height)) {
#line 1076 "CropWidget.c"
		GdkPixbuf* _tmp8_;
#line 333 "../src/widgets/CropWidget.vala"
		_tmp8_ = self->priv->image;
#line 333 "../src/widgets/CropWidget.vala"
		self->priv->current_scale = ((gdouble) widget_height) / gdk_pixbuf_get_height (_tmp8_);
#line 1082 "CropWidget.c"
	}
#line 336 "../src/widgets/CropWidget.vala"
	if (self->priv->current_scale > 1.0) {
#line 337 "../src/widgets/CropWidget.vala"
		self->priv->current_scale = 1.0;
#line 1088 "CropWidget.c"
	}
#line 340 "../src/widgets/CropWidget.vala"
	_tmp9_ = self->priv->image;
#line 340 "../src/widgets/CropWidget.vala"
	self->priv->image_rect.width = (gint) (gdk_pixbuf_get_width (_tmp9_) * self->priv->current_scale);
#line 341 "../src/widgets/CropWidget.vala"
	_tmp10_ = self->priv->image;
#line 341 "../src/widgets/CropWidget.vala"
	self->priv->image_rect.height = (gint) (gdk_pixbuf_get_height (_tmp10_) * self->priv->current_scale);
#line 342 "../src/widgets/CropWidget.vala"
	_tmp11_ = self->priv->image_rect;
#line 342 "../src/widgets/CropWidget.vala"
	self->priv->image_rect.x = (widget_width - _tmp11_.width) / 2;
#line 343 "../src/widgets/CropWidget.vala"
	_tmp12_ = self->priv->image_rect;
#line 343 "../src/widgets/CropWidget.vala"
	self->priv->image_rect.y = (widget_height - _tmp12_.height) / 2;
#line 1106 "CropWidget.c"
}

static gboolean
crop_widget_over_resize_area (CropWidget* self,
                              gdouble x,
                              gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	gboolean result;
#line 346 "../src/widgets/CropWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 348 "../src/widgets/CropWidget.vala"
	_tmp3_ = self->priv->selection_rect;
#line 348 "../src/widgets/CropWidget.vala"
	_tmp4_ = self->priv->selection_rect;
#line 348 "../src/widgets/CropWidget.vala"
	if (x > ((gdouble) ((_tmp3_.x + _tmp4_.width) - 15))) {
#line 1128 "CropWidget.c"
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_;
#line 349 "../src/widgets/CropWidget.vala"
		_tmp5_ = self->priv->selection_rect;
#line 349 "../src/widgets/CropWidget.vala"
		_tmp6_ = self->priv->selection_rect;
#line 349 "../src/widgets/CropWidget.vala"
		_tmp2_ = x < ((gdouble) ((_tmp5_.x + _tmp6_.width) + 5));
#line 1137 "CropWidget.c"
	} else {
#line 348 "../src/widgets/CropWidget.vala"
		_tmp2_ = FALSE;
#line 1141 "CropWidget.c"
	}
#line 348 "../src/widgets/CropWidget.vala"
	if (_tmp2_) {
#line 1145 "CropWidget.c"
		GdkRectangle _tmp7_;
		GdkRectangle _tmp8_;
#line 350 "../src/widgets/CropWidget.vala"
		_tmp7_ = self->priv->selection_rect;
#line 350 "../src/widgets/CropWidget.vala"
		_tmp8_ = self->priv->selection_rect;
#line 350 "../src/widgets/CropWidget.vala"
		_tmp1_ = y > ((gdouble) ((_tmp7_.y + _tmp8_.height) - 15));
#line 1154 "CropWidget.c"
	} else {
#line 348 "../src/widgets/CropWidget.vala"
		_tmp1_ = FALSE;
#line 1158 "CropWidget.c"
	}
#line 348 "../src/widgets/CropWidget.vala"
	if (_tmp1_) {
#line 1162 "CropWidget.c"
		GdkRectangle _tmp9_;
		GdkRectangle _tmp10_;
#line 351 "../src/widgets/CropWidget.vala"
		_tmp9_ = self->priv->selection_rect;
#line 351 "../src/widgets/CropWidget.vala"
		_tmp10_ = self->priv->selection_rect;
#line 351 "../src/widgets/CropWidget.vala"
		_tmp0_ = y < ((gdouble) ((_tmp9_.y + _tmp10_.height) + 5));
#line 1171 "CropWidget.c"
	} else {
#line 348 "../src/widgets/CropWidget.vala"
		_tmp0_ = FALSE;
#line 1175 "CropWidget.c"
	}
#line 348 "../src/widgets/CropWidget.vala"
	if (_tmp0_) {
#line 352 "../src/widgets/CropWidget.vala"
		result = TRUE;
#line 352 "../src/widgets/CropWidget.vala"
		return result;
#line 1183 "CropWidget.c"
	}
#line 355 "../src/widgets/CropWidget.vala"
	result = FALSE;
#line 355 "../src/widgets/CropWidget.vala"
	return result;
#line 1189 "CropWidget.c"
}

GdkPixbuf*
crop_widget_get_cropped_image (CropWidget* self)
{
	gint absolute_x = 0;
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	gint absolute_y = 0;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	gint absolute_w = 0;
	GdkRectangle _tmp4_;
	gint absolute_h = 0;
	GdkRectangle _tmp5_;
	GdkPixbuf* final_image = NULL;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* result;
#line 358 "../src/widgets/CropWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 359 "../src/widgets/CropWidget.vala"
	_tmp0_ = self->priv->selection_rect;
#line 359 "../src/widgets/CropWidget.vala"
	_tmp1_ = self->priv->image_rect;
#line 359 "../src/widgets/CropWidget.vala"
	absolute_x = (gint) ((_tmp0_.x - _tmp1_.x) / self->priv->current_scale);
#line 360 "../src/widgets/CropWidget.vala"
	_tmp2_ = self->priv->selection_rect;
#line 360 "../src/widgets/CropWidget.vala"
	_tmp3_ = self->priv->image_rect;
#line 360 "../src/widgets/CropWidget.vala"
	absolute_y = (gint) ((_tmp2_.y - _tmp3_.y) / self->priv->current_scale);
#line 361 "../src/widgets/CropWidget.vala"
	_tmp4_ = self->priv->selection_rect;
#line 361 "../src/widgets/CropWidget.vala"
	absolute_w = (gint) (_tmp4_.width / self->priv->current_scale);
#line 362 "../src/widgets/CropWidget.vala"
	_tmp5_ = self->priv->selection_rect;
#line 362 "../src/widgets/CropWidget.vala"
	absolute_h = (gint) (_tmp5_.height / self->priv->current_scale);
#line 364 "../src/widgets/CropWidget.vala"
	_tmp6_ = self->priv->image;
#line 364 "../src/widgets/CropWidget.vala"
	_tmp7_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, gdk_pixbuf_get_has_alpha (_tmp6_), 8, absolute_w, absolute_h);
#line 364 "../src/widgets/CropWidget.vala"
	final_image = _tmp7_;
#line 370 "../src/widgets/CropWidget.vala"
	_tmp8_ = self->priv->image;
#line 370 "../src/widgets/CropWidget.vala"
	gdk_pixbuf_copy_area (_tmp8_, absolute_x, absolute_y, absolute_w, absolute_h, final_image, 0, 0);
#line 378 "../src/widgets/CropWidget.vala"
	result = final_image;
#line 378 "../src/widgets/CropWidget.vala"
	return result;
#line 1246 "CropWidget.c"
}

void
crop_widget_set_min_size (CropWidget* self,
                          gint min_width)
{
#line 381 "../src/widgets/CropWidget.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/widgets/CropWidget.vala"
	self->priv->min_width = min_width;
#line 1257 "CropWidget.c"
}

CropWidget*
crop_widget_construct (GType object_type)
{
	CropWidget * self = NULL;
#line 18 "../src/widgets/CropWidget.vala"
	self = (CropWidget*) g_object_new (object_type, NULL);
#line 18 "../src/widgets/CropWidget.vala"
	return self;
#line 1268 "CropWidget.c"
}

CropWidget*
crop_widget_new (void)
{
#line 18 "../src/widgets/CropWidget.vala"
	return crop_widget_construct (TYPE_CROP_WIDGET);
#line 1276 "CropWidget.c"
}

gdouble
crop_widget_get_desired_aspect_ratio (CropWidget* self)
{
	gdouble result;
#line 43 "../src/widgets/CropWidget.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 43 "../src/widgets/CropWidget.vala"
	result = self->priv->_desired_aspect_ratio;
#line 43 "../src/widgets/CropWidget.vala"
	return result;
#line 1289 "CropWidget.c"
}

void
crop_widget_set_desired_aspect_ratio (CropWidget* self,
                                      gdouble value)
{
	gdouble old_value;
#line 43 "../src/widgets/CropWidget.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/widgets/CropWidget.vala"
	old_value = crop_widget_get_desired_aspect_ratio (self);
#line 43 "../src/widgets/CropWidget.vala"
	if (old_value != value) {
#line 43 "../src/widgets/CropWidget.vala"
		self->priv->_desired_aspect_ratio = value;
#line 43 "../src/widgets/CropWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, crop_widget_properties[CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY]);
#line 1307 "CropWidget.c"
	}
}

static gboolean
_crop_widget_mouse_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                             GdkEventMotion* event,
                                                             gpointer self)
{
	gboolean result;
	result = crop_widget_mouse_motion_cb ((CropWidget*) self, event);
#line 52 "../src/widgets/CropWidget.vala"
	return result;
#line 1320 "CropWidget.c"
}

static void
_crop_widget_drag_gesture_begin_cb_gtk_gesture_drag_drag_begin (GtkGestureDrag* _sender,
                                                                gdouble start_x,
                                                                gdouble start_y,
                                                                gpointer self)
{
#line 64 "../src/widgets/CropWidget.vala"
	crop_widget_drag_gesture_begin_cb ((CropWidget*) self, _sender, start_x, start_y);
#line 1331 "CropWidget.c"
}

static void
_crop_widget_drag_gesture_end_cb_gtk_gesture_drag_drag_end (GtkGestureDrag* _sender,
                                                            gdouble offset_x,
                                                            gdouble offset_y,
                                                            gpointer self)
{
#line 65 "../src/widgets/CropWidget.vala"
	crop_widget_drag_gesture_end_cb ((CropWidget*) self, _sender, offset_x, offset_y);
#line 1342 "CropWidget.c"
}

static void
_crop_widget_drag_gesture_update_cb_gtk_gesture_drag_drag_update (GtkGestureDrag* _sender,
                                                                  gdouble offset_x,
                                                                  gdouble offset_y,
                                                                  gpointer self)
{
#line 66 "../src/widgets/CropWidget.vala"
	crop_widget_drag_gesture_update_cb ((CropWidget*) self, _sender, offset_x, offset_y);
#line 1353 "CropWidget.c"
}

static GObject *
crop_widget_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CropWidget * self;
	GdkDisplay* _tmp0_;
	GdkCursor* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkCursor* _tmp5_;
	GtkGestureDrag* _tmp6_;
	GtkGestureDrag* _tmp7_;
	GtkGestureDrag* _tmp8_;
	GtkGestureDrag* _tmp9_;
	GtkGestureDrag* _tmp10_;
#line 47 "../src/widgets/CropWidget.vala"
	parent_class = G_OBJECT_CLASS (crop_widget_parent_class);
#line 47 "../src/widgets/CropWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 47 "../src/widgets/CropWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CROP_WIDGET, CropWidget);
#line 48 "../src/widgets/CropWidget.vala"
	gtk_widget_set_events ((GtkWidget*) self, (((gtk_widget_get_events ((GtkWidget*) self) | GDK_POINTER_MOTION_MASK) | GDK_BUTTON1_MOTION_MASK) | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK);
#line 52 "../src/widgets/CropWidget.vala"
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _crop_widget_mouse_motion_cb_gtk_widget_motion_notify_event, self, 0);
#line 53 "../src/widgets/CropWidget.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 53 "../src/widgets/CropWidget.vala"
	_tmp1_ = gdk_cursor_new_for_display (_tmp0_, GDK_FLEUR);
#line 53 "../src/widgets/CropWidget.vala"
	_g_object_unref0 (self->priv->drag_cursor);
#line 53 "../src/widgets/CropWidget.vala"
	self->priv->drag_cursor = _tmp1_;
#line 55 "../src/widgets/CropWidget.vala"
	_tmp2_ = gtk_widget_get_display ((GtkWidget*) self);
#line 55 "../src/widgets/CropWidget.vala"
	_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_ARROW);
#line 55 "../src/widgets/CropWidget.vala"
	_g_object_unref0 (self->priv->default_cursor);
#line 55 "../src/widgets/CropWidget.vala"
	self->priv->default_cursor = _tmp3_;
#line 57 "../src/widgets/CropWidget.vala"
	_tmp4_ = gtk_widget_get_display ((GtkWidget*) self);
#line 57 "../src/widgets/CropWidget.vala"
	_tmp5_ = gdk_cursor_new_for_display (_tmp4_, GDK_BOTTOM_RIGHT_CORNER);
#line 57 "../src/widgets/CropWidget.vala"
	_g_object_unref0 (self->priv->resize_cursor);
#line 57 "../src/widgets/CropWidget.vala"
	self->priv->resize_cursor = _tmp5_;
#line 59 "../src/widgets/CropWidget.vala"
	memset (&self->priv->image_rect, 0, sizeof (GdkRectangle));
#line 60 "../src/widgets/CropWidget.vala"
	memset (&self->priv->selection_rect, 0, sizeof (GdkRectangle));
#line 62 "../src/widgets/CropWidget.vala"
	_tmp6_ = (GtkGestureDrag*) gtk_gesture_drag_new ((GtkWidget*) self);
#line 62 "../src/widgets/CropWidget.vala"
	_g_object_unref0 (self->priv->drag_gesture);
#line 62 "../src/widgets/CropWidget.vala"
	self->priv->drag_gesture = _tmp6_;
#line 63 "../src/widgets/CropWidget.vala"
	_tmp7_ = self->priv->drag_gesture;
#line 63 "../src/widgets/CropWidget.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp7_, (guint) GDK_BUTTON_PRIMARY);
#line 64 "../src/widgets/CropWidget.vala"
	_tmp8_ = self->priv->drag_gesture;
#line 64 "../src/widgets/CropWidget.vala"
	g_signal_connect_object (_tmp8_, "drag-begin", (GCallback) _crop_widget_drag_gesture_begin_cb_gtk_gesture_drag_drag_begin, self, 0);
#line 65 "../src/widgets/CropWidget.vala"
	_tmp9_ = self->priv->drag_gesture;
#line 65 "../src/widgets/CropWidget.vala"
	g_signal_connect_object (_tmp9_, "drag-end", (GCallback) _crop_widget_drag_gesture_end_cb_gtk_gesture_drag_drag_end, self, 0);
#line 66 "../src/widgets/CropWidget.vala"
	_tmp10_ = self->priv->drag_gesture;
#line 66 "../src/widgets/CropWidget.vala"
	g_signal_connect_object (_tmp10_, "drag-update", (GCallback) _crop_widget_drag_gesture_update_cb_gtk_gesture_drag_drag_update, self, 0);
#line 47 "../src/widgets/CropWidget.vala"
	return obj;
#line 1437 "CropWidget.c"
}

static void
crop_widget_class_init (CropWidgetClass * klass,
                        gpointer klass_data)
{
#line 18 "../src/widgets/CropWidget.vala"
	crop_widget_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/CropWidget.vala"
	g_type_class_adjust_private_offset (klass, &CropWidget_private_offset);
#line 18 "../src/widgets/CropWidget.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) crop_widget_real_draw;
#line 18 "../src/widgets/CropWidget.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) crop_widget_real_size_allocate;
#line 18 "../src/widgets/CropWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_crop_widget_get_property;
#line 18 "../src/widgets/CropWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_crop_widget_set_property;
#line 18 "../src/widgets/CropWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = crop_widget_constructor;
#line 18 "../src/widgets/CropWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = crop_widget_finalize;
#line 1460 "CropWidget.c"
	/**
	   * Ratio of the width to the height, i.e. (width/height)
	   * => values >1.0 for landscape pictures
	   */
#line 18 "../src/widgets/CropWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY, crop_widget_properties[CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY] = g_param_spec_double ("desired-aspect-ratio", "desired-aspect-ratio", "desired-aspect-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 0.8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1467 "CropWidget.c"
}

static void
crop_widget_instance_init (CropWidget * self,
                           gpointer klass)
{
#line 18 "../src/widgets/CropWidget.vala"
	self->priv = crop_widget_get_instance_private (self);
#line 28 "../src/widgets/CropWidget.vala"
	self->priv->selection_grabbed = FALSE;
#line 29 "../src/widgets/CropWidget.vala"
	self->priv->resize_area_grabbed = FALSE;
#line 30 "../src/widgets/CropWidget.vala"
	self->priv->drag_diff_x = 0;
#line 31 "../src/widgets/CropWidget.vala"
	self->priv->drag_diff_y = 0;
#line 32 "../src/widgets/CropWidget.vala"
	self->priv->resize_diff_x = 0;
#line 33 "../src/widgets/CropWidget.vala"
	self->priv->resize_diff_y = 0;
#line 34 "../src/widgets/CropWidget.vala"
	self->priv->resize_area_hovered = FALSE;
#line 35 "../src/widgets/CropWidget.vala"
	self->priv->current_scale = 1.0;
#line 36 "../src/widgets/CropWidget.vala"
	self->priv->min_width = CROP_WIDGET_MIN_SIZE;
#line 43 "../src/widgets/CropWidget.vala"
	self->priv->_desired_aspect_ratio = 0.8;
#line 1496 "CropWidget.c"
}

static void
crop_widget_finalize (GObject * obj)
{
	CropWidget * self;
#line 18 "../src/widgets/CropWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CROP_WIDGET, CropWidget);
#line 21 "../src/widgets/CropWidget.vala"
	_g_object_unref0 (self->priv->drag_gesture);
#line 22 "../src/widgets/CropWidget.vala"
	_g_object_unref0 (self->priv->image);
#line 25 "../src/widgets/CropWidget.vala"
	_g_object_unref0 (self->priv->drag_cursor);
#line 26 "../src/widgets/CropWidget.vala"
	_g_object_unref0 (self->priv->default_cursor);
#line 27 "../src/widgets/CropWidget.vala"
	_g_object_unref0 (self->priv->resize_cursor);
#line 18 "../src/widgets/CropWidget.vala"
	G_OBJECT_CLASS (crop_widget_parent_class)->finalize (obj);
#line 1517 "CropWidget.c"
}

static GType
crop_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CropWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) crop_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CropWidget), 0, (GInstanceInitFunc) crop_widget_instance_init, NULL };
	GType crop_widget_type_id;
	crop_widget_type_id = g_type_register_static (gtk_drawing_area_get_type (), "CropWidget", &g_define_type_info, 0);
	CropWidget_private_offset = g_type_add_instance_private (crop_widget_type_id, sizeof (CropWidgetPrivate));
	return crop_widget_type_id;
}

GType
crop_widget_get_type (void)
{
	static volatile gsize crop_widget_type_id__once = 0;
	if (g_once_init_enter (&crop_widget_type_id__once)) {
		GType crop_widget_type_id;
		crop_widget_type_id = crop_widget_get_type_once ();
		g_once_init_leave (&crop_widget_type_id__once, crop_widget_type_id);
	}
	return crop_widget_type_id__once;
}

static void
_vala_crop_widget_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	CropWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CROP_WIDGET, CropWidget);
#line 18 "../src/widgets/CropWidget.vala"
	switch (property_id) {
#line 18 "../src/widgets/CropWidget.vala"
		case CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY:
#line 18 "../src/widgets/CropWidget.vala"
		g_value_set_double (value, crop_widget_get_desired_aspect_ratio (self));
#line 18 "../src/widgets/CropWidget.vala"
		break;
#line 1558 "CropWidget.c"
		default:
#line 18 "../src/widgets/CropWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/CropWidget.vala"
		break;
#line 1564 "CropWidget.c"
	}
}

static void
_vala_crop_widget_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	CropWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CROP_WIDGET, CropWidget);
#line 18 "../src/widgets/CropWidget.vala"
	switch (property_id) {
#line 18 "../src/widgets/CropWidget.vala"
		case CROP_WIDGET_DESIRED_ASPECT_RATIO_PROPERTY:
#line 18 "../src/widgets/CropWidget.vala"
		crop_widget_set_desired_aspect_ratio (self, g_value_get_double (value));
#line 18 "../src/widgets/CropWidget.vala"
		break;
#line 1584 "CropWidget.c"
		default:
#line 18 "../src/widgets/CropWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/CropWidget.vala"
		break;
#line 1590 "CropWidget.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

