/* MediaDialog.c generated by valac 0.56.14, the Vala compiler
 * generated from MediaDialog.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include "CbMedia.h"
#include <glib.h>
#include <gdk/gdk.h>
#include "CbMediaDownloader.h"
#include <float.h>
#include <math.h>
#include "CbMediaVideoWidget.h"
#include "CbMediaImageWidget.h"
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include "cawbird.h"

#define TYPE_MEDIA_DIALOG (media_dialog_get_type ())
#define MEDIA_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_DIALOG, MediaDialog))
#define MEDIA_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_DIALOG, MediaDialogClass))
#define IS_MEDIA_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_DIALOG))
#define IS_MEDIA_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_DIALOG))
#define MEDIA_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_DIALOG, MediaDialogClass))

typedef struct _MediaDialog MediaDialog;
typedef struct _MediaDialogClass MediaDialogClass;
typedef struct _MediaDialogPrivate MediaDialogPrivate;
enum  {
	MEDIA_DIALOG_0_PROPERTY,
	MEDIA_DIALOG_NUM_PROPERTIES
};
static GParamSpec* media_dialog_properties[MEDIA_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MediaDialog {
	GtkWindow parent_instance;
	MediaDialogPrivate * priv;
};

struct _MediaDialogClass {
	GtkWindowClass parent_class;
};

struct _MediaDialogPrivate {
	GtkFrame* frame;
	GtkRevealer* next_revealer;
	GtkRevealer* previous_revealer;
	GtkRevealer* media_count_revealer;
	GtkLabel* media_count;
	CbMedia** media;
	gint media_length1;
	gint _media_size_;
	gint cur_index;
	GtkGestureMultiPress* button_gesture;
	GdkRectangle max_dimensions;
};

static gint MediaDialog_private_offset;
static gpointer media_dialog_parent_class = NULL;

VALA_EXTERN GType media_dialog_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MediaDialog* media_dialog_new (CbMedia** media,
                               gint media_length1,
                               gint start_media_index,
                               GdkRectangle* max_dimensions);
VALA_EXTERN MediaDialog* media_dialog_construct (GType object_type,
                                     CbMedia** media,
                                     gint media_length1,
                                     gint start_media_index,
                                     GdkRectangle* max_dimensions);
static void media_dialog_button_released_cb (MediaDialog* self,
                                      gint n_press,
                                      gdouble x,
                                      gdouble y);
static void _media_dialog_button_released_cb_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                        gint n_press,
                                                                        gdouble x,
                                                                        gdouble y,
                                                                        gpointer self);
static void media_dialog_change_media (MediaDialog* self,
                                gint new_index);
static void media_dialog_next_media (MediaDialog* self);
static void media_dialog_previous_media (MediaDialog* self);
static gboolean media_dialog_key_press_event_cb (MediaDialog* self,
                                          GdkEventKey* evt);
static gboolean _media_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                      GdkEventKey* event,
                                                                      gpointer self);
static void media_dialog_next_button_clicked_cb (MediaDialog* self);
static void _media_dialog_next_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void media_dialog_previous_button_clicked_cb (MediaDialog* self);
static void _media_dialog_previous_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static gboolean media_dialog_real_enter_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static gboolean media_dialog_real_leave_notify_event (GtkWidget* base,
                                               GdkEventCrossing* event);
static void media_dialog_finalize (GObject * obj);
static GType media_dialog_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
media_dialog_get_instance_private (MediaDialog* self)
{
	return G_STRUCT_MEMBER_P (self, MediaDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/window/MediaDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 141 "MediaDialog.c"
}

static void
_media_dialog_button_released_cb_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self)
{
#line 50 "../src/window/MediaDialog.vala"
	media_dialog_button_released_cb ((MediaDialog*) self, n_press, x, y);
#line 153 "MediaDialog.c"
}

MediaDialog*
media_dialog_construct (GType object_type,
                        CbMedia** media,
                        gint media_length1,
                        gint start_media_index,
                        GdkRectangle* max_dimensions)
{
	MediaDialog * self = NULL;
	CbMediaDownloader* downloader = NULL;
	CbMediaDownloader* _tmp0_;
	CbMediaDownloader* _tmp1_;
	GdkRectangle _tmp8_;
	GtkGestureMultiPress* _tmp9_;
	GtkGestureMultiPress* _tmp10_;
	GtkGestureMultiPress* _tmp11_;
	GtkGestureMultiPress* _tmp12_;
#line 35 "../src/window/MediaDialog.vala"
	g_return_val_if_fail (max_dimensions != NULL, NULL);
#line 35 "../src/window/MediaDialog.vala"
	self = (MediaDialog*) g_object_new (object_type, NULL);
#line 38 "../src/window/MediaDialog.vala"
	self->priv->media = media;
#line 38 "../src/window/MediaDialog.vala"
	self->priv->media_length1 = media_length1;
#line 38 "../src/window/MediaDialog.vala"
	self->priv->_media_size_ = self->priv->media_length1;
#line 39 "../src/window/MediaDialog.vala"
	_tmp0_ = cb_media_downloader_get_default ();
#line 39 "../src/window/MediaDialog.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 39 "../src/window/MediaDialog.vala"
	downloader = _tmp1_;
#line 188 "MediaDialog.c"
	{
		CbMedia** m_collection = NULL;
		gint m_collection_length1 = 0;
		gint _m_collection_size_ = 0;
		gint m_it = 0;
#line 40 "../src/window/MediaDialog.vala"
		m_collection = media;
#line 40 "../src/window/MediaDialog.vala"
		m_collection_length1 = media_length1;
#line 40 "../src/window/MediaDialog.vala"
		for (m_it = 0; m_it < m_collection_length1; m_it = m_it + 1) {
#line 200 "MediaDialog.c"
			CbMedia* _tmp2_;
			CbMedia* m = NULL;
#line 40 "../src/window/MediaDialog.vala"
			_tmp2_ = _g_object_ref0 (m_collection[m_it]);
#line 40 "../src/window/MediaDialog.vala"
			m = _tmp2_;
#line 207 "MediaDialog.c"
			{
				gboolean _tmp3_ = FALSE;
				CbMedia* _tmp4_;
#line 41 "../src/window/MediaDialog.vala"
				_tmp4_ = m;
#line 41 "../src/window/MediaDialog.vala"
				if (!_tmp4_->loaded_hires) {
#line 215 "MediaDialog.c"
					CbMedia* _tmp5_;
#line 41 "../src/window/MediaDialog.vala"
					_tmp5_ = m;
#line 41 "../src/window/MediaDialog.vala"
					_tmp3_ = !_tmp5_->loading_hires;
#line 221 "MediaDialog.c"
				} else {
#line 41 "../src/window/MediaDialog.vala"
					_tmp3_ = FALSE;
#line 225 "MediaDialog.c"
				}
#line 41 "../src/window/MediaDialog.vala"
				if (_tmp3_) {
#line 229 "MediaDialog.c"
					CbMediaDownloader* _tmp6_;
					CbMedia* _tmp7_;
#line 42 "../src/window/MediaDialog.vala"
					_tmp6_ = downloader;
#line 42 "../src/window/MediaDialog.vala"
					_tmp7_ = m;
#line 42 "../src/window/MediaDialog.vala"
					cb_media_downloader_load_hires_async (_tmp6_, _tmp7_, NULL, NULL);
#line 238 "MediaDialog.c"
				}
#line 40 "../src/window/MediaDialog.vala"
				_g_object_unref0 (m);
#line 242 "MediaDialog.c"
			}
		}
	}
#line 45 "../src/window/MediaDialog.vala"
	self->priv->cur_index = start_media_index;
#line 46 "../src/window/MediaDialog.vala"
	_tmp8_ = *max_dimensions;
#line 46 "../src/window/MediaDialog.vala"
	self->priv->max_dimensions = _tmp8_;
#line 47 "../src/window/MediaDialog.vala"
	_tmp9_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 47 "../src/window/MediaDialog.vala"
	_g_object_unref0 (self->priv->button_gesture);
#line 47 "../src/window/MediaDialog.vala"
	self->priv->button_gesture = _tmp9_;
#line 48 "../src/window/MediaDialog.vala"
	_tmp10_ = self->priv->button_gesture;
#line 48 "../src/window/MediaDialog.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp10_, (guint) 0);
#line 49 "../src/window/MediaDialog.vala"
	_tmp11_ = self->priv->button_gesture;
#line 49 "../src/window/MediaDialog.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp11_, GTK_PHASE_BUBBLE);
#line 50 "../src/window/MediaDialog.vala"
	_tmp12_ = self->priv->button_gesture;
#line 50 "../src/window/MediaDialog.vala"
	g_signal_connect_object (_tmp12_, "released", (GCallback) _media_dialog_button_released_cb_gtk_gesture_multi_press_released, self, 0);
#line 52 "../src/window/MediaDialog.vala"
	if (media_length1 == 1) {
#line 272 "MediaDialog.c"
		GtkRevealer* _tmp13_;
		GtkRevealer* _tmp14_;
		GtkRevealer* _tmp15_;
#line 53 "../src/window/MediaDialog.vala"
		_tmp13_ = self->priv->next_revealer;
#line 53 "../src/window/MediaDialog.vala"
		gtk_widget_hide ((GtkWidget*) _tmp13_);
#line 54 "../src/window/MediaDialog.vala"
		_tmp14_ = self->priv->previous_revealer;
#line 54 "../src/window/MediaDialog.vala"
		gtk_widget_hide ((GtkWidget*) _tmp14_);
#line 55 "../src/window/MediaDialog.vala"
		_tmp15_ = self->priv->media_count_revealer;
#line 55 "../src/window/MediaDialog.vala"
		gtk_widget_hide ((GtkWidget*) _tmp15_);
#line 288 "MediaDialog.c"
	}
#line 58 "../src/window/MediaDialog.vala"
	media_dialog_change_media (self, start_media_index);
#line 35 "../src/window/MediaDialog.vala"
	_g_object_unref0 (downloader);
#line 35 "../src/window/MediaDialog.vala"
	return self;
#line 296 "MediaDialog.c"
}

MediaDialog*
media_dialog_new (CbMedia** media,
                  gint media_length1,
                  gint start_media_index,
                  GdkRectangle* max_dimensions)
{
#line 35 "../src/window/MediaDialog.vala"
	return media_dialog_construct (TYPE_MEDIA_DIALOG, media, media_length1, start_media_index, max_dimensions);
#line 307 "MediaDialog.c"
}

static void
media_dialog_button_released_cb (MediaDialog* self,
                                 gint n_press,
                                 gdouble x,
                                 gdouble y)
{
	GtkGestureMultiPress* _tmp0_;
#line 61 "../src/window/MediaDialog.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/window/MediaDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 65 "../src/window/MediaDialog.vala"
	_tmp0_ = self->priv->button_gesture;
#line 65 "../src/window/MediaDialog.vala"
	gtk_gesture_set_state ((GtkGesture*) _tmp0_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 325 "MediaDialog.c"
}

static void
media_dialog_change_media (MediaDialog* self,
                           gint new_index)
{
	GtkWidget* cur_child = NULL;
	GtkFrame* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	gint cur_width = 0;
	gint cur_height = 0;
	gint new_width = 0;
	gint new_height = 0;
	GtkFrame* _tmp3_;
	GtkWidget* _tmp4_;
	CbMedia* media = NULL;
	CbMedia** _tmp10_;
	gint _tmp10__length1;
	CbMedia* _tmp11_;
	CbMedia* _tmp12_;
	GtkWidget* new_widget = NULL;
	CbMedia* _tmp13_;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp26_;
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	GtkLabel* _tmp32_;
	CbMedia** _tmp33_;
	gint _tmp33__length1;
	CbMedia** _tmp34_;
	gint _tmp34__length1;
	gchar* _tmp35_;
	gchar* _tmp36_;
#line 68 "../src/window/MediaDialog.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/window/MediaDialog.vala"
	_tmp0_ = self->priv->frame;
#line 70 "../src/window/MediaDialog.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 70 "../src/window/MediaDialog.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 70 "../src/window/MediaDialog.vala"
	cur_child = _tmp2_;
#line 71 "../src/window/MediaDialog.vala"
	cur_width = 0;
#line 71 "../src/window/MediaDialog.vala"
	cur_height = 0;
#line 75 "../src/window/MediaDialog.vala"
	_tmp3_ = self->priv->frame;
#line 75 "../src/window/MediaDialog.vala"
	_tmp4_ = gtk_bin_get_child ((GtkBin*) _tmp3_);
#line 75 "../src/window/MediaDialog.vala"
	if (_tmp4_ != NULL) {
#line 383 "MediaDialog.c"
		GtkFrame* _tmp5_;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
#line 76 "../src/window/MediaDialog.vala"
		_tmp5_ = self->priv->frame;
#line 76 "../src/window/MediaDialog.vala"
		_tmp6_ = cur_child;
#line 76 "../src/window/MediaDialog.vala"
		gtk_container_remove ((GtkContainer*) _tmp5_, _tmp6_);
#line 77 "../src/window/MediaDialog.vala"
		_tmp7_ = cur_child;
#line 77 "../src/window/MediaDialog.vala"
		gtk_widget_get_size_request (_tmp7_, &_tmp8_, &_tmp9_);
#line 77 "../src/window/MediaDialog.vala"
		cur_width = _tmp8_;
#line 77 "../src/window/MediaDialog.vala"
		cur_height = _tmp9_;
#line 403 "MediaDialog.c"
	}
#line 80 "../src/window/MediaDialog.vala"
	_tmp10_ = self->priv->media;
#line 80 "../src/window/MediaDialog.vala"
	_tmp10__length1 = self->priv->media_length1;
#line 80 "../src/window/MediaDialog.vala"
	_tmp11_ = _tmp10_[new_index];
#line 80 "../src/window/MediaDialog.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 80 "../src/window/MediaDialog.vala"
	media = _tmp12_;
#line 81 "../src/window/MediaDialog.vala"
	new_widget = NULL;
#line 82 "../src/window/MediaDialog.vala"
	_tmp13_ = media;
#line 82 "../src/window/MediaDialog.vala"
	if (cb_media_is_video (_tmp13_)) {
#line 421 "MediaDialog.c"
		CbMedia* _tmp14_;
		GdkRectangle _tmp15_;
		CbMediaVideoWidget* _tmp16_;
		GtkFrame* _tmp17_;
		GtkWidget* _tmp18_;
		GtkWidget* _tmp19_;
#line 83 "../src/window/MediaDialog.vala"
		_tmp14_ = media;
#line 83 "../src/window/MediaDialog.vala"
		_tmp15_ = self->priv->max_dimensions;
#line 83 "../src/window/MediaDialog.vala"
		_tmp16_ = cb_media_video_widget_new (_tmp14_, &_tmp15_);
#line 83 "../src/window/MediaDialog.vala"
		g_object_ref_sink (_tmp16_);
#line 83 "../src/window/MediaDialog.vala"
		_g_object_unref0 (new_widget);
#line 83 "../src/window/MediaDialog.vala"
		new_widget = (GtkWidget*) _tmp16_;
#line 84 "../src/window/MediaDialog.vala"
		_tmp17_ = self->priv->frame;
#line 84 "../src/window/MediaDialog.vala"
		_tmp18_ = new_widget;
#line 84 "../src/window/MediaDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp17_, _tmp18_);
#line 85 "../src/window/MediaDialog.vala"
		_tmp19_ = new_widget;
#line 85 "../src/window/MediaDialog.vala"
		cb_media_video_widget_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, CB_TYPE_MEDIA_VIDEO_WIDGET, CbMediaVideoWidget));
#line 450 "MediaDialog.c"
	} else {
		CbMedia* _tmp20_;
		GdkRectangle _tmp21_;
		CbMediaImageWidget* _tmp22_;
		GtkFrame* _tmp23_;
		GtkWidget* _tmp24_;
#line 87 "../src/window/MediaDialog.vala"
		_tmp20_ = media;
#line 87 "../src/window/MediaDialog.vala"
		_tmp21_ = self->priv->max_dimensions;
#line 87 "../src/window/MediaDialog.vala"
		_tmp22_ = cb_media_image_widget_new (_tmp20_, &_tmp21_);
#line 87 "../src/window/MediaDialog.vala"
		g_object_ref_sink (_tmp22_);
#line 87 "../src/window/MediaDialog.vala"
		_g_object_unref0 (new_widget);
#line 87 "../src/window/MediaDialog.vala"
		new_widget = (GtkWidget*) _tmp22_;
#line 88 "../src/window/MediaDialog.vala"
		_tmp23_ = self->priv->frame;
#line 88 "../src/window/MediaDialog.vala"
		_tmp24_ = new_widget;
#line 88 "../src/window/MediaDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp23_, _tmp24_);
#line 475 "MediaDialog.c"
	}
#line 91 "../src/window/MediaDialog.vala"
	_tmp25_ = new_widget;
#line 91 "../src/window/MediaDialog.vala"
	gtk_widget_show_all (_tmp25_);
#line 93 "../src/window/MediaDialog.vala"
	_tmp26_ = new_widget;
#line 93 "../src/window/MediaDialog.vala"
	gtk_widget_get_size_request (_tmp26_, &_tmp27_, &_tmp28_);
#line 93 "../src/window/MediaDialog.vala"
	new_width = _tmp27_;
#line 93 "../src/window/MediaDialog.vala"
	new_height = _tmp28_;
#line 94 "../src/window/MediaDialog.vala"
	if (new_width != cur_width) {
#line 94 "../src/window/MediaDialog.vala"
		_tmp31_ = TRUE;
#line 493 "MediaDialog.c"
	} else {
#line 95 "../src/window/MediaDialog.vala"
		_tmp31_ = new_height != cur_height;
#line 497 "MediaDialog.c"
	}
#line 94 "../src/window/MediaDialog.vala"
	if (_tmp31_) {
#line 95 "../src/window/MediaDialog.vala"
		_tmp30_ = new_width > 0;
#line 503 "MediaDialog.c"
	} else {
#line 94 "../src/window/MediaDialog.vala"
		_tmp30_ = FALSE;
#line 507 "MediaDialog.c"
	}
#line 94 "../src/window/MediaDialog.vala"
	if (_tmp30_) {
#line 95 "../src/window/MediaDialog.vala"
		_tmp29_ = new_height > 0;
#line 513 "MediaDialog.c"
	} else {
#line 94 "../src/window/MediaDialog.vala"
		_tmp29_ = FALSE;
#line 517 "MediaDialog.c"
	}
#line 94 "../src/window/MediaDialog.vala"
	if (_tmp29_) {
#line 96 "../src/window/MediaDialog.vala"
		gtk_window_resize ((GtkWindow*) self, new_width, new_height);
#line 523 "MediaDialog.c"
	}
#line 98 "../src/window/MediaDialog.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 100 "../src/window/MediaDialog.vala"
	self->priv->cur_index = new_index;
#line 103 "../src/window/MediaDialog.vala"
	_tmp32_ = self->priv->media_count;
#line 103 "../src/window/MediaDialog.vala"
	_tmp33_ = self->priv->media;
#line 103 "../src/window/MediaDialog.vala"
	_tmp33__length1 = self->priv->media_length1;
#line 103 "../src/window/MediaDialog.vala"
	_tmp34_ = self->priv->media;
#line 103 "../src/window/MediaDialog.vala"
	_tmp34__length1 = self->priv->media_length1;
#line 103 "../src/window/MediaDialog.vala"
	_tmp35_ = g_strdup_printf (ngettext ("Image %d of %d", "Image %d of %d", (gulong) _tmp33__length1), self->priv->cur_index + 1, _tmp34__length1);
#line 103 "../src/window/MediaDialog.vala"
	_tmp36_ = _tmp35_;
#line 103 "../src/window/MediaDialog.vala"
	gtk_label_set_text (_tmp32_, _tmp36_);
#line 103 "../src/window/MediaDialog.vala"
	_g_free0 (_tmp36_);
#line 68 "../src/window/MediaDialog.vala"
	_g_object_unref0 (new_widget);
#line 68 "../src/window/MediaDialog.vala"
	_g_object_unref0 (media);
#line 68 "../src/window/MediaDialog.vala"
	_g_object_unref0 (cur_child);
#line 553 "MediaDialog.c"
}

static void
media_dialog_next_media (MediaDialog* self)
{
	CbMedia** _tmp0_;
	gint _tmp0__length1;
#line 106 "../src/window/MediaDialog.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/window/MediaDialog.vala"
	_tmp0_ = self->priv->media;
#line 107 "../src/window/MediaDialog.vala"
	_tmp0__length1 = self->priv->media_length1;
#line 107 "../src/window/MediaDialog.vala"
	media_dialog_change_media (self, (self->priv->cur_index + 1) % _tmp0__length1);
#line 569 "MediaDialog.c"
}

static void
media_dialog_previous_media (MediaDialog* self)
{
	gint _tmp0_ = 0;
#line 110 "../src/window/MediaDialog.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/window/MediaDialog.vala"
	if (self->priv->cur_index != 0) {
#line 111 "../src/window/MediaDialog.vala"
		_tmp0_ = self->priv->cur_index - 1;
#line 582 "MediaDialog.c"
	} else {
		CbMedia** _tmp1_;
		gint _tmp1__length1;
#line 111 "../src/window/MediaDialog.vala"
		_tmp1_ = self->priv->media;
#line 111 "../src/window/MediaDialog.vala"
		_tmp1__length1 = self->priv->media_length1;
#line 111 "../src/window/MediaDialog.vala"
		_tmp0_ = _tmp1__length1 - 1;
#line 592 "MediaDialog.c"
	}
#line 111 "../src/window/MediaDialog.vala"
	media_dialog_change_media (self, _tmp0_);
#line 596 "MediaDialog.c"
}

static gboolean
media_dialog_key_press_event_cb (MediaDialog* self,
                                 GdkEventKey* evt)
{
	gboolean result;
#line 115 "../src/window/MediaDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 115 "../src/window/MediaDialog.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 116 "../src/window/MediaDialog.vala"
	if (evt->keyval == GDK_KEY_Left) {
#line 117 "../src/window/MediaDialog.vala"
		media_dialog_previous_media (self);
#line 612 "MediaDialog.c"
	} else {
#line 118 "../src/window/MediaDialog.vala"
		if (evt->keyval == GDK_KEY_Right) {
#line 119 "../src/window/MediaDialog.vala"
			media_dialog_next_media (self);
#line 618 "MediaDialog.c"
		} else {
#line 121 "../src/window/MediaDialog.vala"
			gtk_widget_destroy ((GtkWidget*) self);
#line 622 "MediaDialog.c"
		}
	}
#line 123 "../src/window/MediaDialog.vala"
	result = GDK_EVENT_PROPAGATE;
#line 123 "../src/window/MediaDialog.vala"
	return result;
#line 629 "MediaDialog.c"
}

static gboolean
_media_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                             GdkEventKey* event,
                                                             gpointer self)
{
	gboolean result;
	result = media_dialog_key_press_event_cb ((MediaDialog*) self, event);
#line 19 "../src/window/MediaDialog.vala"
	return result;
#line 641 "MediaDialog.c"
}

static void
media_dialog_next_button_clicked_cb (MediaDialog* self)
{
#line 127 "../src/window/MediaDialog.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/window/MediaDialog.vala"
	media_dialog_next_media (self);
#line 651 "MediaDialog.c"
}

static void
_media_dialog_next_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 19 "../src/window/MediaDialog.vala"
	media_dialog_next_button_clicked_cb ((MediaDialog*) self);
#line 660 "MediaDialog.c"
}

static void
media_dialog_previous_button_clicked_cb (MediaDialog* self)
{
#line 132 "../src/window/MediaDialog.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/window/MediaDialog.vala"
	media_dialog_previous_media (self);
#line 670 "MediaDialog.c"
}

static void
_media_dialog_previous_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
#line 19 "../src/window/MediaDialog.vala"
	media_dialog_previous_button_clicked_cb ((MediaDialog*) self);
#line 679 "MediaDialog.c"
}

static gboolean
media_dialog_real_enter_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	MediaDialog * self;
	gboolean _tmp0_ = FALSE;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gboolean result;
#line 136 "../src/window/MediaDialog.vala"
	self = (MediaDialog*) base;
#line 136 "../src/window/MediaDialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 137 "../src/window/MediaDialog.vala"
	_tmp1_ = event->window;
#line 137 "../src/window/MediaDialog.vala"
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
#line 137 "../src/window/MediaDialog.vala"
	if (_tmp1_ == _tmp2_) {
#line 138 "../src/window/MediaDialog.vala"
		_tmp0_ = event->detail != GDK_NOTIFY_INFERIOR;
#line 703 "MediaDialog.c"
	} else {
#line 137 "../src/window/MediaDialog.vala"
		_tmp0_ = FALSE;
#line 707 "MediaDialog.c"
	}
#line 137 "../src/window/MediaDialog.vala"
	if (_tmp0_) {
#line 711 "MediaDialog.c"
		GtkRevealer* _tmp3_;
		GtkRevealer* _tmp4_;
		GtkRevealer* _tmp5_;
#line 139 "../src/window/MediaDialog.vala"
		_tmp3_ = self->priv->next_revealer;
#line 139 "../src/window/MediaDialog.vala"
		gtk_revealer_set_reveal_child (_tmp3_, TRUE);
#line 140 "../src/window/MediaDialog.vala"
		_tmp4_ = self->priv->previous_revealer;
#line 140 "../src/window/MediaDialog.vala"
		gtk_revealer_set_reveal_child (_tmp4_, TRUE);
#line 141 "../src/window/MediaDialog.vala"
		_tmp5_ = self->priv->media_count_revealer;
#line 141 "../src/window/MediaDialog.vala"
		gtk_revealer_set_reveal_child (_tmp5_, TRUE);
#line 727 "MediaDialog.c"
	}
#line 144 "../src/window/MediaDialog.vala"
	result = FALSE;
#line 144 "../src/window/MediaDialog.vala"
	return result;
#line 733 "MediaDialog.c"
}

static gboolean
media_dialog_real_leave_notify_event (GtkWidget* base,
                                      GdkEventCrossing* event)
{
	MediaDialog * self;
	gboolean _tmp0_ = FALSE;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gboolean result;
#line 147 "../src/window/MediaDialog.vala"
	self = (MediaDialog*) base;
#line 147 "../src/window/MediaDialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 148 "../src/window/MediaDialog.vala"
	_tmp1_ = event->window;
#line 148 "../src/window/MediaDialog.vala"
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
#line 148 "../src/window/MediaDialog.vala"
	if (_tmp1_ == _tmp2_) {
#line 149 "../src/window/MediaDialog.vala"
		_tmp0_ = event->detail != GDK_NOTIFY_INFERIOR;
#line 757 "MediaDialog.c"
	} else {
#line 148 "../src/window/MediaDialog.vala"
		_tmp0_ = FALSE;
#line 761 "MediaDialog.c"
	}
#line 148 "../src/window/MediaDialog.vala"
	if (_tmp0_) {
#line 765 "MediaDialog.c"
		GtkRevealer* _tmp3_;
		GtkRevealer* _tmp4_;
		GtkRevealer* _tmp5_;
#line 150 "../src/window/MediaDialog.vala"
		_tmp3_ = self->priv->next_revealer;
#line 150 "../src/window/MediaDialog.vala"
		gtk_revealer_set_reveal_child (_tmp3_, FALSE);
#line 151 "../src/window/MediaDialog.vala"
		_tmp4_ = self->priv->previous_revealer;
#line 151 "../src/window/MediaDialog.vala"
		gtk_revealer_set_reveal_child (_tmp4_, FALSE);
#line 152 "../src/window/MediaDialog.vala"
		_tmp5_ = self->priv->media_count_revealer;
#line 152 "../src/window/MediaDialog.vala"
		gtk_revealer_set_reveal_child (_tmp5_, FALSE);
#line 781 "MediaDialog.c"
	}
#line 155 "../src/window/MediaDialog.vala"
	result = FALSE;
#line 155 "../src/window/MediaDialog.vala"
	return result;
#line 787 "MediaDialog.c"
}

static void
media_dialog_class_init (MediaDialogClass * klass,
                         gpointer klass_data)
{
#line 19 "../src/window/MediaDialog.vala"
	media_dialog_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/window/MediaDialog.vala"
	g_type_class_adjust_private_offset (klass, &MediaDialog_private_offset);
#line 19 "../src/window/MediaDialog.vala"
	((GtkWidgetClass *) klass)->enter_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) media_dialog_real_enter_notify_event;
#line 19 "../src/window/MediaDialog.vala"
	((GtkWidgetClass *) klass)->leave_notify_event = (gboolean (*) (GtkWidget*, GdkEventCrossing*)) media_dialog_real_leave_notify_event;
#line 19 "../src/window/MediaDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = media_dialog_finalize;
#line 19 "../src/window/MediaDialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/uk/co/ibboard/cawbird/ui/media-dialog.ui");
#line 19 "../src/window/MediaDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "frame", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, frame));
#line 19 "../src/window/MediaDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "next_revealer", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, next_revealer));
#line 19 "../src/window/MediaDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "previous_revealer", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, previous_revealer));
#line 19 "../src/window/MediaDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "media_count_revealer", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, media_count_revealer));
#line 19 "../src/window/MediaDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "media_count", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, media_count));
#line 19 "../src/window/MediaDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_event_cb", G_CALLBACK(_media_dialog_key_press_event_cb_gtk_widget_key_press_event));
#line 19 "../src/window/MediaDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "next_button_clicked_cb", G_CALLBACK(_media_dialog_next_button_clicked_cb_gtk_button_clicked));
#line 19 "../src/window/MediaDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "previous_button_clicked_cb", G_CALLBACK(_media_dialog_previous_button_clicked_cb_gtk_button_clicked));
#line 822 "MediaDialog.c"
}

static void
media_dialog_instance_init (MediaDialog * self,
                            gpointer klass)
{
#line 19 "../src/window/MediaDialog.vala"
	self->priv = media_dialog_get_instance_private (self);
#line 31 "../src/window/MediaDialog.vala"
	self->priv->cur_index = 0;
#line 19 "../src/window/MediaDialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 835 "MediaDialog.c"
}

static void
media_dialog_finalize (GObject * obj)
{
	MediaDialog * self;
#line 19 "../src/window/MediaDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_DIALOG, MediaDialog);
#line 32 "../src/window/MediaDialog.vala"
	_g_object_unref0 (self->priv->button_gesture);
#line 19 "../src/window/MediaDialog.vala"
	G_OBJECT_CLASS (media_dialog_parent_class)->finalize (obj);
#line 848 "MediaDialog.c"
}

static GType
media_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MediaDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaDialog), 0, (GInstanceInitFunc) media_dialog_instance_init, NULL };
	GType media_dialog_type_id;
	media_dialog_type_id = g_type_register_static (gtk_window_get_type (), "MediaDialog", &g_define_type_info, 0);
	MediaDialog_private_offset = g_type_add_instance_private (media_dialog_type_id, sizeof (MediaDialogPrivate));
	return media_dialog_type_id;
}

GType
media_dialog_get_type (void)
{
	static volatile gsize media_dialog_type_id__once = 0;
	if (g_once_init_enter (&media_dialog_type_id__once)) {
		GType media_dialog_type_id;
		media_dialog_type_id = media_dialog_get_type_once ();
		g_once_init_leave (&media_dialog_type_id__once, media_dialog_type_id);
	}
	return media_dialog_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

